      subroutine cmp2II(ic)
c
c     contracts the integrals a=(ij||kl) in the buffer with
C     all active MO coeff; MO intgrs (ab|cd) are saved in MPDISK.SCR
c
c     ic ... control variable
c     ic=0 ... contract all
c     ic=1 ... contract iiii
c     ic=2 ... contract iiij
c     ic=3 ... contract iijj
c     ic=4 ... contract ijij
c     ic=5 ... contract ijkk
c     ic=6 ... contract ikjk
c     ic=7 ... contract ijkl
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nbuff=400,nort=700,nat0=190,nor=80)
      character*2 at
      character*1 ty,ok
      parameter (noo0=30,noo1=(noo0*(noo0+1))/2,
     1noo5=(noo1*(noo1+1))/2)
      dimension Aabcd(noo5)
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/intbuff/aiiii(nbuff),aiiij(nbuff),aiijj(nbuff),
     1aijkk(nbuff),aijij(nbuff),aikjk(nbuff),aijkl(nbuff),
     2iiiii(nbuff),iiiij(nbuff),jiiij(nbuff),iiijj(nbuff),jiijj(nbuff),
     3iijkk(nbuff),jijkk(nbuff),kijkk(nbuff),iijij(nbuff),jijij(nbuff),
     4iikjk(nbuff),jikjk(nbuff),kikjk(nbuff),iijkl(nbuff),jijkl(nbuff),
     5kijkl(nbuff),lijkl(nbuff),ideij(nbuff),
     6niiii,niiij,niijj,nijkk,nijij,nikjk,nijkl
      logical lone,lci,lopt
      common/iopts/iopt(300)
      equivalence
     1(iopt(8),nstart),(iopt(9),nend)
      dimension cti(nort),ctj(nort),ctk(nort),ctl(nort)
      common/opts/lopt(300),icha,n1
      equivalence (lci,lopt(59))
c
      ks=nstart
      je=nend
      if(lci)then
       ks=1
       je=nmo
      endif
      noom=je-ks+1
      lone=ic.ne.0
c     total # of (abcd) MO integrals
      nt1=noom*(noom+1)/2
      ntotal=nt1*(nt1+1)/2
      nrwd=0
      ibstart=1
      rewind 45
8888  ibend=ibstart+noo5-1
      if(ibend.gt.ntotal)ibend=ntotal
      nnn=ibend-ibstart+1
c
c     load a batch of MO integrals (ab|cd) from disk
      read(45)(Aabcd(i),i=1,nnn),is1,js1,ks1,ls1
      nrwd=nrwd+1
c
c     contract the batch with Ao buffer:
c
      goto(10,20,30,40,50,60,70)ic
c
c     iiii
10    do 10001 ib=1,niiii
      b=aiiii(ib)
      ii=iiiii(ib)
      kk=0
      do 12005 i=is1 ,je
      c1=cij(i,ii)*b
      do 12005 j=js1,i
      c2=cij(j,ii)*c1
      do 12005 k=ks1,i
      c3=cij(k,ii)*c2
      lend=k
      if(k.eq.i)lend=j
      do 12005 l=ls1,lend
      kk=kk+1
      if(kk.gt.nnn)goto 10001
12005 Aabcd(kk)=Aabcd(kk)+cij(l,ii)*c3
10001 continue
      if(lone)goto 99999
c
c     iiij=iiji=ijii=jiii
20    do 20001 ib=1,niiij
      ii=iiiij(ib)
      jj=jiiij(ib)
      b=aiiij(ib)
      kk=0
      do 22005 i=is1,je
      cii =cij(i,ii)*b
      ccij=cij(i,jj)*b
      do 22005 j=js1,i
      cii_ji=cii*cij(j,ii)
      cii_jj=cii*cij(j,jj)
      cij_ji=ccij*cij(j,ii)
      do 22005 k=ks1,i
      cij_ji_ki=cij_ji*cij(k,ii)
      cii_jj_ki=cii_jj*cij(k,ii)
      cii_ji_kj=cii_ji*cij(k,jj)
      cii_ji_ki=cii_ji*cij(k,ii)
      lend=k
      if(k.eq.i)lend=j
      do 22005 l=ls1,lend
      kk=kk+1
      if(kk.gt.nnn)goto 20001
22005 Aabcd(kk)=Aabcd(kk)
     1+cii_ji_ki*cij(l,jj)+(cii_ji_kj+cii_jj_ki+cij_ji_ki)*cij(l,ii)
20001 continue
      if(lone)goto 99999
c
c     iijj = jjii
30    do 30001 ib=1,niijj
      ii=iiijj(ib)
      jj=jiijj(ib)
      b=aiijj(ib)
      kk=0
      do 32005 i=is1,je
      wi=cij(i,ii)*b
      wj=cij(i,jj)*b
      do 32005 j=js1,i
      wii=wi*cij(j,ii)
      wjj=wj*cij(j,jj)
      do 32005 k=ks1,i
      wiij=wii*cij(k,jj)
      wjji=wjj*cij(k,ii)
      lend=k
      if(k.eq.i)lend=j
      do 32005 l=ls1,lend
      kk=kk+1
      if(kk.gt.nnn)goto 30001
32005 Aabcd(kk)=Aabcd(kk)+wiij*cij(l,jj)+wjji*cij(l,ii)
30001 continue
      if(lone)goto 99999
c
c     ijij=jiji=jiij=ijji
40    do 40001 ib=1,nijij
      ii=iijij(ib)
      jj=jijij(ib)
      b =aijij(ib)
      kk=0
      do 42005 i=is1,je
      wi=cij(i,ii)*b
      wj=cij(i,jj)*b
      do 42005 j=js1,i
      wij=wi*cij(j,jj)
      wji=wj*cij(j,ii)
      do 42005 k=ks1,i
      wiji=wij*cij(k,ii)
      wijj=wij*cij(k,jj)
      wjii=wji*cij(k,ii)
      wjij=wji*cij(k,jj)
      lend=k
      if(k.eq.i)lend=j
      do 42005 l=ls1,lend
      kk=kk+1
      if(kk.gt.nnn)goto 40001
42005 Aabcd(kk)=Aabcd(kk)+(wiji+wjii)*cij(l,jj)+(wijj+wjij)*cij(l,ii)
40001 continue
      if(lone)goto 99999
c
c     ijkk=jikk=kkji=kkij
50    do 50001 ib=1,nijkk
      b=aijkk(ib)
      ii=iijkk(ib)
      jj=jijkk(ib)
      kk=kijkk(ib)
      i2=0
      do 52005 i=is1,je
      cii =cij(i,ii)*b
      ccij=cij(i,jj)*b
      cik =cij(i,kk)*b
      do 52005 j=js1,i
      cii_jjcij_ji=cii *cij(j,jj)+ccij*cij(j,ii)
      cik_jk=cik *cij(j,kk)
      do 52005 k=ks1,i
      cijkcjik=cii_jjcij_ji*cij(k,kk)
      ckki=cik_jk*cij(k,ii)
      ckkj=cik_jk*cij(k,jj)
      lend=k
      if(k.eq.i)lend=j
      if(i2+lend-ls1+1.gt.nnn)lend=ls1+nnn-i2-1
      do 52015 l=ls1,lend
      i2=i2+1
52015 Aabcd(i2)=Aabcd(i2)+cijkcjik*cij(l,kk)
     1        +ckki*cij(l,jj)+ckkj*cij(l,ii)
52005 if(i2.eq.nnn)goto 50001
50001 continue
      if(lone)goto 99999
c
c     ikjk=ikkj=kikj=kijk=jkik=jkki=kjik=kjki
60    do 60001 ib=1,nikjk
      b =aikjk(ib)
      ii=iikjk(ib)
      jj=jikjk(ib)
      kk=kikjk(ib)
      i2=0
      do 62005 i=is1,je
      cii=cij(i,ii)*b
      ccij=cij(i,jj)*b
      cik=cij(i,kk)*b
      do 62005 j=js1,i
      cii_jkcik_ji=cii*cij(j,kk)+cik*cij(j,ii)
      cik_jjcij_jk=ccij*cij(j,kk)+cik*cij(j,jj)
      do 62005 k=ks1,i
      c4=cii_jkcik_ji*cij(k,jj)+cik_jjcij_jk*cij(k,ii)
      cikkckik=cii_jkcik_ji*cij(k,kk)
      ckjkcjkk=cik_jjcij_jk*cij(k,kk)
      lend=k
      if(k.eq.i)lend=j
      if(i2+lend-ls1+1.gt.nnn)lend=ls1+nnn-i2-1
      do 62015 l=ls1,lend
      i2=i2+1
62015 Aabcd(i2)=Aabcd(i2)+c4*cij(l,kk)
     1                   +cikkckik*cij(l,jj)
     1                   +ckjkcjkk*cij(l,ii)
62005 if(i2.eq.nnn)goto 60001
60001 continue
      if(lone)goto 99999
c
c     ijkl=ijlk=jikl=jilk=klij=klji=lkij=lkji
70    do 70001 ib=1,nijkl
      b =aijkl(ib)
      ii=iijkl(ib)
      jj=jijkl(ib)
      kk=kijkl(ib)
      ll=lijkl(ib)
c     temporary buffer for MO coeffs
      do 71003 kmo=ks,je
      cti(kmo)=cij(kmo,ii)
      ctj(kmo)=cij(kmo,jj)
      ctk(kmo)=cij(kmo,kk)
71003 ctl(kmo)=cij(kmo,ll)
      i2=0
      do 72005 i=is1,je
      ci=cti(i)*b
      cj=ctj(i)*b
      ck=ctk(i)*b
      cl=ctl(i)*b
      do 72005 j=js1,i
      cijcji=ci*ctj(j)+cj*cti(j)
      cklclk=ck*ctl(j)+cl*ctk(j)
      do 72005 k=ks1,i
      cijkcjik=cijcji*ctk(k)
      cijlcjil=cijcji*ctl(k)
      ckliclki=cklclk*cti(k)
      ckljclkj=cklclk*ctj(k)
      lend=k
      if(k.eq.i)lend=j
      if(i2+lend-ls1+1.gt.nnn)lend=ls1+nnn-i2-1
      do 72015 l=ls1,lend
      i2=i2+1
72015 Aabcd(i2)=Aabcd(i2)+cijkcjik*ctl(l)+cijlcjil*ctk(l)
     1                   +ckliclki*ctj(l)+ckljclkj*cti(l)
72005 if(i2.eq.nnn)goto 70001
70001 continue
c
99999 rewind 45
      do 200 i=1,nrwd-1
200   read(45)
      write(45)(Aabcd(i),i=1,nnn),is1,js1,ks1,ls1
      if(ibend.lt.ntotal)then
       ibstart=ibend+1
       goto 8888
      endif
c
      return
c
      end
c     ============================================================
