      subroutine cnknj(b,i,j,k,l)
c
c     contracts the integral a=(ij||kl) with the (JJKK) (JKJK) integrals
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nort=700,nat0=190,nor=80,nkkjj0=nort*(nort+1))
      character*2 at
      character*1 ty,ok
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      logical lnknj
      common/kkjj/ckkjj(nkkjj0),enknj(nort),lnknj
      common/iopts/iopt(300)
      equivalence (iopt(23),nk),(iopt(24),nj)
      dimension cijt(nort),cikt(nort),cilt(nort),
     1          cjkt(nort),cjlt(nort),cklt(nort),
     1          ckkt(nort)
      common/densitymatrices/palpha(nort*nort),pbeta(nort*nort),e_c,e_x
c
      ic=-1
c
c     sort the case
c
      if(i.eq.j)then
c II
       if(k.eq.j)then
c IIi
        if(l.eq.k)then
c IIII
         ii=i
         goto 10
        else
c IIIJ
         ii=i
         jj=l
         goto 20
        endif
       else
c IIj
        if(l.eq.i)then
c IIJI -> iiij
         ii=i
         jj=k
         goto 20
        else
         if(l.eq.k)then
c IIJJ
          ii=i
          jj=k
          goto 30
         else
c IIJK -> ijkk
          ii=k
          jj=l
          kk=i
          goto 50
         endif
        endif
       endif

      else

C IJ
       if(k.eq.i)then
c IJi
        if(l.eq.i)then
c IJII -> iiij
         ii=i
         jj=j
         goto 20
        else
         if(l.eq.j)then
c IJIJ
          ii=i
          jj=j
          goto 40
         else
c IJIK -> ikjk
          ii=l
          jj=j
          kk=i
          goto 60
         endif
        endif
       else
        if(k.eq.j)then
c IJj
         if(l.eq.i)then
c IJJI (=ijij)
          ii=i
          jj=j
          goto 40
         else
          if(l.eq.j)then
c IJJJ -> iiij
           ii=j
           jj=i
           goto 20
          else
c IJJK -> ikjk
           ii=i
           jj=l
           kk=j
           goto 60
          endif
         endif
        else
c IJk
         if(l.eq.i)then
c IJKI -> ikjk
          ii=k
          jj=j
          kk=i
          goto 60
         else
          if(l.eq.j)then
c IJKJ -> ikjk
           ii=i
           jj=k
           kk=j
           goto 60
          else
           if(l.eq.k)then
c IJKK
            ii=i
            jj=j
            kk=k
            goto 50
           else
c IJKL
            goto 70
           endif
          endif
         endif
        endif
       endif
      endif
c
c     iiii
10    it=nao*(ii-1)
      do 10001 kmo=nk,nj
      ccki=cij(kmo,ii)**2*b
      enknj(kmo-nk+1)=enknj(kmo-nk+1)+palpha(ii+it)*ccki
      do 10001 jmo=nk,kmo
      ic=ic+2
      ccji=cij(jmo,ii)**2*ccki
      ckkjj(ic  )=ckkjj(ic  )+ccji
10001 ckkjj(ic+1)=ckkjj(ic+1)+ccji
      return
c
c     iiij
20    a2=b+b
      it=nao*(ii-1)
      do 20001 kmo=nk,nj
      cckii=cij(kmo,ii)**2*a2
      cckij=cij(kmo,ii)*cij(kmo,jj)*a2
      enknj(kmo-nk+1)=enknj(kmo-nk+1)
     1  +palpha(ii+it)*cckij+palpha(jj+it)*cckii
      do 20001 jmo=nk,kmo
      ic=ic+2
      s1=(cckii*cij(jmo,jj)+cckij*cij(jmo,ii))*cij(jmo,ii)
c     iiij iiji ijii jiii
      ckkjj(ic  )=ckkjj(ic  )+s1
20001 ckkjj(ic+1)=ckkjj(ic+1)+s1
      return
c
c     iijj
30    a2=b+b
      it=nao*(ii-1)
      jt=nao*(jj-1)
      do 30001 kmo=nk,nj
      ccki2=cij(kmo,ii)*cij(kmo,ii)*b
      cckj2=cij(kmo,jj)*cij(kmo,jj)*b
      cckij=cij(kmo,ii)*cij(kmo,jj)*a2
      enknj(kmo-nk+1)=enknj(kmo-nk+1)
     1+a2*(palpha(ii+it)*cij(kmo,jj)*cij(kmo,jj)
     1    +palpha(jj+jt)*cij(kmo,ii)*cij(kmo,ii)
     1    -palpha(ii+jt)*cij(kmo,jj)*cij(kmo,ii))
      do 30001 jmo=nk,kmo
      ic=ic+2
      ccji=cij(jmo,ii)
      ccjj=cij(jmo,jj)
      ckkjj(ic  )=ckkjj(ic  )+ ccki2*ccjj*ccjj+cckj2*ccji*ccji
30001 ckkjj(ic+1)=ckkjj(ic+1)+ cckij*ccji*ccjj
      return
c
c     ijij
40    a2=b+b
      a4=a2+a2
      a6=a4+a2
      jt=nao*(jj-1)
      it=nao*(ii-1)
      do 40001 kmo=nk,nj
      cckij =cij(kmo,ii)*cij(kmo,jj)*a4
      cckija=cij(kmo,ii)*cij(kmo,jj)*a2
      ccki2 =cij(kmo,ii)*cij(kmo,ii)*b
      cckj2 =cij(kmo,jj)*cij(kmo,jj)*b
      enknj(kmo-nk+1)=enknj(kmo-nk+1)
     1+a6*palpha(ii+jt)*cij(kmo,ii)*cij(kmo,jj)
     1-b *palpha(jj+jt)*cij(kmo,ii)*cij(kmo,ii)
     1-b *palpha(ii+it)*cij(kmo,jj)*cij(kmo,jj)
      do 40001 jmo=nk,kmo
      ic=ic+2
      ccji=cij(jmo,ii)
      ccjj=cij(jmo,jj)
      c2=ccji*ccjj
c     ijij ijji jiji jiij
      ckkjj(ic  )=ckkjj(ic  )+cckij*c2
40001 ckkjj(ic+1)=ckkjj(ic+1)+ccki2* ccjj*ccjj+
     1                        cckija*c2+
     1                        cckj2* ccji*ccji
      return
c
c     ijkk
50    a2=b+b
      a4=a2+a2
      jt=nao*(jj-1)
      kt=nao*(kk-1)
      do 50001 kmo=nk,nj
      s1=cij(kmo,ii)*cij(kmo,jj)*a2
      s2=cij(kmo,kk)*cij(kmo,kk)*a2
      s3=cij(kmo,ii)*cij(kmo,kk)*a2
      s4=cij(kmo,jj)*cij(kmo,kk)*a2
      enknj(kmo-nk+1)=enknj(kmo-nk+1)
     1+a4*(palpha(ii+jt)*cij(kmo,kk)*cij(kmo,kk)+
     1     palpha(kk+kt)*cij(kmo,ii)*cij(kmo,jj))
     1-a2*(palpha(ii+kt)*cij(kmo,jj)*cij(kmo,kk)+
     1     palpha(jj+kt)*cij(kmo,ii)*cij(kmo,kk))
      do 50001 jmo=nk,kmo
      ic=ic+2
      ckkjj(ic  )=ckkjj(ic  )
     1 +s1*cij(jmo,kk)**2+s2*cij(jmo,jj)*cij(jmo,ii)
50001 ckkjj(ic+1)=ckkjj(ic+1)
     1 +(s3*cij(jmo,jj)+s4*cij(jmo,ii))*cij(jmo,kk)
      return
c
c     ikjk
60    a2=b+b
      a4=a2+a2
      a6=a4+a2
      it=nao*(ii-1)
      jt=nao*(jj-1)
      kt=nao*(kk-1)
      do 60003 kmo=nk,nj
      cti=cij(kmo,ii)
      ctj=cij(kmo,jj)
      ctk=cij(kmo,kk)
      cijt(kmo)=cti*ctj
      cikt(kmo)=cti*ctk
      cjkt(kmo)=ctj*ctk
      ckkt(kmo)=ctk*ctk
60003 continue
      do 60001 kmo=nk,nj
      s1=cjkt(kmo)*a4
      s2=cikt(kmo)*a4
      s11=a2*ckkt(kmo)
      s22=a2*cjkt(kmo)
      s33=a2*cijt(kmo)
      s44=a2*cikt(kmo)
      enknj(kmo-nk+1)=enknj(kmo-nk+1)
     1+a6*(palpha(ii+kt)*cjkt(kmo)+palpha(jj+kt)*cikt(kmo))
     1-a2*(palpha(ii+jt)*ckkt(kmo)+palpha(kk+kt)*cijt(kmo))
      do 60001 jmo=nk,kmo
      ic=ic+2
      ckkjj(ic  )=ckkjj(ic  )+ s1*cikt(jmo)+s2*cjkt(jmo)
60001 ckkjj(ic+1)=ckkjj(ic+1)+ s11*cijt(jmo)+s22*cikt(jmo)+
     2                         s33*ckkt(jmo)+s44*cjkt(jmo)
      return
c
c     ijkl
70    a2=b+b
      a4=a2+a2
      a8=a4+a4
      it=nao*(i-1)
      jt=nao*(j-1)
      kt=nao*(k-1)
      lt=nao*(l-1)
      do 70003 kmo=nk,nj
      cti=cij(kmo,i)
      ctj=cij(kmo,j)
      ctk=cij(kmo,k)
      ctl=cij(kmo,l)
      cijt(kmo)=cti*ctj
      cikt(kmo)=cti*ctk
      cilt(kmo)=cti*ctl
      cjkt(kmo)=ctj*ctk
      cjlt(kmo)=ctj*ctl
70003 cklt(kmo)=ctk*ctl
      do 70001 kmo=nk,nj
      s1=cijt(kmo)*a4
      s2=cklt(kmo)*a4
      ss1=cikt(kmo)*a2
      ss2=cilt(kmo)*a2
      ss3=cjkt(kmo)*a2
      ss4=cjlt(kmo)*a2
      enknj(kmo-nk+1)=enknj(kmo-nk+1)
     1+a8*(palpha(i+jt)*cklt(kmo)+palpha(k+lt)*cijt(kmo))
     1-a2*(palpha(i+kt)*cjlt(kmo)+palpha(i+lt)*cjkt(kmo)+
     1     palpha(j+lt)*cikt(kmo)+palpha(j+kt)*cilt(kmo))
      do 70001 jmo=nk,kmo
      ic=ic+2
      ckkjj(ic  )=ckkjj(ic  )+s1*cklt(jmo)+s2*cijt(jmo)
70001 ckkjj(ic+1)=ckkjj(ic+1)+ss1*cjlt(jmo)+ss2*cjkt(jmo)+
     1                        ss3*cilt(jmo)+ss4*cikt(jmo)
      return
      end
