      subroutine contra3(a,i,j,k,l)
c
c     contracts the integral a=(ij||kl) with the MO coeff
c     for ALL i,j,k,l (in contrary to old contract):
c     iiii
c     jjji
c     iiij
c     iijj                i<>j,k<>i,k<>j,l<>i,l<>j,l<>k
c     ijij
c6    ijkk
c7    ikjk
c8    ijkl
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nbuff=400,nort=700)
      common/intbuff/aiiii(nbuff),aiiij(nbuff),aiijj(nbuff),
     1  aijkk(nbuff),aijij(nbuff),aikjk(nbuff),aijkl(nbuff),
     2iiiii(nbuff),iiiij(nbuff),jiiij(nbuff),iiijj(nbuff),jiijj(nbuff),
     3iijkk(nbuff),jijkk(nbuff),kijkk(nbuff),iijij(nbuff),jijij(nbuff),
     4iikjk(nbuff),jikjk(nbuff),kikjk(nbuff),iijkl(nbuff),jijkl(nbuff),
     5kijkl(nbuff),lijkl(nbuff),ideij(nbuff),
     6niiii,niiij,niijj,nijkk,nijij,nikjk,nijkl
c
c
c     sort the case
c
      if(i.eq.j)then
c II
       if(k.eq.j)then
c IIi
        if(l.eq.k)then
c IIII
         do i8=niiii,1,-1
          if(iiiii(i8).eq.i)then
           aiiii(i8)=aiiii(i8)+a
           return
          endif
         enddo
         niiii=niiii+1
         iiiii(niiii)=i
         aiiii(niiii)=a
         if(niiii.eq.nbuff)call contrxx(1)
        else
c IIIJ
         do i8=niiij,1,-1
          if(iiiij(i8).eq.i.and.jiiij(i8).eq.l)then
           aiiij(i8)=aiiij(i8)+a
           return
          endif
         enddo
         niiij=niiij+1
         iiiij(niiij)=i
         jiiij(niiij)=l
         aiiij(niiij)=a
         if(niiij.eq.nbuff)call contrxx(2)
        endif
       else
c IIj
        if(l.eq.i)then
c IIJI -> iiij
         do i8=niiij,1,-1
          if(iiiij(i8).eq.i.and.jiiij(i8).eq.k)then
           aiiij(i8)=aiiij(i8)+a
           return
          endif
         enddo
         niiij=niiij+1
         iiiij(niiij)=i
         jiiij(niiij)=k
         aiiij(niiij)=a
         if(niiij.eq.nbuff)call contrxx(2)
        else
         if(l.eq.k)then
c IIJJ
          do i8=niijj,1,-1
           if(iiijj(i8).eq.i.and.jiijj(i8).eq.k)then
            aiijj(i8)=aiijj(i8)+a
            return
           endif
          enddo
          niijj=niijj+1
          iiijj(niijj)=i
          jiijj(niijj)=k
          aiijj(niijj)=a
          if(niijj.eq.nbuff)call contrxx(3)
         else
c IIJK -> ijkk
          do 601 i8=nijkk,1,-1
          if(iijkk(i8).eq.k.and.jijkk(i8).eq.l.and.kijkk(i8).eq.i)then
           aijkk(i8)=aijkk(i8)+a
           return
          endif
601       continue
          nijkk=nijkk+1
          iijkk(nijkk)=k
          jijkk(nijkk)=l
          kijkk(nijkk)=i
          aijkk(nijkk)=a
          if(nijkk.eq.nbuff)call contrxx(5)
         endif
        endif
       endif

      else

C IJ
       if(k.eq.i)then
c IJi
        if(l.eq.i)then
c IJII -> iiij
         do i8=niiij,1,-1
          if(iiiij(i8).eq.i.and.jiiij(i8).eq.j)then
           aiiij(i8)=aiiij(i8)+a
           return
          endif
         enddo
         niiij=niiij+1
         iiiij(niiij)=i
         jiiij(niiij)=j
         aiiij(niiij)=a
         if(niiij.eq.nbuff)call contrxx(2)
        else
         if(l.eq.j)then
c IJIJ
          do i8=nijij,1,-1
           if(iijij(i8).eq.i.and.jijij(i8).eq.j)then
            aijij(i8)=aijij(i8)+a
            return
           endif
          enddo
          nijij=nijij+1
          iijij(nijij)=i
          jijij(nijij)=j
          aijij(nijij)=a
          if(nijij.eq.nbuff)call contrxx(4)
         else
c IJIK -> ikjk
          do 704 i8=nikjk,1,-1
          if(iikjk(i8).eq.l.and.jikjk(i8).eq.j.and.kikjk(i8).eq.i)then
           aikjk(i8)=aikjk(i8)+a
           return
          endif
704       continue
          nikjk=nikjk+1
          iikjk(nikjk)=l
          jikjk(nikjk)=j
          kikjk(nikjk)=i
          aikjk(nikjk)=a
          if(nikjk.eq.nbuff)call contrxx(6)
         endif
        endif
       else
        if(k.eq.j)then
c IJj
         if(l.eq.i)then
c IJJI (=ijij)
          do i8=nijij,1,-1
           if(iijij(i8).eq.i.and.jijij(i8).eq.j)then
            aijij(i8)=aijij(i8)+a
            return
           endif
          enddo
          nijij=nijij+1
          iijij(nijij)=i
          jijij(nijij)=j
          aijij(nijij)=a
          if(nijij.eq.nbuff)call contrxx(4)
         else
          if(l.eq.j)then
c IJJJ -> iiij
           do i8=niiij,1,-1
            if(iiiij(i8).eq.j.and.jiiij(i8).eq.i)then
             aiiij(i8)=aiiij(i8)+a
             return
            endif
           enddo
           niiij=niiij+1
           iiiij(niiij)=j
           jiiij(niiij)=i
           aiiij(niiij)=a
           if(niiij.eq.nbuff)call contrxx(2)
          else
c IJJK -> ikjk
           do 703 i8=nikjk,1,-1
           if(iikjk(i8).eq.i.and.jikjk(i8).eq.l.and.kikjk(i8).eq.j)then
            aikjk(i8)=aikjk(i8)+a
            return
           endif
703        continue
           nikjk=nikjk+1
           iikjk(nikjk)=i
           jikjk(nikjk)=l
           kikjk(nikjk)=j
           aikjk(nikjk)=a
           if(nikjk.eq.nbuff)call contrxx(6)
          endif
         endif
        else
c IJk
         if(l.eq.i)then
c IJKI -> ikjk
          do 702 i8=nikjk,1,-1
          if(iikjk(i8).eq.k.and.jikjk(i8).eq.j.and.kikjk(i8).eq.i)then
           aikjk(i8)=aikjk(i8)+a
           return
          endif
702       continue
          nikjk=nikjk+1
          iikjk(nikjk)=k
          jikjk(nikjk)=j
          kikjk(nikjk)=i
          aikjk(nikjk)=a
          if(nikjk.eq.nbuff)call contrxx(6)
         else
          if(l.eq.j)then
c IJKJ -> ikjk
           do 701 i8=nikjk,1,-1
           if(iikjk(i8).eq.i.and.jikjk(i8).eq.k.and.kikjk(i8).eq.j)then
            aikjk(i8)=aikjk(i8)+a
            return
           endif
701        continue
           nikjk=nikjk+1
           iikjk(nikjk)=i
           jikjk(nikjk)=k
           kikjk(nikjk)=j
           aikjk(nikjk)=a
           if(nikjk.eq.nbuff)call contrxx(6)
          else
           if(l.eq.k)then
c IJKK
            do 602 i8=nijkk,1,-1
            if(iijkk(i8).eq.i.and.jijkk(i8).eq.j.and.kijkk(i8).eq.k)then
             aijkk(i8)=aijkk(i8)+a
             return
            endif
602         continue
            nijkk=nijkk+1
            iijkk(nijkk)=i
            jijkk(nijkk)=j
            kijkk(nijkk)=k
            aijkk(nijkk)=a
            if(nijkk.eq.nbuff)call contrxx(5)
           else
c IJKL
            ident=i+nort*(j+nort*(k+nort*l))
            do 801 i8=nijkl,1,-1
            if(ideij(i8).eq.ident)then
             aijkl(i8)=aijkl(i8)+a
             return
            endif
801         continue
            nijkl=nijkl+1
            ideij(nijkl)=ident
            iijkl(nijkl)=i
            jijkl(nijkl)=j
            kijkl(nijkl)=k
            lijkl(nijkl)=l
            aijkl(nijkl)=a
            if(nijkl.eq.nbuff)call contrxx(7)
           endif
          endif
         endif
        endif
       endif
      endif
      return
      end
c     =================================================================
      subroutine contract33(ic)
c
c     contracts the integrals a=(ij||kl) in the buffer with the MO coeff
c
c     ic ... control variable
c     ic=0 ... contract all
c     ic=1 ... contract iiii
c     ic=2 ... contract iiij
c     ic=3 ... contract iijj
c     ic=4 ... contract ijij
c     ic=5 ... contract ijkk
c     ic=6 ... contract ikjk
c     ic=7 ... contract ijkl
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nbuff=400,nort=700,nat0=190,nor=80)
      character*2 at
      character*1 ty,ok
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/ajak/ak(nort,nort),aj(nort,nort),kmin,kmax,jmin,jmax
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/intbuff/aiiii(nbuff),aiiij(nbuff),aiijj(nbuff),
     1aijkk(nbuff),aijij(nbuff),aikjk(nbuff),aijkl(nbuff),
     2iiiii(nbuff),iiiij(nbuff),jiiij(nbuff),iiijj(nbuff),jiijj(nbuff),
     3iijkk(nbuff),jijkk(nbuff),kijkk(nbuff),iijij(nbuff),jijij(nbuff),
     4iikjk(nbuff),jikjk(nbuff),kikjk(nbuff),iijkl(nbuff),jijkl(nbuff),
     5kijkl(nbuff),lijkl(nbuff),ideij(nbuff),
     6niiii,niiij,niijj,nijkk,nijij,nikjk,nijkl
      logical lone
      logical lopt,tight,loose,l66,lmp2,lmpdisk,lmpn4,lconfig
      common/opts/lopt(300),icha,n1
      equivalence (lopt(35),tight),(lopt(37),loose),(lopt(42),l66),
     1(lopt(61),lmp2),(lopt(63),lmpdisk),(lopt(64),lmpn4),
     1(lopt(65),lconfig)
      dimension tj(nort*nort),tk(nort*nort),cijt(nort),cikt(nort),
     1cilt(nort),cjkt(nort),cjlt(nort),cklt(nort),ckkt(nort)
c
      ctol=1.0d-6
      if(loose)ctol=0.001D0
      if(tight)ctol=1.0D-10
      ctol2=ctol*ctol
c
      lone=ic.ne.0
      goto(10,20,30,40,50,60,70)ic
c
c     iiii
10    do 10001 ib=1,niiii
      b=aiiii(ib)
      ii=iiiii(ib)
c     write(3,6001)ii,ii,ii,ii,b
c6001  format(4I,F15.9)
      do 10001 kmo=kmin,kmax
      ccki=cij(kmo,ii)*cij(kmo,ii)*b
      do 10001 jmo=jmin,jmax
      ccji=cij(jmo,ii)*cij(jmo,ii)*ccki
      aj(kmo,jmo)=aj(kmo,jmo)+ccji
10001 ak(kmo,jmo)=ak(kmo,jmo)+ccji
      niiii=0
      if(lone)return
c
c     iiij
20    do 20001 ib=1,niiij
      ii=iiiij(ib)
      jj=jiiij(ib)
c     write(3,6001)ii,ii,ii,jj,b
      b=aiiij(ib)
      a2=b+b
      do 20001 kmo=kmin,kmax
      cckii=cij(kmo,ii)*cij(kmo,ii)*a2
      cckij=cij(kmo,ii)*cij(kmo,jj)*a2
      do 20001 jmo=jmin,jmax
      s1=(cckii*cij(jmo,jj)+cckij*cij(jmo,ii))*cij(jmo,ii)
c     iiij iiji ijii jiii
      aj(kmo,jmo)=aj(kmo,jmo)+ s1
20001 ak(kmo,jmo)=ak(kmo,jmo)+ s1
      niiij=0
      if(lone)return
c
c     iijj
30    do 30001 ib=1,niijj
      ii=iiijj(ib)
      jj=jiijj(ib)
c     write(3,6001)ii,ii,jj,jj,b
      b=aiijj(ib)
      a2=b+b
      do 30001 kmo=kmin,kmax
      ccki2=cij(kmo,ii)*cij(kmo,ii)*b
      cckj2=cij(kmo,jj)*cij(kmo,jj)*b
      cckij=cij(kmo,ii)*cij(kmo,jj)*a2
      do 30001 jmo=jmin,jmax
      ccji=cij(jmo,ii)
      ccjj=cij(jmo,jj)
      aj(kmo,jmo)=aj(kmo,jmo)+ ccki2*ccjj*ccjj+cckj2*ccji*ccji
30001 ak(kmo,jmo)=ak(kmo,jmo)+ cckij*ccji*ccjj
      niijj=0
      if(lone)return
c
c     ijij
40    do 40001 ib=1,nijij
      ii=iijij(ib)
      jj=jijij(ib)
c     write(3,6001)ii,jj,ii,jj,b
      b =aijij(ib)
      a2=b+b
      a4=a2+a2
      do 40001 kmo=kmin,kmax
      cckij =cij(kmo,ii)*cij(kmo,jj)*a4
      cckija=cij(kmo,ii)*cij(kmo,jj)*a2
      ccki2 =cij(kmo,ii)*cij(kmo,ii)*b
      cckj2 =cij(kmo,jj)*cij(kmo,jj)*b
      do 40001 jmo=jmin,jmax
      ccji=cij(jmo,ii)
      ccjj=cij(jmo,jj)
      c2=ccji*ccjj
c     ijij ijji jiji jiij
      aj(kmo,jmo)=aj(kmo,jmo)+cckij*c2
40001 ak(kmo,jmo)=ak(kmo,jmo)+ccki2* ccjj*ccjj+
     1                        cckija*c2+
     1                        cckj2* ccji*ccji
      nijij=0
      if(lone)return
c
c     ijkk
50    do 50001 ib=1,nijkk
      b=aijkk(ib)
      ii=iijkk(ib)
      jj=jijkk(ib)
      kk=kijkk(ib)
c     write(3,6001)ii,jj,kk,kk,b
      a2=b+b
      do 50003 kmo=1,nmo
      cti=cij(kmo,ii)
      ctj=cij(kmo,jj)
      ctk=cij(kmo,kk)
      cijt(kmo)=cti*ctj
      cikt(kmo)=cti*ctk
      cjkt(kmo)=ctj*ctk
      ckkt(kmo)=ctk*ctk
50003 continue
      do 50001 kmo=kmin,kmax
      s1=cijt(kmo)*a2
      s2=ckkt(kmo)*a2
      s11=cikt(kmo)*a2
      s22=cjkt(kmo)*a2
      if(abs(s1 ).gt.ctol2.or.abs(s2 ).gt.ctol2.
     1or.abs(s11).gt.ctol2.or.abs(s22).gt.ctol2)then
       do 50002 jmo=jmin,jmax
       aj(kmo,jmo)=aj(kmo,jmo)+s1*ckkt(jmo)+s2*cijt(jmo)
50002  ak(kmo,jmo)=ak(kmo,jmo)+s11*cjkt(jmo)+s22*cikt(jmo)
      endif
50001 continue
      nijkk=0
      if(lone)return
c
c     ikjk
60    do 60001 ib=1,nikjk
      b =aikjk(ib)
      ii=iikjk(ib)
      jj=jikjk(ib)
      kk=kikjk(ib)
      a2=b+b
      a4=a2+a2
      do 60003 jmo=1,nmo
      cti=cij(jmo,ii)
      ctj=cij(jmo,jj)
      ctk=cij(jmo,kk)
      cijt(jmo)=cti*ctj
      cikt(jmo)=cti*ctk
      cjkt(jmo)=ctj*ctk
      ckkt(jmo)=ctk*ctk
60003 continue
      do 60001 jmo=jmin,jmax
      s1=cjkt(jmo)*a4
      s2=cikt(jmo)*a4
      s11=a2*ckkt(jmo)
      s22=a2*cjkt(jmo)
      s33=a2*cijt(jmo)
      s44=a2*cikt(jmo)
      if(abs(s1)+abs(s2).gt.ctol2.or.abs(s11)+abs(s22).gt.ctol2.
     1or.abs(s33)+abs(s44).gt.ctol2)then
       do 60002 kmo=kmin,kmax
       aj(kmo,jmo)=aj(kmo,jmo)+ s1*cikt(kmo)+s2*cjkt(kmo)
       ak(kmo,jmo)=ak(kmo,jmo)+ s11*cijt(kmo)+s22*cikt(kmo)+
     2                          s33*ckkt(kmo)+s44*cjkt(kmo)
60002 continue
      endif
60001 continue
      nikjk=0
      if(lone)return
c
c     ijkl
c     first, define a temporary buffer
70    ind=0
      do 70005 kmo=kmin,kmax
      do 70005 jmo=jmin,jmax
      ind=ind+1
      tj(ind)=z0
70005 tk(ind)=z0
c
c     loop over the accumulated AO integrals:
      do 70001 ib=1,nijkl
      b =aijkl(ib)
      ii=iijkl(ib)
      jj=jijkl(ib)
      kk=kijkl(ib)
      ll=lijkl(ib)
c     write(3,6001)ii,jj,kk,ll,b
      do 70003 kmo=1,nmo
      cti=cij(kmo,ii)
      ctj=cij(kmo,jj)
      ctk=cij(kmo,kk)
      ctl=cij(kmo,ll)
      cijt(kmo)=cti*ctj
      cikt(kmo)=cti*ctk
      cilt(kmo)=cti*ctl
      cjkt(kmo)=ctj*ctk
      cjlt(kmo)=ctj*ctl
      cklt(kmo)=ctk*ctl
70003 continue
      a2=b+b
      a4=a2+a2
      ind=0
      do 70001 kmo=kmin,kmax
      s1 =cijt(kmo)*a4
      s2 =cklt(kmo)*a4
      ss1=cikt(kmo)*a2
      ss2=cilt(kmo)*a2
      ss3=cjkt(kmo)*a2
      ss4=cjlt(kmo)*a2
      if(abs(ss1).gt.ctol2.or.abs(ss3).gt.ctol2.
     1or.abs(ss2).gt.ctol2.or.abs(ss4).gt.ctol2.
     2or.abs( s1).gt.ctol2.or.abs( s2).gt.ctol2)then
       do 70002 jmo=jmin,jmax
       ind=ind+1
       tj(ind)=tj(ind)+s1 *cklt(jmo)+s2 *cijt(jmo)
70002  tk(ind)=tk(ind)+ss1*cjlt(jmo)+ss2*cjkt(jmo)+
     1                 ss3*cilt(jmo)+ss4*cikt(jmo)
      else
       ind=ind+jmax-jmin+1
      endif
70001 continue
c
c     add the contribution from the integrals to J and K
      ind=0
      do 70004 kmo=kmin,kmax
      do 70004 jmo=jmin,jmax
      ind=ind+1
      aj(kmo,jmo)=aj(kmo,jmo)+tj(ind)
70004 ak(kmo,jmo)=ak(kmo,jmo)+tk(ind)
      nijkl=0
c
      return
c
      end

c     =================================================================
      subroutine contract33UHF(ic)
c
c     contracts the integrals a=(ij||kl) in the buffer with the MO coeff
c     UHF - different meaning of ajj,akk integrals!
c
c     ic ... control variable
c     ic=0 ... contract all
c     ic=1 ... contract iiii
c     ic=2 ... contract iiij
c     ic=3 ... contract iijj
c     ic=4 ... contract ijij
c     ic=5 ... contract ijkk
c     ic=6 ... contract ikjk
c     ic=7 ... contract ijkl
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nbuff=400,nort=700,nat0=190,nor=80)
      character*2 at
      character*1 ty,ok
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/ajak/ak(nort,nort),aj(nort,nort),kmin,kmax,jmin,jmax
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/intbuff/aiiii(nbuff),aiiij(nbuff),aiijj(nbuff),
     1aijkk(nbuff),aijij(nbuff),aikjk(nbuff),aijkl(nbuff),
     2iiiii(nbuff),iiiij(nbuff),jiiij(nbuff),iiijj(nbuff),jiijj(nbuff),
     3iijkk(nbuff),jijkk(nbuff),kijkk(nbuff),iijij(nbuff),jijij(nbuff),
     4iikjk(nbuff),jikjk(nbuff),kikjk(nbuff),iijkl(nbuff),jijkl(nbuff),
     5kijkl(nbuff),lijkl(nbuff),ideij(nbuff),
     6niiii,niiij,niijj,nijkk,nijij,nikjk,nijkl
      logical lone
      logical lopt,tight,loose,l66,lmp2,lmpdisk,lmpn4
      common/opts/lopt(300),icha,n1
      common/sobs/sbe(nort*2),ndog,nsi,nsorb,isos(2*nort),
     1isomo(2*nort)
      equivalence (lopt(35),tight),(lopt(37),loose),(lopt(42),l66),
     1(lopt(61),lmp2),(lopt(63),lmpdisk),(lopt(64),lmpn4)
      dimension tj(nort*nort),tk(nort*nort),cijt(nort),cikt(nort),
     1cilt(nort),cjkt(nort),cjlt(nort),cklt(nort),ckkt(nort),
     1cbij(nort,nort)
C
      if(lmp2)then
       if(lmpn4)then
        call cmp2I(ic)
       else
        call report('UHF/MP2 supported only with lmpn4 option')
       endif
      endif
c
      ctol=1.0d-6
      if(loose)ctol=0.001D0
      if(tight)ctol=1.0D-10
      ctol2=ctol*ctol
      kmin=1
      kmax=2*nmo
      jmin=1
      jmax=2*nmo
      do 1 ks=kmin,kmax
      k=isomo(ks)
      if(isos(ks).eq.1)then
       do 2 ii=1,nao
2      cbij(ks,ii)=cij(k,ii)
      else
       do 3 ii=1,nao
3      cbij(ks,ii)=bij(k,ii)
      endif
1     continue
c
      lone=ic.ne.0
      goto(10,20,30,40,50,60,70)ic
c
c     iiii
10    do 10001 ib=1,niiii
      b=aiiii(ib)
      ii=iiiii(ib)
      do 10001 kmo=kmin,kmax
      ccki=cbij(kmo,ii)**2*b
      do 10001 jmo=jmin,jmax
      ccji=cbij(jmo,ii)**2*ccki
      aj(kmo,jmo)=aj(kmo,jmo)+ccji
10001 ak(kmo,jmo)=ak(kmo,jmo)+ccji
      niiii=0
      if(lone)return
c
c     iiij
20    do 20001 ib=1,niiij
      ii=iiiij(ib)
      jj=jiiij(ib)
      b=aiiij(ib)
      a2=b+b
      do 20001 kmo=kmin,kmax
      cckii=cbij(kmo,ii)**2*a2
      cckij=cbij(kmo,ii)*cbij(kmo,jj)*a2
      do 20001 jmo=jmin,jmax
      s1=(cckii*cbij(jmo,jj)+cckij*cbij(jmo,ii))*cbij(jmo,ii)
c     iiij iiji ijii jiii
      aj(kmo,jmo)=aj(kmo,jmo)+ s1
20001 ak(kmo,jmo)=ak(kmo,jmo)+ s1
      niiij=0
      if(lone)return
c
c     iijj
30    do 30001 ib=1,niijj
      ii=iiijj(ib)
      jj=jiijj(ib)
      b=aiijj(ib)
      a2=b+b
      do 30001 kmo=kmin,kmax
      ccki2=cbij(kmo,ii)**2*b
      cckj2=cbij(kmo,jj)**2*b
      cckij=cbij(kmo,ii)*cbij(kmo,jj)*a2
      do 30001 jmo=jmin,jmax
      ccji=cbij(jmo,ii)
      ccjj=cbij(jmo,jj)
      aj(kmo,jmo)=aj(kmo,jmo)+ ccki2*ccjj**2+cckj2*ccji**2
30001 ak(kmo,jmo)=ak(kmo,jmo)+ cckij*ccji*ccjj
      niijj=0
      if(lone)return
c
c     ijij
40    do 40001 ib=1,nijij
      ii=iijij(ib)
      jj=jijij(ib)
      b =aijij(ib)
      a2=b+b
      a4=a2+a2
      do 40001 kmo=kmin,kmax
      cckija=cbij(kmo,ii)*cbij(kmo,jj)*a2
      cckij =cckija+cckija
      ccki2 =cbij(kmo,ii)**2*b
      cckj2 =cbij(kmo,jj)**2*b
      do 40001 jmo=jmin,jmax
      ccji=cbij(jmo,ii)
      ccjj=cbij(jmo,jj)
      c2=ccji*ccjj
c     ijij ijji jiji jiij
      aj(kmo,jmo)=aj(kmo,jmo)+cckij*c2
40001 ak(kmo,jmo)=ak(kmo,jmo)+ccki2* ccjj**2+
     1                        cckija*c2+
     1                        cckj2* ccji**2
      nijij=0
      if(lone)return
c
c     ijkk
50    do 50001 ib=1,nijkk
      b=aijkk(ib)
      ii=iijkk(ib)
      jj=jijkk(ib)
      kk=kijkk(ib)
c     write(3,6001)ii,jj,kk,kk,b
      a2=b+b
      do 50003 kmo=1,2*nmo
      cti=cbij(kmo,ii)
      ctj=cbij(kmo,jj)
      ctk=cbij(kmo,kk)
      cijt(kmo)=cti*ctj
      cikt(kmo)=cti*ctk
      cjkt(kmo)=ctj*ctk
      ckkt(kmo)=ctk*ctk
50003 continue
      do 50001 kmo=kmin,kmax
      s1=cijt(kmo)*a2
      s2=ckkt(kmo)*a2
      s11=cikt(kmo)*a2
      s22=cjkt(kmo)*a2
      if(abs(s1 ).gt.ctol2.or.abs(s2 ).gt.ctol2.
     1or.abs(s11).gt.ctol2.or.abs(s22).gt.ctol2)then
       do 50002 jmo=jmin,jmax
       aj(kmo,jmo)=aj(kmo,jmo)+s1*ckkt(jmo)+s2*cijt(jmo)
50002  ak(kmo,jmo)=ak(kmo,jmo)+s11*cjkt(jmo)+s22*cikt(jmo)
      endif
50001 continue
      nijkk=0
      if(lone)return
c
c     ikjk
60    do 60001 ib=1,nikjk
      b =aikjk(ib)
      ii=iikjk(ib)
      jj=jikjk(ib)
      kk=kikjk(ib)
      a2=b+b
      a4=a2+a2
      do 60003 jmo=1,2*nmo
      cti=cbij(jmo,ii)
      ctj=cbij(jmo,jj)
      ctk=cbij(jmo,kk)
      cijt(jmo)=cti*ctj
      cikt(jmo)=cti*ctk
      cjkt(jmo)=ctj*ctk
      ckkt(jmo)=ctk*ctk
60003 continue
      do 60001 jmo=jmin,jmax
      s1=cjkt(jmo)*a4
      s2=cikt(jmo)*a4
      s11=a2*ckkt(jmo)
      s22=a2*cjkt(jmo)
      s33=a2*cijt(jmo)
      s44=a2*cikt(jmo)
      if(abs(s1)+abs(s2).gt.ctol2.or.abs(s11)+abs(s22).gt.ctol2.
     1or.abs(s33)+abs(s44).gt.ctol2)then
       do 60002 kmo=kmin,kmax
       aj(kmo,jmo)=aj(kmo,jmo)+ s1*cikt(kmo)+s2*cjkt(kmo)
       ak(kmo,jmo)=ak(kmo,jmo)+ s11*cijt(kmo)+s22*cikt(kmo)+
     2                          s33*ckkt(kmo)+s44*cjkt(kmo)
60002 continue
      endif
60001 continue
      nikjk=0
      if(lone)return
c
c     ijkl
c     first, define a temporary buffer
70    ind=0
      do 70005 kmo=kmin,kmax
      do 70005 jmo=jmin,jmax
      ind=ind+1
      tj(ind)=z0
70005 tk(ind)=z0
c
c     loop over the accumulated AO integrals:
      do 70001 ib=1,nijkl
      b =aijkl(ib)
      ii=iijkl(ib)
      jj=jijkl(ib)
      kk=kijkl(ib)
      ll=lijkl(ib)
c     write(3,6001)ii,jj,kk,ll,b
      do 70003 kmo=1,2*nmo
      cti=cbij(kmo,ii)
      ctj=cbij(kmo,jj)
      ctk=cbij(kmo,kk)
      ctl=cbij(kmo,ll)
      cijt(kmo)=cti*ctj
      cikt(kmo)=cti*ctk
      cilt(kmo)=cti*ctl
      cjkt(kmo)=ctj*ctk
      cjlt(kmo)=ctj*ctl
      cklt(kmo)=ctk*ctl
70003 continue
      a2=b+b
      a4=a2+a2
      ind=0
      do 70001 kmo=kmin,kmax
      s1 =cijt(kmo)*a4
      s2 =cklt(kmo)*a4
      ss1=cikt(kmo)*a2
      ss2=cilt(kmo)*a2
      ss3=cjkt(kmo)*a2
      ss4=cjlt(kmo)*a2
      if(abs(ss1).gt.ctol2.or.abs(ss3).gt.ctol2.
     1or.abs(ss2).gt.ctol2.or.abs(ss4).gt.ctol2.
     2or.abs( s1).gt.ctol2.or.abs( s2).gt.ctol2)then
       do 70002 jmo=jmin,jmax
       ind=ind+1
       tj(ind)=tj(ind)+s1 *cklt(jmo)+s2 *cijt(jmo)
70002  tk(ind)=tk(ind)+ss1*cjlt(jmo)+ss2*cjkt(jmo)+
     1                 ss3*cilt(jmo)+ss4*cikt(jmo)
      else
       ind=ind+jmax-jmin+1
      endif
70001 continue
c
c     add the contribution from the integrals to J and K
      ind=0
      do 70004 kmo=kmin,kmax
      do 70004 jmo=jmin,jmax
      ind=ind+1
      aj(kmo,jmo)=aj(kmo,jmo)+tj(ind)
70004 ak(kmo,jmo)=ak(kmo,jmo)+tk(ind)
      nijkl=0
c
      return
c
      end
