      subroutine contra66(ic)
c
c     contracts the integrals a=(ij||kl) in the buffer with the MO coeff
c
c     ic ... control variable
c     ic=0 ... contract all
c     ic=1 ... contract iiii
c     ic=2 ... contract iiij
c     ic=3 ... contract iijj
c     ic=4 ... contract ijij
c     ic=5 ... contract ijkk
c     ic=6 ... contract ikjk
c     ic=7 ... contract ijkl
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nbuff=400,nort=700,nat0=190,nor=80)
      character*2 at
      character*1 ty,ok
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/ajak/ak(nort,nort),aj(nort,nort),kmin,kmax,jmin,jmax
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/intbuff/aiiii(nbuff),aiiij(nbuff),aiijj(nbuff),
     1aijkk(nbuff),aijij(nbuff),aikjk(nbuff),aijkl(nbuff),
     2iiiii(nbuff),iiiij(nbuff),jiiij(nbuff),iiijj(nbuff),jiijj(nbuff),
     3iijkk(nbuff),jijkk(nbuff),kijkk(nbuff),iijij(nbuff),jijij(nbuff),
     4iikjk(nbuff),jikjk(nbuff),kikjk(nbuff),iijkl(nbuff),jijkl(nbuff),
     5kijkl(nbuff),lijkl(nbuff),ideij(nbuff),
     6niiii,niiij,niijj,nijkk,nijij,nikjk,nijkl
      logical lone
      dimension cjk(nort,nort)
c
c
      lone=ic.ne.0
c
      do 9901 jmo=jmin,jmax
      do 9901 kmo=kmin,kmax
c
      do 9902 i=1,nao
      do 9902 j=1,nao
9902  cjk(i,j)=cij(jmo,i)*cij(kmo,j)
c
      sumj=z0
      sumk=z0
c
      goto(10,20,30,40,50,60,70)ic
c
c     iiii
10    do 10001 ib=1,niiii
      ii=iiiii(ib)
      ccji=cjk(ii,ii)*cjk(ii,ii)*aiiii(ib)
      sumj=sumj+ccji
10001 sumk=sumk+ccji
      if(lone)goto 9901
c
c     iiij
20    do 20001 ib=1,niiij
      ii=iiiij(ib)
      jj=jiiij(ib)
      b=aiiij(ib)
      a2=b+b
      s1=(cjk(jj,ii)+cjk(ii,jj))*cjk(ii,ii)*(b+b)
c     iiij iiji ijii jiii
      sumj=sumj+ s1
20001 sumk=sumk+ s1
      if(lone)goto 9901
c
c     iijj
30    do 30001 ib=1,niijj
      ii=iiijj(ib)
      jj=jiijj(ib)
      b=aiijj(ib)
      sumj=sumj+(cjk(ii,jj)*cjk(ii,jj)+cjk(jj,ii)*cjk(jj,ii) )*b
30001 sumk=sumk+ cjk(ii,ii)*cjk(jj,jj)*(b+b)
      if(lone)goto 9901
c
c     ijij
40    do 40001 ib=1,nijij
      ii=iijij(ib)
      jj=jijij(ib)
      b =aijij(ib)
      tij=cjk(ii,jj)
      tji=cjk(jj,ii)
      sumj=sumj+(cjk(ii,ii)*cjk(jj,jj)+tij*tji)*(b+b)
40001 sumk=sumk+(tij+tji)*(tij+tji)*b
c     ijij ijji jiji jiij
      if(lone)goto 9901
c
c     ijkk
50    do 50001 ib=1,nijkk
      b=aijkk(ib)
      ii=iijkk(ib)
      jj=jijkk(ib)
      kk=kijkk(ib)
      a2=b+b
      sumj=sumj+(cjk(ii,kk)*cjk(jj,kk)+cjk(kk,ii)*cjk(kk,jj))*a2
50001 sumk=sumk+(cjk(ii,jj)+cjk(jj,ii))*cjk(kk,kk)*a2
      if(lone)goto 9901
c     ijkk=jikk=kkij=kkji
c
c     ikjk
60    do 60001 ib=1,nikjk
      b =aikjk(ib)
      ii=iikjk(ib)
      jj=jikjk(ib)
      kk=kikjk(ib)
      a2=b+b
      tij=cjk(ii,jj)
      tji=cjk(jj,ii)
      tki=cjk(kk,ii)
      tik=cjk(ii,kk)
      tjk=cjk(jj,kk)
      tkj=cjk(kk,jj)
      sumj=sumj+((tij+tji)*cjk(kk,kk)+tkj*tik+tjk*tki)*a2
      sumk=sumk+ (tjk+tkj)*(tki+tik)*a2
60001 continue
      if(lone)goto 9901
c
c     ijkl
70    do 70001 ib=1,nijkl
      b =aijkl(ib)
      a2=b+b
      a4=a2+a2
      ii=iijkl(ib)
      jj=jijkl(ib)
      kk=kijkl(ib)
      ll=lijkl(ib)
      sumj=sumj+(cjk(kk,ii)*cjk(ll,jj)+cjk(ii,kk)*cjk(jj,ll))*a4
70001 sumk=sumk+((cjk(ll,kk)+cjk(kk,ll))*cjk(jj,ii)
     1         + (cjk(ll,kk)+cjk(kk,ll))*cjk(ii,jj))*a2
c
      aj(kmo,jmo)=aj(kmo,jmo)+sumj
      ak(kmo,jmo)=ak(kmo,jmo)+sumk
9901  continue
c
      if(ic.eq.0)then
       niiii=0
       niiij=0
       niijj=0
       nijij=0
       nijkk=0
       nikjk=0
       nijkl=0
       return
      endif
      if(ic.eq.1)niiii=0
      if(ic.eq.2)niiij=0
      if(ic.eq.3)niijj=0
      if(ic.eq.4)nijij=0
      if(ic.eq.5)nijkk=0
      if(ic.eq.6)nikjk=0
      if(ic.eq.7)nijkl=0
      return
c
      end
