      subroutine contryy(ic)
c
c     contracts the integrals a=(ij||kl) in the buffer with the MO coeff
c
c     ic ... control variable
c     ic=0 ... contract all
c     ic=1 ... contract iiii
c     ic=2 ... contract iiij
c     ic=3 ... contract iijj
c     ic=4 ... contract ijij
c     ic=5 ... contract ijkk
c     ic=6 ... contract ikjk
c     ic=7 ... contract ijkl
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nbuff=400,nort=700,nat0=190,nor=80)
      character*2 at
      character*1 ty,ok
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/ajak/ak(nort,nort),aj(nort,nort),kmin,kmax,jmin,jmax
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/intbuff/aiiii(nbuff),aiiij(nbuff),aiijj(nbuff),
     1aijkk(nbuff),aijij(nbuff),aikjk(nbuff),aijkl(nbuff),
     2iiiii(nbuff),iiiij(nbuff),jiiij(nbuff),iiijj(nbuff),jiijj(nbuff),
     3iijkk(nbuff),jijkk(nbuff),kijkk(nbuff),iijij(nbuff),jijij(nbuff),
     4iikjk(nbuff),jikjk(nbuff),kikjk(nbuff),iijkl(nbuff),jijkl(nbuff),
     5kijkl(nbuff),lijkl(nbuff),ideij(nbuff),
     6niiii,niiij,niijj,nijkk,nijij,nikjk,nijkl
      logical lone
      common/iopts/iopt(300)
      common/densitymatrices/palpha(nort*nort),pbeta(nort*nort),e_c,e_x
      dimension cijt(nort),cikt(nort),
     1cilt(nort),cjkt(nort),cjlt(nort),cklt(nort),ckkt(nort)
      common/yyy/q_c(nort),q_x(nort)
      logical lci,lopt
      common/opts/lopt(300),icha,n1
      equivalence (lci,lopt(59))
c
      if(lci)then
       nstart=1
       nend=nmo
      else
       nstart=iopt(8)
       nend=iopt(9)
      endif
c
      ctol=1.0d-12
      lone=ic.ne.0
      goto(10,20,30,40,50,60,70)ic
c
c     iiii
10    do 10001 ib=1,niiii
      b=aiiii(ib)
      ii=iiiii(ib)
      ind=ii+nao*(ii-1)
      d1=palpha(ind)**2*b
      e_c=e_c+d1
      e_x=e_x+d1
      s1=palpha(ind)*b
      do 19001 kmo=1,nmo
      d1=s1*cij(kmo,ii)*cij(kmo,ii)
      q_c(kmo)=q_c(kmo)+d1
19001 q_x(kmo)=q_x(kmo)+d1
      do 10001 kmo=nstart,nend
      ccki=cij(kmo,ii)**2*b
      do 10001 jmo=kmo,nend
      ccji=cij(jmo,ii)**2*ccki
      aj(kmo,jmo)=aj(kmo,jmo)+ccji
10001 ak(kmo,jmo)=ak(kmo,jmo)+ccji
      niiii=0
      if(lone)return
c
c     iiij
20    do 20001 ib=1,niiij
      ii=iiiij(ib)
      jj=jiiij(ib)
      b=aiiij(ib)
      a2=b+b
      a4=a2+a2
      it=nao*(ii-1)
      del=palpha(ii+it)*palpha(jj+it)*a4
      dij=palpha(jj+it)*a2
      dii=palpha(ii+it)*a2
      e_c=e_c+del
      e_x=e_x+del
      do 29001 kmo=1,nmo
      del=cij(kmo,jj)*cij(kmo,ii)*dii+cij(kmo,ii)*cij(kmo,ii)*dij
      q_c(kmo)=q_c(kmo)+del
29001 q_x(kmo)=q_x(kmo)+del
      do 20001 kmo=nstart,nend
      cckii=cij(kmo,ii)**2*a2
      cckij=cij(kmo,ii)*cij(kmo,jj)*a2
      do 20001 jmo=kmo,nend
      s1=(cckii*cij(jmo,jj)+cckij*cij(jmo,ii))*cij(jmo,ii)
c     iiij iiji ijii jiii
      aj(kmo,jmo)=aj(kmo,jmo)+ s1
20001 ak(kmo,jmo)=ak(kmo,jmo)+ s1
      niiij=0
      if(lone)return
c
c     iijj
30    do 30001 ib=1,niijj
      ii=iiijj(ib)
      jj=jiijj(ib)
      b=aiijj(ib)
      a2=b+b
      it=nao*(ii-1)
      jt=nao*(jj-1)
      e_c=e_c+palpha(ii+it)*palpha(jj+jt)*a2
      e_x=e_x+palpha(jj+it)**2*a2
      dii=palpha(ii+it)*b
      djj=palpha(jj+jt)*b
      dij=palpha(jj+it)*a2
      do 39001 kmo=1,nmo
      c_i=cij(kmo,ii)
      c_j=cij(kmo,jj)
      q_c(kmo)=q_c(kmo)+c_j*c_j*dii+c_i*c_i*djj
39001 q_x(kmo)=q_x(kmo)+c_i*c_j*dij
      do 30001 kmo=nstart,nend
      ccki2=cij(kmo,ii)*cij(kmo,ii)*b
      cckj2=cij(kmo,jj)*cij(kmo,jj)*b
      cckij=cij(kmo,ii)*cij(kmo,jj)*a2
      do 30001 jmo=kmo,nend
      ccji=cij(jmo,ii)
      ccjj=cij(jmo,jj)
      aj(kmo,jmo)=aj(kmo,jmo)+ ccki2*ccjj*ccjj+cckj2*ccji*ccji
30001 ak(kmo,jmo)=ak(kmo,jmo)+ cckij*ccji*ccjj
      niijj=0
      if(lone)return
c
c     ijij
40    do 40001 ib=1,nijij
      ii=iijij(ib)
      jj=jijij(ib)
      b =aijij(ib)
      a2=b+b
      a4=a2+a2
      it=nao*(ii-1)
      jt=nao*(jj-1)
      d1=palpha(ii+it)*palpha(jj+jt)
      d2=palpha(jj+it)**2
      e_c=e_c+a4*d2
      e_x=e_x+a2*(d1+d2)
      dii=palpha(ii+it)*b
      djj=palpha(jj+jt)*b
      dij=palpha(ii+jt)*a2
      do 49001 kmo=1,nmo
      q_c(kmo)=q_c(kmo)+cij(kmo,ii)*cij(kmo,jj)*(dij+dij)
49001 q_x(kmo)=q_x(kmo)+cij(kmo,ii)*cij(kmo,ii)*djj
     1                 +cij(kmo,ii)*cij(kmo,jj)*dij
     2                 +cij(kmo,jj)*cij(kmo,jj)*dii
      do 40001 kmo=nstart,nend
      cckij =cij(kmo,ii)*cij(kmo,jj)*a4
      cckija=cij(kmo,ii)*cij(kmo,jj)*a2
      ccki2 =cij(kmo,ii)*cij(kmo,ii)*b
      cckj2 =cij(kmo,jj)*cij(kmo,jj)*b
      do 40001 jmo=kmo,nend
      ccji=cij(jmo,ii)
      ccjj=cij(jmo,jj)
      c2=ccji*ccjj
c     ijij ijji jiji jiij
      aj(kmo,jmo)=aj(kmo,jmo)+cckij*c2
40001 ak(kmo,jmo)=ak(kmo,jmo)+ccki2* ccjj*ccjj+
     1                        cckija*c2+
     1                        cckj2* ccji*ccji
      nijij=0
      if(lone)return
c
c     ijkk
50    do 50001 ib=1,nijkk
      b=aijkk(ib)
      ii=iijkk(ib)
      jj=jijkk(ib)
      kk=kijkk(ib)
      a2=b+b
      a4=a2+a2
      kt=nao*(kk-1)
      jt=nao*(jj-1)
      e_c=e_c+palpha(kk+kt)*palpha(ii+jt)*a4
      e_x=e_x+palpha(ii+kt)*palpha(jj+kt)*a4
      dij=palpha(ii+jt)*a2
      dik=palpha(ii+kt)*a2
      djk=palpha(jj+kt)*a2
      dkk=palpha(kk+kt)*a2
      do 59001 kmo=1,nmo
      q_c(kmo)=q_c(kmo)+cij(kmo,ii)*cij(kmo,jj)*dkk
     1                 +cij(kmo,kk)*cij(kmo,kk)*dij
59001 q_x(kmo)=q_x(kmo)+cij(kmo,ii)*cij(kmo,kk)*djk
     1                 +cij(kmo,jj)*cij(kmo,kk)*dik
      do 50001 kmo=nstart,nend
      s1=cij(kmo,ii)*cij(kmo,jj)*a2
      s2=cij(kmo,kk)*cij(kmo,kk)*a2
      s3=cij(kmo,ii)*cij(kmo,kk)*a2
      s4=cij(kmo,jj)*cij(kmo,kk)*a2
      do 50001 jmo=kmo,nend
      aj(kmo,jmo)=aj(kmo,jmo)
     1 +s1*cij(jmo,kk)**2+s2*cij(jmo,jj)*cij(jmo,ii)
50001 ak(kmo,jmo)=ak(kmo,jmo)
     1 +(s3*cij(jmo,jj)+s4*cij(jmo,ii))*cij(jmo,kk)
      nijkk=0
      if(lone)return
c
c     ikjk
60    do 60001 ib=1,nikjk
      b =aikjk(ib)
      ii=iikjk(ib)
      jj=jikjk(ib)
      kk=kikjk(ib)
      a2=b+b
      a4=a2+a2
      kt=nao*(kk-1)
      jt=nao*(jj-1)
      d1=palpha(ii+kt)*palpha(jj+kt)*a4
      d2=palpha(ii+jt)*palpha(kk+kt)*a4
      e_c=e_c+d1+d1
      e_x=e_x+d2+d1
      dik=palpha(ii+kt)*a2
      djk=palpha(jj+kt)*a2
      dkk=palpha(kk+kt)*a2
      dij=palpha(ii+jt)*a2
      do 69003 kmo=1,nmo
      c_i=cij(kmo,ii)
      c_j=cij(kmo,jj)
      c_k=cij(kmo,kk)
      q_c(kmo)=q_c(kmo)+c_k*(c_i*(djk+djk)+c_j*(dik+dik))
69003 q_x(kmo)=q_x(kmo)+c_i*(c_j*dkk+c_k*djk)+c_k*(c_j*dik+c_k*dij)
      do 60003 kmo=nstart,nend
      cti=cij(kmo,ii)
      ctj=cij(kmo,jj)
      ctk=cij(kmo,kk)
      cijt(kmo)=cti*ctj
      cikt(kmo)=cti*ctk
      cjkt(kmo)=ctj*ctk
      ckkt(kmo)=ctk*ctk
60003 continue
      do 60001 kmo=nstart,nend
      s1=cjkt(kmo)*a4
      s2=cikt(kmo)*a4
      s11=a2*ckkt(kmo)
      s22=a2*cjkt(kmo)
      s33=a2*cijt(kmo)
      s44=a2*cikt(kmo)
      do 60001 jmo=kmo,nend
      aj(kmo,jmo)=aj(kmo,jmo)+ s1*cikt(jmo)+s2*cjkt(jmo)
60001 ak(kmo,jmo)=ak(kmo,jmo)+ s11*cijt(jmo)+s22*cikt(jmo)+
     2                         s33*ckkt(jmo)+s44*cjkt(jmo)
      nikjk=0
      if(lone)return
c
c     ijkl
70    do 70001 ib=1,nijkl
      b =aijkl(ib)
      ii=iijkl(ib)
      jj=jijkl(ib)
      kk=kijkl(ib)
      ll=lijkl(ib)
      a2=b+b
      a4=a2+a2
      a8=a4+a4
      jt=nao*(jj-1)
      lt=nao*(ll-1)
      kt=nao*(kk-1)
      e_c=e_c+palpha(ii+jt)*palpha(kk+lt)*a8
      e_x=e_x+( palpha(ii+kt)*palpha(jj+lt)
     1         +palpha(jj+kt)*palpha(ii+lt))*a4
      dij=palpha(ii+jt)*a2
      dik=palpha(ii+kt)*a2
      dil=palpha(ii+lt)*a2
      djk=palpha(kk+jt)*a2
      djl=palpha(ll+jt)*a2
      dkl=palpha(ll+kt)*a2
      do 79003 kmo=1,nmo
      c_i=cij(kmo,ii)
      c_j=cij(kmo,jj)
      c_k=cij(kmo,kk)
      c_l=cij(kmo,ll)
      q_c(kmo)=q_c(kmo)+c_i*c_j*(dkl+dkl)
     1                 +c_k*c_l*(dij+dij)
79003 q_x(kmo)=q_x(kmo)+c_k*(c_i*djl+c_j*dil)
     1                 +c_l*(c_j*dik+c_i*djk)
      do 70003 kmo=nstart,nend
      cti=cij(kmo,ii)
      ctj=cij(kmo,jj)
      ctk=cij(kmo,kk)
      ctl=cij(kmo,ll)
      cijt(kmo)=cti*ctj
      cikt(kmo)=cti*ctk
      cilt(kmo)=cti*ctl
      cjkt(kmo)=ctj*ctk
      cjlt(kmo)=ctj*ctl
      cklt(kmo)=ctk*ctl
70003 continue
      do 70001 kmo=nstart,nend
      if(abs(cijt(kmo)).gt.ctol)then
       s1=cijt(kmo)*a4
       do 70004 jmo=kmo,nend
70004  aj(kmo,jmo)=aj(kmo,jmo)+s1*cklt(jmo)
      endif
      if(abs(cklt(kmo)).gt.ctol)then
       s2=cklt(kmo)*a4
       do 70005 jmo=kmo,nend
70005  aj(kmo,jmo)=aj(kmo,jmo)+s2*cijt(jmo)
      endif
      if(abs(cikt(kmo)).gt.ctol)then
       ss1=cikt(kmo)*a2
       do 70006 jmo=kmo,nend
70006  ak(kmo,jmo)=ak(kmo,jmo)+ss1*cjlt(jmo)
      endif
      if(abs(cilt(kmo)).gt.ctol)then
       ss2=cilt(kmo)*a2
       do 70007 jmo=kmo,nend
70007  ak(kmo,jmo)=ak(kmo,jmo)+ss2*cjkt(jmo)
      endif
      if(abs(cjkt(kmo)).gt.ctol)then
       ss3=cjkt(kmo)*a2
       do 70008 jmo=kmo,nend
70008  ak(kmo,jmo)=ak(kmo,jmo)+ss3*cilt(jmo)
      endif
      if(abs(cjlt(kmo)).gt.ctol)then
       ss4=cjlt(kmo)*a2
       do 70009 jmo=kmo,nend
70009  ak(kmo,jmo)=ak(kmo,jmo)+ss4*cikt(jmo)
      endif
70001 continue
      nijkl=0
c
      return
c
      end
