      subroutine dhsl(iint,nmo)
c
c     load iint integrals in common jklm into a9 from BBCD.SCR
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nhcir=100000,nort=700)
      common/jklm/j9(nhcir),k9(nhcir),l9(nhcir),m9(nhcir),
     1i88(nhcir),a9(nhcir)
      common/jklmapp/nds(nort),nde(nort)
      logical lopt,lmpn4
      common/opts/lopt(300),icha,n1
      equivalence (lmpn4,lopt(64))
      dimension bmm(100)
c
      ks=1
      je=nmo
      ifound=0
c
c     preorder integrals with respect to last index
      call qisort(iint)
      nend=0
      do 576 IDB=ks,je
      do 571 nstart=nend+1,iint
571   if(m9(nstart).eq.IDB)goto 572
      nstart=0
      goto 575
572   do 573 nend=nstart+1,iint
573   if(m9(nend).ne.IDB)goto 574
      nend=iint+1
574   nend=nend-1
575   nds(IDB)=nstart
576   nde(IDB)=nend
c
      if(lmpn4)then
c
       nend=0
       open(53,file='BBCD.SCR',form='unformatted',status='old')
       do 57 IDB=ks,je
       nstart=nds(IDB)
       nend  =nde(IDB)
c
c      read from 100 word blocks:
       read(53)ntest
       i1=1
60001  i2=min(i1+99,ntest)
       if(nstart.ne.0)then
        read(53)(bmm(ibb-i1+1),ibb=i1,i2)
c
c       look if current batch contains integrals from the list
        do 1 i8=nstart,nend
        if(i88(i8).ge.i1.and.i88(i8).le.i2)then
         a9(i8)=bmm(i88(i8)-i1+1)
         ifound=ifound+1
        endif
1       continue
       else
        read(53)
       endif
c
       if(i2.lt.ntest)then
        i1=i2+1
        goto 60001
       endif
c
57     continue
       close(53)
       if(ifound.ne.iint)then
        write(6,*)ifound,iint
        do i8=1,iint
         write(6,6000)i8,j9(i8),k9(i8),l9(i8),m9(i8),nds(m9(i8)),
     1   nde(m9(i8))
6000     format(i13,3x,4i3,2i8)
        enddo
        call report('Some integrals were not found in dhsl')
       endif
c
      else
c
       call report('other than lmpn4 not implemented in dhsl')
c
      endif
c
      return
      end
c
c     =====================================================
      subroutine qisort(n)
c     orders integrals in common jklm with respect to m9 index=arr
      integer*4 nhcir,M,nstack
      parameter (nhcir=100000,M=10,NSTACK=nhcir)
      real*8 a9
      integer*4 n,j9,k9,l9,i88,i,ir,j,temp,
     1jstack,k,l,istack(NSTACK),it(nhcir),brr(nhcir),arr,a,b
      common/jklm/j9(nhcir),k9(nhcir),l9(nhcir),arr(nhcir),
     1i88(nhcir),a9(nhcir)
c
      do i=1,n
       brr(i)=i
      enddo
c
c     QUICKSORT::::::::::::::::::::::::::::::::::
c     Sorts an array arr(1:n) into ascending order while
c     making rearangement of the array brr(1:n)
c     M ... when buble sort is switched on
      jstack=0
      l=1
      ir=n
1     if(ir-l.lt.M)then
c      insertion sort for small Ms:
       do j=l+1,ir
        a=arr(j)
        b=brr(j)
        do i=j-1,l,-1
         if(arr(i).le.a)goto 2
         arr(i+1)=arr(i)
         brr(i+1)=brr(i)
        enddo
        i=l-1
2       arr(i+1)=a
        brr(i+1)=b
       enddo
       if(jstack.eq.0)goto 9999
c      pop stack and begind new round of partitioning
       ir=istack(jstack)
       l=istack(jstack-1)
       jstack=jstack-2
      else
c      choose median of left, center and right elements as partitioning
c      element a. Also rearrange so that a(l)<=a(l+1)<=a(ir)
       k=(l+ir)/2
       temp=arr(k)
       arr(k)=arr(l+1)
       arr(l+1)=temp
       temp=brr(k)
       brr(k)=brr(l+1)
       brr(l+1)=temp
       if(arr(l).gt.arr(ir))then
        temp=arr(l)
        arr(l)=arr(ir)
        arr(ir)=temp
        temp=brr(l)
        brr(l)=brr(ir)
        brr(ir)=temp
       endif
       if(arr(l+1).gt.arr(ir))then
        temp=arr(l+1)
        arr(l+1)=arr(ir)
        arr(ir)=temp
        temp=brr(l+1)
        brr(l+1)=brr(ir)
        brr(ir)=temp
       endif
       if(arr(l).gt.arr(l+1))then
        temp=arr(l)
        arr(l)=arr(l+1)
        arr(l+1)=temp
        temp=brr(l)
        brr(l)=brr(l+1)
        brr(l+1)=temp
       endif
c      initialize pointers for partitioning
       i=l+1
       j=ir
c      partitioning element
       a=arr(l+1)
       b=brr(l+1)
c      beginninf of innermost loop
3      continue
c      scan up to find element >a
       i=i+1
       if(arr(i).lt.a)goto 3
4      continue
c      scan down to find element <a
       j=j-1
       if(arr(j).gt.a)goto 4
c      pointers crossed; exit whe partitioning complete
       if(j.lt.i)goto 5
c      exchange elements of both arrays
       temp=arr(i)
       arr(i)=arr(j)
       arr(j)=temp
       temp=brr(i)
       brr(i)=brr(j)
       brr(j)=temp
       goto 3
c      end of innermost loop
c      insert partitioning elements in both arrays
5      arr(l+1)=arr(j)
       arr(j)=a
       brr(l+1)=brr(j)
       brr(j)=b
       jstack=jstack+2
c      push pointers to larger subarray on stack,
c      process smaller subarray immediately
       if(jstack.gt.nstack)write(6,*) 'nstack too small'
       if(ir-i+1.ge.j-l)then
        istack(jstack)=ir
        istack(jstack-1)=i
        ir=j-1
       else
        istack(jstack)=j-1
        istack(jstack-1)=l
        l=i
       endif
      endif
      goto 1
c     QUICKSORT::::::END::::::::::::::::::::
9999  do 100 i=1,n
100   it(i)=j9(brr(i))
      do 101 i=1,n
      j9(i)=it(i)
101   it(i)=k9(brr(i))
      do 102 i=1,n
      k9(i)=it(i)
102   it(i)=l9(brr(i))
      do 103 i=1,n
      l9(i)=it(i)
103   it(i)=i88(brr(i))
      do 104 i=1,n
104   i88(i)=it(i)
      return
      end

