      subroutine dhss(iint,nmo)
c     load iint integrals into a9 from expansion (IJKL)-(IJI')(KLL')(I'|L')
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nhcir=100000,nbi0=500,nort=700)
      common/jklm/j9(nhcir),k9(nhcir),l9(nhcir),m9(nhcir),
     1i88(nhcir),a9(nhcir)
      dimension b(nort),ib(nort),bjkl(nbi0,nort),ollm(nbi0,nort)
c
      call vz(a9,0.0d0,iint)
c
c     make batches N1..N2 from the list 1..iint
      N1=1
9     N2=min(iint,N1+nbi0)
      nd=N2-N1+1
c
      do 1 i8=1,nd
      do 1 ll=1,nmo
      ollm(i8,ll)=0.0d0
1     bjkl(i8,ll)=0.0d0
c
c     load (JK|l) for the batch
      open(47,file='FJKL.SCR',form='unformatted',status='old')
      do 2 L=1,nmo
      do 2 J=1,nmo
      read(47)nb,(b(kk),kk=1,nb),(ib(kk),kk=1,nb)
      do 2 kk=1,nb
      K=ib(kk)
      do 2 i8=1,nd
      ii=i8+N1-1
2     if(K.eq.k9(ii).and.J.eq.j9(ii))bjkl(i8,L)=b(kk)
      close(47)
c
c     load (lLM) for the batch
      open(46,file='JKL.SCR',form='unformatted',status='old')
      do 3 LL=1,nmo
      do 3 L=1,nmo
      read(46)nb,(b(mm),mm=1,nb),(ib(mm),mm=1,nb)
      do 3 mm=1,nb
      M=ib(mm)
      do 3 i8=1,nd
      ii=i8+N1-1
3     if(L.eq.l9(ii).and.M.eq.m9(ii))ollm(i8,LL)=b(mm)
      close(46)
c
c     make the integrals
      do 4 i8=1,nd
      ii=i8+N1-1
      sum=0.0d0
      do 5 l=1,nmo
5     sum=sum+bjkl(i8,l)*ollm(i8,l)
      a9(ii)=sum
      write(99,9999)ii,j9(ii),k9(ii),l9(ii),m9(ii),a9(ii)
9999  format(i6,4i4,f12.6)
4     continue
c
c     move to the next batch
      if(N2.lt.iint)then
       N1=N2+1
       goto 9
      endif
c
      return
      end
