      subroutine dojk(j,k,dj,mj,alj,rlj,dk,mk,alk,rlk)
c     symmetry properties of overlaps are not used, because of control
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nort=700)
c     n1e ... number of kinds of one-electron integrals
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/ajak/ak(nort,nort),aj(nort,nort),kmin,kmax,jmin,jmax
      dimension dj(mj),dk(mk),
     5alj(mj),alk(mk),rlj(3,mj),rlk(3,mk)
c
      aj(k,j)=z0
      ak(k,j)=z0
      do 1 i=1,mj
      xi=rlj(1,i)
      yi=rlj(2,i)
      zi=rlj(3,i)
      a=alj(i)
      dji=dj(i)
      do 2 jj=1,mk
      xij=rlk(1,jj)-xi
      yij=rlk(2,jj)-yi
      zij=rlk(3,jj)-zi
      r2=xij*xij+yij*yij+zij*zij
      b=alk(jj)
      th=a*b/(a+b)
      sq=sqrt(th+th)
      t=th*r2
      aint=ee4(t,0)*sq
c
c     contract the coulomb integral with the coefficients
2     aj(k,j)=aj(k,j)+dji*dk(jj)*aint
1     continue
c
      return
      end
