      subroutine dqmpol3(alc,ac,g,alcv,ioe)
c     alpha, A and G' tensors (static limits), chi
c
      implicit none
      integer*4 nat0,nor,nort,nel,nr,Nro,Nro3,nfiles,j,k,ik,
     1isu,nsubst0,nsubst
      parameter (nat0=190,nor=80,nort=700,nel=15,nr=100,
     1Nro=15,Nro3=Nro*Nro*Nro,nfiles=4,nsubst0=100)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c     nel    dimension of the buffer dmo with MO matrix elements
c     nr     something for fitro1
c
      character*2 at
      character*1 ok,ty
      real*8 etol,anml,dum,delG,c,ck1,ck2,ck3,ejknm,ejk,a10,
     1a8,aex,aj,ajkj,ak,akkj,alpha,
     2be,bij,cc,cij,ckj,dd,ddg,
     3e,escf,e_c,e_x,five,four,fw4,half,one,
     4palpha,pbeta,qua,q_c,q_x,r1,r2,rcp,rd,ropt,
     5rv,six,sp,spa,spap,three,twf,two,umi,umw,uui,
     6uuw,vd,vv,wexc,xjk,xk,xr0,xr0m,xx,xy,xz,yjk,yk,yr0,yr0m,yy,yz,
     7z0,zjk,zk,zr0,zr0m,zz,delV,ekj
      integer*4 i,i0,icha,ichm,idx,idy,idz,ifil,ii,ij,
     1io,ioe,ione,ioo,ish,ix,iy,iz,jdeg,jj,jmax,jmin,jstart,
     2jx,jy,jz,kc,kind,kk,kmax,kmin,mc,mclock,mcp,mj,mk,mtp,n1,
     3nao,nat,ndeg,ndo,ndoo,nmo,noa,noe,nop,nori,npx,npy,
     4npz,nrj,nrk,nsa,nsb,nuvcd,nzz
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      real*8 dmo(nel,nort),alp(3,3),a(3,6),g(3,3),
     1alc(3,3),ac(3,3,3),alcv(3,3),alpv(3,3),dk(nr),dj(nr),alk(nr),
     2alj(nr),rlk(3,nr),rlj(3,nr),chip(3,3),chid(3,3)
      common/densitymatrices/palpha(nort*nort),pbeta(nort*nort),e_c,e_x
      common/ajak/ak(nort,nort),aj(nort,nort),kmin,kmax,jmin,jmax
c
      logical lscf,lres,lrec,lopt,lsp,lmoscr,lall,luvcd,lar,
     1lconfig ,larmp2,lmp2,lmpn4,lonly,gconfig,lsubst,lab
      common/opts/lopt(300),icha,n1
      common/ropts/ropt(300)
      equivalence (lopt(21),lscf),(lopt(22),lres),(lopt(25),lrec),
     1(lopt(19),lsp),(lopt(43),lall),(lopt(55),luvcd),
     1(lopt(65),lconfig),(lopt(61),lmp2),(lopt(64),lmpn4),
     1(lopt(69),lonly),(lopt(66),gconfig),(lopt(88),lsubst),
     1(ropt(1),wexc),(lopt(105),lab)
c
c     variables for the density-grid calculations:
      real*8 rok(Nro3),roj(Nro3),rrx(Nro),rry(Nro),rrz(Nro),es(nsubst0)
      integer*4 ijkk(3,Nro3),ijkj(3,Nro3),is1(nsubst0),is2(nsubst0)
      common/ro2/delG,xr0,yr0,zr0,npx,npy,npz
      common/yyy/q_c(nort),q_x(nort)
      character*7 fm(nfiles,3)
      data fm/'PMO.SCR','QMO.SCR','LMO.SCR','VMO.SCR',
     1        'PMO.SCR','QMO.SCR','LMO.SCR','VMO.SCR',
     1        'PMB.SCR','QMB.SCR','LMB.SCR','VMB.SCR'/
      integer*4 id(nfiles)
      data id/3,6,3,3/
c
      call w36('       ')
      call w36('Dqmpol3')
      call w36('^^^^^^^')
      call w36('       ')
c
      I0=0
      Ione=1
      etol=0.00001d0
      anml=10.0d0
      write(3,4001)nmo,nao,wexc
      write(6,4001)nmo,nao,wexc
4001  format(' A,alpha,G',1H',' and Chi; NMO = ',I4,' NAO = ',I4,
     1/,' wexc =  ',f12.6,' au')
      if(nao.gt.nort)call report('Too many orbitals for dqmpol3')
      if(lconfig)then
       write(3,*)'Warning: un-restricted open shell defined'
       write(3,*)'some features are not implemented yet'
       nzz=2*nmo
      else
       nzz=nmo
      endif

      if(lsubst)then
       write(6,*)'Substitute certain transitions'
       open(88,file='SUBST.LST',status='old')
       read(88,*)nsubst
       if(nsubst.gt.nsubst0)call report('nsubst.gt.nsubst0')
       do i=1,nsubst
        read(88,*)is1(i),is2(i),es(i)
       enddo
       close(88)
      endif
c
      inquire(file='VMO.SCR',exist=lmoscr)
      if(.not.lmoscr)call makemos2(nao,cij,nmo)
      inquire(file='VMB.SCR',exist=lmoscr)
      if(.not.lmoscr.and.nsb.gt.0)call makemosb(nao,bij,nmo)
      inquire(file='VMA.SCR',exist=lmoscr)
      if(.not.lmoscr.and.nsb.gt.0.and.lab)
     1call makemosab(nao,cij,bij,nmo)
c
      call vz(alp ,z0,9)
      call vz(alpv,z0,9)
      call vz(chid,z0,9)
      call vz(chip,z0,9)
      call vz(g   ,z0,9)
      call vz(a   ,z0,18)
c
      mc=mclock()
      if(ioe.ne.0)then
       call inibe4
       if(kmin.eq.0)kmin=1
       if(kmax.eq.0)then
        kmax=ndo
        if(lscf)kmax=nori
       endif
       if(jmin.eq.0)then
        jmin=ndo+1
        if(lscf.or.lall)jmin=1
       endif
       if(jmax.eq.0)jmax=nori
       inquire(file='AKJK.SCR',exist=lar)
       if(lres.and..not.lar)call report('AKJK.SCR does not exist')
       if(lmp2)then
        larmp2=.false.
        if(lmpn4)then
         inquire(file='BBCD.SCR',exist=larmp2)
        endif
        if(.not.larmp2)then
         call w36('MP2 cannot restart')
         lar=.false.
        endif
       endif
       if(lar)then
        lres=.true.
        open(23,file='AKJK.SCR',form='unformatted')
        read(23)((ak(i,j),i=1,nzz),j=1,nzz),((aj(i,j),i=1,nzz),j=1,nzz)
        if(lonly)then
         read(23)(palpha(i),i=1,nao**2),(pbeta(i),i=1,nao**2),e_c,e_x
         if(gconfig)read(23)q_c,q_x
         write(3,*)'density matrix read from scratch'
        endif
        close(23)
        write(6,*)'J,K read from scratch'
        write(3,*)'J,K read from scratch'
       endif
      endif

      if(ioe.eq.4.and..not.lres)then
       call setlr(Nro)
       ddG=half*delG
       xr0m=xr0-ddG
       yr0m=yr0-ddG
       zr0m=zr0-ddG
       do 550 ii=1,Nro
       dum=dble(ii)*delG
       rrx(ii)=xr0m+dum
       rry(ii)=yr0m+dum
550    rrz(ii)=zr0m+dum
       delV=delG**3
       c=1.8811D0/delG
       ck1=0.980886D0/delG
       ck2=0.708495114d0/delG
       ck3=0.578797d0/delG
c
       do 500 k=kmin,kmax
c
c      density for k-orbital:
       call roapp(k,rok,Nro3,ijkk,Nro,Nrk)
       jstart=jmin
       if(jstart.lt.k)jstart=k
       do 500 j=jstart,jmax
c
c      density for j-orbital:
       if(j.eq.k)then
        do 501 io=1,Nrk
        roj(io)=rok(io)
        do 501 ioo=1,3
501     ijkj(ioo,io)=ijkk(ioo,io)
        Nrj=Nrk
       else
        call roapp(j,roj,Nro3,ijkj,Nro,Nrj)
       endif
       write(6,*)'Calculating J,K for orbitals ',k,',',j
       ajkj=z0
       akkj=z0
       do 400 ik=1,Nrk
       ix=ijkk(1,ik)
       iy=ijkk(2,ik)
       iz=ijkk(3,ik)
       xk=rrx(ix)
       yk=rry(iy)
       zk=rrz(iz)
       r1=rok(ik)
       do 401 ij=1,Nrj
       r2=roj(ij)*r1
       jx=ijkj(1,ij)
       jy=ijkj(2,ij)
       jz=ijkj(3,ij)
       idx=abs(ix-jx)
       idy=abs(iy-jy)
       idz=abs(iz-jz)
       if(idx.gt.1)goto 99
       if(idy.gt.1)goto 99
       if(idz.gt.1)goto 99
       kind=idx+idy+idz
       if(kind.eq.0)then
        ajkj=ajkj+r2*c
       else
        if(kind.eq.1)then
         ajkj=ajkj+r2*ck1
        else
         if(kind.eq.2)then
          ajkj=ajkj+r2*ck2
         else
          ajkj=ajkj+r2*ck3
         endif
        endif
       endif
       goto 401
99     xjk=rrx(jx)-xk
       yjk=rry(jy)-yk
       zjk=rrz(jz)-zk
       ajkj=ajkj+r2/sqrt(xjk*xjk+yjk*yjk+zjk*zjk)
401    continue
400    continue
       ajkj=ajkj*delV*delV
       aj(k,j)=ajkj
       ak(k,j)=akkj
       aj(j,k)=ajkj
       ak(j,k)=akkj
500    continue
      endif
c
      if((ioe.eq.2.or.ioe.eq.3).and..not.lres)then
       call dox31
      endif
c
      if(ioe.eq.1)call report('ioe=1 not implemented')
c
      if(ioe.gt.0)then
       aex=one
       if(ioe.eq.3)aex=z0
       if(lscf)call overlav
       if(.not.lres)then
        open(23,file='AKJK.SCR',form='unformatted')
        write(23)((ak(i,j),i=1,nzz),j=1,nzz),((aj(i,j),i=1,nzz),j=1,nzz)
        if(lonly)then
         write(23)(palpha(i),i=1,nao**2),
     1            ( pbeta(i),i=1,nao**2),e_c,e_x
         if(gconfig)write(23)q_c,q_x
        endif
        close(23)
        write(3,*)'AKJK.SCR written'
        write(6,*)'AKJK.SCR written'
       endif
       if(lsp)lres=.true.
      endif
c
      mcp=mclock()
      write(6,*)' Time spent ',mcp-mc
      write(3,*)' Time spent ',mcp-mc
c
      if(luvcd) then
       open(23,file='UVCD.TAB')
       open(24,file='UVCD.LST')
       write(23,23000)
       write(24,24000)anml
23000  format(' UVCD',/,'transition energy[nm] ',
     1'  Dr[au]     Rr[au]     Dv       Dvr          Rv',
     2 /,60(1h-))
24000  format(' UVCD, complementary list to file UVCD.TAB,',/,
     1  ' with some specifications of the transitions',/,
     2  'limit for energies: ',F8.2,' nm',/,/,
     3  ' transition K ->   J       ux       uy   ',
     4  '    uz       mx       my       mz',
     5/,60(1h-))
       nuvcd=0
      endif
c
      xx=z0
      xy=z0
      xz=z0
      yy=z0
      yz=z0
      zz=z0
      write(3,3334)
3334  format(
     1'  j  k         ejk =         ej -         ek -      Jjk + 2 x ',
     2'       Kjk',/,80(1H-))
c
      do 5 ik=1,3
      twf=one
      if(ik.eq.1)twf=two
      if(ik.eq.1)ndoo=ndo
      if(ik.eq.2)ndoo=nsa
      if(ik.eq.3)ndoo=nsb
c     sum over occupied orbitals
      do 5 k=1,ndoo
c
c     read up one electron integrals:
      kk=0
      do ifil=1,4
       open(36,file=fm(ifil,ik),form='unformatted')
       do ix=1,id(ifil)
        kk=kk+1
        do kc=1,nmo
         if(kc.eq.k)then
          read(36)(dmo(kk,j),j=1,nmo)
         else
          read(36)
         endif
        enddo
       enddo
       close(36)
      enddo
c
c     if desired, fit the density of the MO k
      if(ioe.eq.1)then
       mc=mclock()
       call fitro1(k,dk,mk,alk,rlk)
c
c      ro_k=c_kl fl  l=1..M,   fl=exp(-al*(r-rl)^2)
c
       mcp=mclock()
       write(6,*)' fit time ',mcp-mc
       write(3,*)' fit time ',mcp-mc
      endif
c
c     sum over excited states = virtual orbitals
      jstart=ndoo+1
      if(lall)jstart=1
      do 6 j=jstart,nmo
      if(j.eq.k)goto 6
c
c     energy difference by a vertical excitation scheme
c     dE=ej-ek-Jjk+2Kjk, ei Fock energies, Kjk neglected
      if(ik.eq.3)then
       ejk=be(j)-be(k)
      else
       ejk=e(j)-e(k)
      endif
      if(abs(ejk).lt.etol)goto 6
      ndeg=1
c
c     check for degeneracy
      if(ioe.gt.0)then
       do 2 jj=ndoo+1,nmo
       if(jj.eq.j)goto 2
       if(abs(e(j)-e(jj)).lt.0.0001d0)then
        ndeg=ndeg+1
        jdeg=jj
       endif
2      continue
      endif
c
      if(ndeg.gt.2)then
       write(3,*)'high degeneracy may not be properly implemented'
      endif
c
      if(ioe.eq.2.or.ioe.eq.3.or.ioe.eq.4)then
       if(ndeg.eq.1)then
        ckj=aj(k,j)
        ekj=ak(k,j)*aex
       else
        ckj=half*(aj(k,j)+aj(k,jdeg))
        ekj=half*(ak(k,j)+ak(k,jdeg))*aex
       endif
       ejk=ejk-ckj+two*ekj
       write(3,3333)k,j,ejk,e(j),e(k),ckj,ekj
3333  format(I3,'->',I3,': ',F10.5,' = ',F10.4,' - ',F10.4,' - ',F10.4,
     1' + 2 x ',F10.4)
      else
       write(3,3333)k,j,ejk,e(j),e(k)
      endif
c
c     if(nk.gt.0)then
c      if(k.ge.nk.and.k.le.nj.and.j.ge.nk.and.j.le.nj)then
c       jt=j-nk+1
c       kt=k-nk+1
c       ipair=jt*(jt-1)/2+kt
c       ic=ipair+ipair-1
c       in fact, cjk=ckj; and only cs for j<=k recorded
c       ckj=ckkjj(ic)
c       ekj=ckkjj(ic+1)
c       ejk=enknj(jt)-enknj(kt)-ckj+two*ekj
c       write(3,3333)k,j,ejk,enknj(jt),enknj(kt),ckj,ekj
c       write(6,3333)k,j,ejk,enknj(jt),enknj(kt),ckj,ekj
c       ejknm=1.0d7/(ejk*219470.0d0)
c       tejk=ejk-two*ekj
c       tejknm=1.0d7/(tejk*219470.0d0)
c       if(luvcd)write(3,3335)ejknm,tejknm
c       if(luvcd)write(6,3335)ejknm,tejknm
c335    format(f12.2,' (triplet',f10.2,') nm')
c      endif
c     endif
c
      if(ioe.eq.1)then
       if(k.eq.1)then
        mc=mclock()
        call fitro1(j,dj,mj,alj,rlj)
        call savero(j,dj,mj,I0,ndo)
        mcp=mclock()
        write(6,*)' fit time ',mcp-mc
        write(3,*)' fit time ',mcp-mc
       else
        call savero(j,dj,mj,Ione,ndo)
       endif
       call dojk(j,k,dj,mj,alj,rlj,dk,mk,alk,rlk)
       ejk=ejk-aj(k,j)+two*ak(k,j)
       write(3,3333)j,k,ejk,e(j),e(k),aj(k,j),ak(k,j)
       write(6,3333)j,k,ejk,e(j),e(k),aj(k,j),ak(k,j)
      endif
c
      if(lsubst)then
       do isu=1,nsubst
        if(k.eq.is1(isu).and.j.eq.is2(isu))then
         write(6,6099)k,j,es(isu)
6099     format(2i4,' energy substituted by ',f12.6)
         ejk=es(isu)
        endif
       enddo
      endif

      if(luvcd)then
       ejknm=1.0d7/(ejk*219470.0d0)
       if(ejknm.gt.anml)then
        dd=dmo( 1,j)*dmo( 1,j)+dmo( 2,j)*dmo( 2,j)+dmo( 3,j)*dmo( 3,j)
        vd=dmo( 1,j)*dmo(13,j)+dmo( 2,j)*dmo(14,j)+dmo( 3,j)*dmo(15,j)
        vv=dmo(13,j)*dmo(13,j)+dmo(14,j)*dmo(14,j)+dmo(15,j)*dmo(15,j)
        rd=dmo( 1,j)*dmo(10,j)+dmo( 2,j)*dmo(11,j)+dmo( 3,j)*dmo(12,j)
        rv=dmo(13,j)*dmo(10,j)+dmo(14,j)*dmo(11,j)+dmo(15,j)*dmo(12,j)
        vd=vd/ejk
        rv=rv/ejk
        vv=vv/(ejk*ejk)
        nuvcd=nuvcd+1
        write(23,23002)nuvcd,ejknm,dd,rd,vd,vv,rv
23002   format(i5,f10.2,5F11.6)
        write(24,24002)nuvcd,k,j,(dmo(ii,j),ii=1 , 3),
     1                           (dmo(ii,j),ii=10,12)
24002   format(i5,i6,' ->',i6,6f9.5)
       endif
      endif
c
      if(abs(ejk-wexc).lt.etol)goto 6
      fw4=two*twf/((ejk-wexc)*(ejk+wexc))
      do 10 ix=1,3
      uui=dmo(  ix,j)*fw4
      uuw=uui*ejk
      umi=dmo(9+ix,j)*fw4
      umw=umi*ejk
      do 10 jx=1,3
c     # alpha
c     # alphav, second index -velocity
c     # G full, first index - elctric, second - magnetic
c     # A first index dipole, second quadrupole
c     # chi(para) full
      alp( ix,jx  )=alp( ix,jx  )+uuw*dmo(   jx,j)
      alpv(ix,jx  )=alpv(ix,jx  )+uui*dmo(12+jx,j)
      g(   ix,jx  )=g(   ix,jx  )-uui*dmo( 9+jx,j)
      a(   ix,jx  )=a(   ix,jx  )+uuw*dmo( 3+jx,j)
      a(   ix,jx+3)=a(   ix,jx+3)+uuw*dmo( 6+jx,j)
10    chip(ix,jx  )=chip(ix,jx  )+umw*dmo( 9+jx,j)
c
6     continue
c
      xx=xx+two*dmo(4,k)
      xy=xy+two*dmo(5,k)
      xz=xz+two*dmo(6,k)
      yy=yy+two*dmo(7,k)
      yz=yz+two*dmo(8,k)
      zz=zz+two*dmo(9,k)
c
5     continue
c
      chid(1,1)=-qua*(yy+zz)
      chid(2,2)=-qua*(xx+zz)
      chid(3,3)=-qua*(yy+xx)
      chid(1,2)=qua*xy
      chid(2,1)=qua*xy
      chid(1,3)=qua*xz
      chid(3,1)=qua*xz
      chid(2,3)=qua*yz
      chid(3,2)=qua*yz
c
      if(luvcd)then
       write(23,23001)
       write(24,23001)
23001  format(60(1h-))
       close(23)
       close(24)
      endif
c
c     construct the traceless A:
      do 8 ix=1,3
      xx=a(ix,1)
      xy=a(ix,2)
      xz=a(ix,3)
      yy=a(ix,4)
      yz=a(ix,5)
      zz=a(ix,6)
      a(ix,1)=half*(two*xx-zz-yy)
      a(ix,2)=half*three*xy
      a(ix,3)=half*three*xz
      a(ix,4)=half*(two*yy-zz-xx)
      a(ix,5)=half*three*yz
8     a(ix,6)=half*(two*zz-xx-yy)
c
      open(33,file='AL.TEN')
      write( 3,4000)'Alpha   (au)',wexc,((alp(ix,jx),ix=1,3),jx=1,3)
      write(33,4000)'Alpha   (au)',wexc,((alp(ix,jx),ix=1,3),jx=1,3)
4000  format(a12,/,
     1       ' (wexc=',f12.6,' au)',/,19x,'X',19x,'Y',19x,'Z',/,
     2       3(3F20.9,/),/)
      close(33)
      write(3,4004)(alp(1,1)+alp(2,2)+alp(3,3))/3.0d0
4004  format('Trace/3 = ',f20.9,/)
c
      open(33,file='ALV.TEN')
      write(3 ,4000)'Alpha V (au)',wexc,((alpv(ix,jx),jx=1,3),ix=1,3)
      write(33,4000)'Alpha V (au)',wexc,((alpv(ix,jx),jx=1,3),ix=1,3)
      close(33)
      write(3,4004)(alpv(1,1)+alpv(2,2)+alpv(3,3))/3.0d0
c
      open(33,file='A.TEN')
      write(33,4003)a(1,1),a(1,4),a(1,6),a(1,2),a(1,3),a(1,5),
     1             a(2,1),a(2,4),a(2,6),a(2,2),a(2,3),a(2,5),
     1             a(3,1),a(3,4),a(3,6),a(3,2),a(3,3),a(3,5)
      write(3,4003)a(1,1),a(1,4),a(1,6),a(1,2),a(1,3),a(1,5),
     1             a(2,1),a(2,4),a(2,6),a(2,2),a(2,3),a(2,5),
     1             a(3,1),a(3,4),a(3,6),a(3,2),a(3,3),a(3,5)
4003  format(' Electric dipole - electric quadrupole polarizability',/,
     1       ' (A, in atomic units)',/,
     1        11x,'XX',11x,'YY',11x,'ZZ',11x,'XY',11x,'XZ',11x,'YZ',/,
     2       3(6F18.8,/),/)
      close(33)
c
      open(33,file='G.TEN')
      write(3 ,4002)((g(i,j),j=1,3),i=1,3)
      write(33,4002)((g(i,j),j=1,3),i=1,3)
4002  format(' Electric dipole - magnetic dipole polarizability',/,
     1' (static limit of the tensor, w^-1G',1h',', in atomic units)',/,
     1        18x,'BX',18x,'BY',18x,'BZ',/,
     2       3(3F20.9,/),/)
      close(33)
c
      do 22 i=1,3
      do 22 j=1,3
      alc(i,j)=alp(i,j)
22    alcv(i,j)=alpv(i,j)
      ii=0
      do 21 i=1,3
      do 21 j=i,3
      ii=ii+1
      do 21 k=1,3
      ac(k,i,j)=a(k,ii)
21    ac(k,j,i)=a(k,ii)
c
      spap=(chip(1,1)+chip(2,2)+chip(3,3))/three
      write(3,*)
     1'Susceptibility, paramagnetic, static limit, in atomic units:'
      write(3,4006)((chip(i,j),i=1,3),j=1,3),spap
4006  format(/,'                          ',15x,'X',15x,'Y',15x,'Z',/,
     1         '    Chi                   ',3F16.8,/,
     1         '                          ',3F16.8,/,
     2         '                          ',3F16.8,/,
     3         '                          ',16(1H-),/,
     3         '    (Tr Chi)/3            ',F16.8,/,/)
c
      sp=(chid(1,1)+chid(2,2)+chid(3,3))/three
      write(3,*)'Susceptibility, diamagnetic, in atomic units:'
      write(3,4006)((chid(i,j),i=1,3),j=1,3),sp
      do 14 i=1,3
      do 14 j=1,3
14    chid(i,j)=chid(i,j)+chip(i,j)
      spa=spap+sp
      write(3,*)'Susceptibility, total, in atomic units:'
      write(3,4006)((chid(i,j),i=1,3),j=1,3),spa
c
      write(6,*)' Leaving dqmpol3 ...'
      return
      end
