      subroutine frox(rox,rx,ry,rz,istart,iend,ic1,ic2)
c
c     the elctron density from MOs istart..iend
c     ic1=2 .. double occupied
c     ic1=1 .. singly occupied
c     ic2=0 .. density olnly
c     ic2=1 .. also gradient
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
c
      parameter (nat0=190,nor=80,nort=700,nX=2000,mmax=21)
      integer*4 u0
      parameter (u0=28)
c
      character*2 at
      character*1 ok,ty
      logical ld5,lf7,lopt,tight,special
c
      dimension occup(2),aad(u0,u0),aaf(u0,u0),aa1(u0,u0),
     1aag(u0,u0),aah(u0,u0),aaii(u0,u0),
     1aai(u0,u0),cci(u0),nxi(u0),nyi(u0),nzi(u0)
c
      common/atoms/q(nat0),zsum,xv(3,nat0)
      common/opts/lopt(300),icha,n1
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/ap4/et(nX),ei(mmax,nX),dt(mmax),dt63(mmax),dt62(mmax),
     1ti(mmax),t5(mmax),dtt,t23,dtt2,dtt3
      equivalence (lopt(4),ld5),(lopt(8),lf7),(lopt(35),tight)
      data occup/1.0D0,2.0D0/

c
      if(ic2.eq.1)call report('grad ro not implemented')
c
      call initfd(aa1,aad,aaf,aag,aah,aaii)
c
      rosum=z0
      do 1 i=istart,iend
      psii=z0
c
c     MO psi(i)=sum over AOs
c     sum over atoms
      io=0
      do 2 ia=1,noa
      x=rx-xv(1,ia)
      y=ry-xv(2,ia)
      z=rz-xv(3,ia)
c
c     d-functions
      xx=x*x
      yy=y*y
      zz=z*z
c
c     f-functions
      xxx=xx*x
      yyy=yy*y
      zzz=zz*z
c
      ar2=xx+yy+zz
c
c     sum over primitives
      do 3 ip=1,nop(ia)
      a=alpha(ia,ip)
      ecp=a*ar2
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
      if(ecp.gt.23.0D0)goto 333
c
c     sum over primitive components
c     ef=exp(-ecp)
c     quadratic interpolation
      jmm=max(1,int(ecp/dtt))
      jm=jmm+1
      jp=jm+1
      tm=dtt*dble(jmm)
      fm2=et(jmm)
      fm=et(jm)
      fp=et(jp)
      aF=(fm2-fm-fm+fp)*dtt2
      b=(fp-fm)/dtt-(tm+tm+dtt)*aF
      c=fm-(aF*tm+b)*tm
      EF=c+ecp*(b+ecp*aF)
      special=npi.ne.npii
      do 4 ipx=1,npi
      b6=cci(ipx)*EF
      goto(101,102,103)nxi(ipx)
      goto 100
101   b6=b6*x
      goto 100
102   b6=b6*xx
      goto 100
103   b6=b6*xxx
100   goto(201,202,203)nyi(ipx)
      goto 200
201   b6=b6*y
      goto 200
202   b6=b6*yy
      goto 200
203   b6=b6*yyy
200   goto(301,302,303)nzi(ipx)
      goto 300
301   b6=b6*z
      goto 300
302   b6=b6*zz
      goto 300
303   b6=b6*zzz
300   if(special)then
       do 74 ioo=1,npii
74     psii=psii+aai(ioo,ipx)*b6*cij(i,io+ioo)
      else
       psii=psii+b6*cij(i,io+ipx)
c      if(i.eq.2)then
c       write(6,*)cij(i,io+ipx),i,ia,io,ipx,npii,b6
c       read(6,*)oooo
c      endif
      endif
4     continue
c
333   continue
      if(ish(ia,ip+1).gt.ish(ia,ip))io=io+npii
3     continue
2     continue
1     rosum=rosum+psii*psii
c      if(istart.eq.2)then
c       write(6,*)rosum,ic1,occup(ic1),rx,ry,rz
c       read(6,*)oooo
c      endif
      rox=rosum*occup(ic1)
      return
      end
