      subroutine froxp(roxp,rx,ry,rz,istart,iend,ic1,ic2,nsign)
c
c     electron density for plotting program (og)
c
c     the elctron density from MOs istart..iend
c     ic1=2 .. double occupied
c     ic1=1 .. singly occupied
c     ic2=0 .. density olnly
c     ic2=1 .. also gradient
c     nsign=1 .. density
c     nsign=-1 ..signed density for orbital plotting
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700)
      integer*4 u0
      parameter (u0=28)
      character*2 at
      character*1 ok,ty
      common/atoms/q(nat0),zsum,xv(3,nat0)
      logical ld5,lf7,lopt,special
      common/opts/lopt(300),icha,n1
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      equivalence (lopt(4),ld5),(lopt(8),lf7)
      dimension occup(2),aad(u0,u0),aaf(u0,u0),aa1(u0,u0),
     1aag(u0,u0),aah(u0,u0),aai(u0,u0),
     1aaii(u0,u0),cci(u0),nxi(u0),nyi(u0),nzi(u0),
     2axs(4),ays(4),azs(4)
      data occup/1.0D0,2.0D0/
c
      if(ic2.eq.1)call report('grad ro not implemented yet')
c
      call initfd(aa1,aad,aaf,aag,aah,aaii)
c
      rosum=z0
      do 1 i=istart,iend
      psii=z0
c
c     MO psi(i)=sum over AOs
c     sum over atoms
      io=0
      do 2 ia=1,noa
      x=rx-xv(1,ia)
      y=ry-xv(2,ia)
      z=rz-xv(3,ia)
      xx=x*x
      yy=y*y
      zz=z*z
      xxx=xx*x
      yyy=yy*y
      zzz=zz*z
      ar2=xx+yy+zz
      axs(1)=one
      axs(2)=x
      axs(3)=xx
      axs(4)=xxx
      ays(1)=one
      ays(2)=y
      ays(3)=yy
      ays(4)=yyy
      azs(1)=one
      azs(2)=z
      azs(3)=zz
      azs(4)=zzz
c
c     sum over primitives
      do 3 ip=1,nop(ia)
      a=alpha(ia,ip)
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
      ecp=a*ar2
      if(ecp.gt.12.0D0)goto 3
      ef=exp(-ecp)
      special=npi.ne.npii
c
      do 4 ipx=1,npi
      b6=cci(ipx)*ef*axs(nxi(ipx)+1)*ays(nyi(ipx)+1)*azs(nzi(ipx)+1)
      if(special)then
       do 74 ioo=1,npii
74     psii=psii+aai(ioo,ipx)*b6*cij(i,io+ioo)
      else
       psii=psii+b6*cij(i,io+ipx)
      endif
4     continue
c
3     if(ish(ia,ip+1).gt.ish(ia,ip))io=io+npii
2     continue
      sign=1.0D0
      if(nsign.eq.-1.and.psii.lt.0.0d0)sign=-1.0D0
1     rosum=rosum+psii*psii*sign
      roxp=rosum*occup(ic1)
      return
      end
c     =================================================================
      subroutine forbxp(orbxp,rx,ry,rz,i)
c
c     orbital i at the point rx,ry,rz
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700)
      integer*4 u0
      parameter (u0=28)
      character*2 at
      character*1 ok,ty
      common/atoms/q(nat0),zsum,xv(3,nat0)
      logical ld5,lf7,lopt,special
      common/opts/lopt(300),icha,n1
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      equivalence (lopt(4),ld5),(lopt(8),lf7)
      dimension aad(u0,u0),aaf(u0,u0),aa1(u0,u0),aag(u0,u0),aah(u0,u0),
     1aaii(u0,u0),cci(u0),nxi(u0),nyi(u0),nzi(u0),aai(u0,u0),
     2axs(4),ays(4),azs(4)
c
      call initfd(aa1,aad,aaf,aag,aah,aaii)
c
      psii=z0
c
c     MO psi(i)=sum over AOs
c
c     sum over atoms
      io=0
      do 2 ia=1,noa
      x=rx-xv(1,ia)
      y=ry-xv(2,ia)
      z=rz-xv(3,ia)
      xx=x*x
      yy=y*y
      zz=z*z
      xxx=xx*x
      yyy=yy*y
      zzz=zz*z
      ar2=xx+yy+zz
      axs(1)=one
      axs(2)=x
      axs(3)=xx
      axs(4)=xxx
      ays(1)=one
      ays(2)=y
      ays(3)=yy
      ays(4)=yyy
      azs(1)=one
      azs(2)=z
      azs(3)=zz
      azs(4)=zzz
c
c     sum over primitives
      do 3 ip=1,nop(ia)
      a=alpha(ia,ip)
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
      ecp=a*ar2
      if(ecp.gt.12.0D0)goto 3
      ef=exp(-ecp)
      special=npi.ne.npii
c
      do 4 ipx=1,npi
      b6=cci(ipx)*ef*axs(nxi(ipx)+1)*ays(nyi(ipx)+1)*azs(nzi(ipx)+1)
      if(special)then
       do 74 ioo=1,npii
74     psii=psii+aai(ioo,ipx)*b6*cij(i,io+ioo)
      else
       psii=psii+b6*cij(i,io+ipx)
      endif
4     continue
c
3     if(ish(ia,ip+1).gt.ish(ia,ip))io=io+npii
2     continue
      orbxp=psii
      return
      end
c     ===============================================
c     =================================================================
c     Function roxpsnell(rx,ry,rz,istart,iend,ic1)
c
c     electron density for plotting program (og) without initialization of fd
c
c     the elctron density from MOs istart..iend
c     ic1=2 .. double occupied
c     ic1=1 .. singly occupied
c
c     implicit real*8 (a-h,o-z)
c     implicit integer*4 (i-n)
c     parameter (nat0=190,nor=80,nort=700)
c     character*2 at
c     character*1 ok,ty
c     common/atoms/q(nat0),zsum,xv(3,nat0)
c     logical ld5,lf7,lopt,special
c     common/opts/lopt(300),icha,n1
c     common/work/escf,
c    2cc(nat0,nor),alpha(nat0,nor),
c    3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
c    4e(nort),be(nort),nat,nao,nmo,
c    5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
c    6nop(nat0),ty(nat0,nor),ish(nat0,nor),
c    7at(nat0),ok
c     common/numbers/z0,one,two,three,four,five,six,half,qua,
c    1a8,a10
c     equivalence (lopt(4),ld5),(lopt(8),lf7)
c     dimension occup(2),
c    1aai(u0,u0),cci(u0),nxi(u0),nyi(u0),nzi(u0),
c    2axs(4),ays(4),azs(4)
c     common/snell/aa1(u0,u0),aad(u0,u0),aaf(u0,u0)
c     data occup/1.0D0,2.0D0/
c
c     rosum=z0
c     do 1 i=istart,iend
c     psii=z0
c
c     MO psi(i)=sum over AOs
c     sum over atoms
c     io=0
c     do 2 ia=1,noa
c     x=rx-xv(1,ia)
c     y=ry-xv(2,ia)
c     z=rz-xv(3,ia)
c     xx=x*x
c     yy=y*y
c     zz=z*z
c     xxx=xx*x
c     yyy=yy*y
c     zzz=zz*z
c     ar2=xx+yy+zz
c     axs(1)=one
c     axs(2)=x
c     axs(3)=xx
c     axs(4)=xxx
c     ays(1)=one
c     ays(2)=y
c     ays(3)=yy
c     ays(4)=yyy
c     azs(1)=one
c     azs(2)=z
c     azs(3)=zz
c     azs(4)=zzz
c
c     sum over primitives
c     do 3 ip=1,nop(ia)
c     a=alpha(ia,ip)
c     call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
c    1aai,aa1,aad,aaf,ld5,lf7,ia,ip)
c     ecp=a*ar2
c     if(ecp.gt.10.0D0)goto 3
c     ef=exp(-ecp)
c     special=npi.ne.npii
c
c     do 4 ipx=1,npi
c     b6=cci(ipx)*ef*axs(nxi(ipx)+1)*ays(nyi(ipx)+1)*azs(nzi(ipx)+1)
c     if(special)then
c      do 74 ioo=1,npii
c74     psii=psii+aai(ioo,ipx)*b6*cij(i,io+ioo)
c     else
c       psii=psii+b6*cij(i,io+ipx)
c      endif
c4     continue
c
c3     if(ish(ia,ip+1).gt.ish(ia,ip))io=io+npii
c2     continue
c1     rosum=rosum+psii*psii
c     roxpsnell=rosum*occup(ic1)
c     return
c     end
c     ===========================================================
      subroutine rosnake(nr,rx,ry,rz,db,istart,iend)
c
c     electron density without initialization of fd, in nr points of r,
c     put it to db
c     the electron density from MOs istart..iend
c     nr0:dimension of the buffer of coordinates
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700,nr0=1000)
      integer*4 u0
      parameter (u0=28)
      character*2 at
      character*1 ok,ty
      common/atoms/q(nat0),zsum,xv(3,nat0)
      logical ld5,lf7,lopt,special
      common/opts/lopt(300),icha,n1
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      equivalence (lopt(4),ld5),(lopt(8),lf7)
      dimension aai(u0,u0),cci(u0),nxi(u0),nyi(u0),nzi(u0)
      common/snell/aa1(u0,u0),aad(u0,u0),aaf(u0,u0),
     1aag(u0,u0),aah(u0,u0),aaii(u0,u0)
      dimension ry(nr),rz(nr),rx(nr),db(nr)
      dimension axs(4,nr0),ays(4,nr0),azs(4,nr0),ar2(nr0),psii(nr0),
     1b6(nr0),ef(nr0)
c
      do 202 ii=1,nr
202   db(ii)=z0
c
c     Loop over molecular orbitals:
      do 1 i=istart,iend
      do 203 ii=1,nr
203   psii(ii)=z0
c
c     MO psi(i)=sum over AOs
c     sum over atoms
      io=0
      do 2 ia=1,noa
      xn=xv(1,ia)
      yn=xv(2,ia)
      zn=xv(3,ia)
      do 200 ii=1,nr
      x=rx(ii)-xn
      y=ry(ii)-yn
      z=rz(ii)-zn
      xx=x*x
      yy=y*y
      zz=z*z
      xxx=xx*x
      yyy=yy*y
      zzz=zz*z
      ar2(ii)=xx+yy+zz
      axs(1,ii)=one
      axs(2,ii)=x
      axs(3,ii)=xx
      axs(4,ii)=xxx
      ays(1,ii)=one
      ays(2,ii)=y
      ays(3,ii)=yy
      ays(4,ii)=yyy
      azs(1,ii)=one
      azs(2,ii)=z
      azs(3,ii)=zz
200   azs(4,ii)=zzz
c
c     sum over primitives
      do 3 ip=1,nop(ia)
      a=alpha(ia,ip)
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
      special=npi.ne.npii
      ic=nr
      do 205 ii=1,nr
      ecp=a*ar2(ii)
      if(ecp.gt.12.0D0)then
       ef(ii)=z0
       ic=ic-1
      else
       ef(ii)=exp(-ecp)
      endif
205   continue
      if(ic.eq.0)goto 3
c
      if(special)then
       do 4 ipx=1,npi
       c1=cci(ipx)
       nx= nxi(ipx)+1
       ny= nyi(ipx)+1
       nz= nzi(ipx)+1
       do 206 ii=1,nr
206    b6(ii)=c1*ef(ii)*axs(nx,ii)*ays(ny,ii)*azs(nz,ii)
       do 74 ioo=1,npii
       c2=aai(ioo,ipx)*cij(i,io+ioo)
       do 74 ii=1,nr
74     psii(ii)=psii(ii)+c2*b6(ii)
4      continue
      else
       do 41 ipx=1,npi
       cciipx=cci(ipx)*cij(i,io+ipx)
       nx= nxi(ipx)+1
       ny= nyi(ipx)+1
       nz= nzi(ipx)+1
       do 201 ii=1,nr
201    psii(ii)=psii(ii)+cciipx*ef(ii)*axs(nx,ii)*ays(ny,ii)*azs(nz,ii)
41     continue
      endif
c
3     if(ish(ia,ip+1).gt.ish(ia,ip))io=io+npii
2     continue
      do 204 ii=1,nr
      dum=psii(ii)
204   db(ii)=db(ii)+(dum+dum)*dum
1     continue
      return
      end
c     =================================================================
      subroutine forbaa(orbaa,maa,i)
c
c     orbital i at the nucleus maa
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700)
      integer*4 u0
      parameter (u0=28)
      character*2 at
      character*1 ok,ty
      common/atoms/q(nat0),zsum,xv(3,nat0)
      logical ld5,lf7,lopt,special
      common/opts/lopt(300),icha,n1
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      equivalence (lopt(4),ld5),(lopt(8),lf7)
      dimension aad(u0,u0),aaf(u0,u0),aa1(u0,u0),aag(u0,u0),aah(u0,u0),
     1aaii(u0,u0),cci(u0),nxi(u0),nyi(u0),nzi(u0),aai(u0,u0),
     2axs(4),ays(4),azs(4)
c
      rx=xv(1,maa)
      ry=xv(2,maa)
      rz=xv(3,maa)
c
      call initfd(aa1,aad,aaf,aag,aah,aaii)
c
      psii=z0
c
c     MO psi(i)=sum over AOs
c
c     sum over atoms
      io=0
      do 2 ia=1,noa
      x=rx-xv(1,ia)
      y=ry-xv(2,ia)
      z=rz-xv(3,ia)
      xx=x*x
      yy=y*y
      zz=z*z
      xxx=xx*x
      yyy=yy*y
      zzz=zz*z
      ar2=xx+yy+zz
      axs(1)=one
      axs(2)=x
      axs(3)=xx
      axs(4)=xxx
      ays(1)=one
      ays(2)=y
      ays(3)=yy
      ays(4)=yyy
      azs(1)=one
      azs(2)=z
      azs(3)=zz
      azs(4)=zzz
c
c     sum over primitives
      do 3 ip=1,nop(ia)
      a=alpha(ia,ip)
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
      ecp=a*ar2
      if(ecp.gt.12.0D0)goto 3
      ef=exp(-ecp)
      special=npi.ne.npii
c
      do 4 ipx=1,npi
      b6=cci(ipx)*ef*axs(nxi(ipx)+1)*ays(nyi(ipx)+1)*azs(nzi(ipx)+1)
      if(special)then
       do 74 ioo=1,npii
74     psii=psii+aai(ioo,ipx)*b6*cij(i,io+ioo)
      else
       psii=psii+b6*cij(i,io+ipx)
      endif
4     continue
c
3     if(ish(ia,ip+1).gt.ish(ia,ip))io=io+npii
2     continue
      orbaa=psii
      return
      end
c     ===========================================================
