      program iwao
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nbuff=400)
      dimension ib(nbuff),jb(nbuff),kb(nbuff),lb(nbuff),bb(nbuff),
     1          iu(nbuff),ju(nbuff),ku(nbuff),lu(nbuff),cc(nbuff)
c
      write(6,*)' Rewrites AO integrals from ROA using a cutoff'
      write(6,*)
      write(6,*)' Cutoff:'
      read(5,*)tol
c
      open(45,file='MPN45.SCR',form='unformatted')
      open(46,file='MPN46.SCR',form='unformatted')
      open(47,file='MPN47.SCR',form='unformatted')
      open(48,file='MPN48.SCR',form='unformatted')
      open(49,file='MPN49.SCR',form='unformatted')
      open(50,file='MPN50.SCR',form='unformatted')
      open(51,file='MPN51.SCR',form='unformatted')
c
      open(65,file='MPN65.SCR',form='unformatted')
      open(66,file='MPN66.SCR',form='unformatted')
      open(67,file='MPN67.SCR',form='unformatted')
      open(68,file='MPN68.SCR',form='unformatted')
      open(69,file='MPN69.SCR',form='unformatted')
      open(70,file='MPN70.SCR',form='unformatted')
      open(71,file='MPN71.SCR',form='unformatted')
c
      ntot=0
      ni=0
c
c     iiii
10    read(45,end=211)n,(bb(i),i=1,n),(ib(i),i=1,n)
      nii=0
      do 201 i=1,n
      ntot=ntot+1
      if(abs(bb(i)).gt.tol)then
       nii=nii+1
       ni=ni+1
       cc(nii)=bb(i)
       iu(nii)=ib(i)
      endif
201   continue
      write(65)nii,(cc(ii),ii=1,nii),(iu(ii),ii=1,nii)
      goto 10
c
c     iiij
211   write(6,*)'iiii'
20    read(46,end=311)n,(bb(i),i=1,n),(ib(i),i=1,n),(jb(i),i=1,n)
      nii=0
      do 202 i=1,n
      ntot=ntot+1
      if(abs(bb(i)).gt.tol)then
       ni=ni+1
       nii=nii+1
       cc(nii)=bb(i)
       iu(nii)=ib(i)
       ju(nii)=jb(i)
      endif
202   continue
      write(66)nii,(cc(ii),ii=1,nii),(iu(ii),ii=1,nii),(ju(ii),ii=1,nii)
      goto 20
c
c     iijj
311   write(6,*)'iiij'
30    read(47,end=411)n,(bb(i),i=1,n),(ib(i),i=1,n),(jb(i),i=1,n)
      nii=0
      do 203 i=1,n
      ntot=ntot+1
      if(abs(bb(i)).gt.tol)then
       ni=ni+1
       nii=nii+1
       cc(nii)=bb(i)
       iu(nii)=ib(i)
       ju(nii)=jb(i)
      endif
203   continue
      write(67)nii,(cc(ii),ii=1,nii),(iu(ii),ii=1,nii),(ju(ii),ii=1,nii)
      goto 30
c
c     ijij
411   write(6,*)'iijj'
40    read(48,end=511)n,(bb(i),i=1,n),(ib(i),i=1,n),(jb(i),i=1,n)
      nii=0
      do 204 i=1,n
      ntot=ntot+1
      if(abs(bb(i)).gt.tol)then
       ni=ni+1
       nii=nii+1
       cc(nii)=bb(i)
       iu(nii)=ib(i)
       ju(nii)=jb(i)
      endif
204   continue
      write(68)nii,(cc(ii),ii=1,nii),(iu(ii),ii=1,nii),(ju(ii),ii=1,nii)
      goto 40
c
c     ijkk
511   write(6,*)'ijij'
50    read(49,end=611)n,(bb(i),i=1,n),(ib(i),i=1,n),(jb(i),i=1,n),
     1                               (kb(i),i=1,n)
      nii=0
      do 205 i=1,n
      ntot=ntot+1
      if(abs(bb(i)).gt.tol)then
       ni=ni+1
       nii=nii+1
       cc(nii)=bb(i)
       iu(nii)=ib(i)
       ju(nii)=jb(i)
       ku(nii)=kb(i)
      endif
205   continue
      write(69)nii,(cc(ii),ii=1,nii),(iu(ii),ii=1,nii),(ju(ii),ii=1,nii)
     1,(ku(ii),ii=1,nii)
      goto 50
c
c     ikjk
611   write(6,*)'ijkk'
60    read(50,end=711)n,(bb(i),i=1,n),(ib(i),i=1,n),(jb(i),i=1,n),
     1                               (kb(i),i=1,n)
      nii=0
      do 206 i=1,n
      ntot=ntot+1
      if(abs(bb(i)).gt.tol)then
       ni=ni+1
       nii=nii+1
       cc(nii)=bb(i)
       iu(nii)=ib(i)
       ju(nii)=jb(i)
       ku(nii)=kb(i)
      endif
206   continue
      write(70)nii,(cc(ii),ii=1,nii),(iu(ii),ii=1,nii),(ju(ii),ii=1,nii)
     1,(ku(ii),ii=1,nii)
      goto 60
c
c     ijkl
711   write(6,*)'ikjk'
70    read(51,end=811)n,(bb(i),i=1,n),(ib(i),i=1,n),(jb(i),i=1,n),
     1                              (kb(i),i=1,n),(lb(i),i=1,n)
      nii=0
      do 207 i=1,n
      ntot=ntot+1
      if(abs(bb(i)).gt.tol)then
       ni=ni+1
       nii=nii+1
       if(nii.gt.nbuff)write(6,*)71
       cc(nii)=bb(i)
       iu(nii)=ib(i)
       ju(nii)=jb(i)
       ku(nii)=kb(i)
       lu(nii)=lb(i)
      endif
207   continue
      write(71)nii,(cc(ii),ii=1,nii),(iu(ii),ii=1,nii),(ju(ii),ii=1,nii)
     1,(ku(ii),ii=1,nii),(lu(ii),ii=1,nii)
      goto 70
c
811   write(6,*)'ijkl'
80    do 4 i=45 ,51
      close(i+20)
4     close(i)
c
      a=100.0d0*dble(ni)/real(ntot)
      write(6,*)ni,ntot,a
      write(6,6000)ni,ntot,a
6000  format(i20,' non-zero integrals of ',i20,' total',/,
     1' (',f12.4,' %) written into MPNXX.SCR')
      stop
      end
