      subroutine makemos2(nao,cij,nmo)
c     transform dipole moments into MOs
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nort=700,nfiles=10)
c     nfiles
c     1 P  dipole
c     2 Q  quadrupole
c     3 L  magnetic r x grad / 2
c     4 V  gradient
c     5 W  magnetic (r-rj) x grad / 2
c     6 T  magnetic (r-rij) x grad / 2
c     7 U  magnetic (r-rj) x grad / 2 * "pop" ab
c     8 C  magnetic (r-rij) x grad / 2* "pop" ab
c     9 D  GIAO like r x rj / 2
c    10 E  GIAO like r x ri / 2
      dimension bao(nort,nort),bmo(nort,nort),
     1btem(nort,nort),cij(nort,nort)
      integer*4   id(nfiles)
      character*5 fn(nfiles)
      character*7 fm
      data id/3        ,6        ,3        ,3        ,3        ,
     1        3        ,3        ,3        ,3        ,3        /
      data fn/'P.SCR'  ,'Q.SCR'  ,'L.SCR'  ,'V.SCR'  ,'W.SCR'  ,
     1        'T.SCR'  ,'U.SCR'  ,'C.SCR'  ,'D.SCR'  ,'E.SCR'  /
      character*1 xyz(3)
      character*2 qxy(6)
      data xyz/'X','Y','Z'/
      data qxy/'XX','XY','XZ','YY','YZ','ZZ'/
      logical ltxt,lopt
      common/opts/lopt(300),icha,n1
      equivalence (lopt(101),ltxt)

c
      do 8 if=1,nfiles
      idim=id(if)
      fm=fn(if)(1:1)//'MO'//fn(if)(2:5)
      write(6,63737)fn(if),fm
63737 format(' Transforming ',a5,' to ',a7,'.')
      open(37,file=fm,form='unformatted')
      open(33,file=fn(if),form='unformatted')
      do 7 ix=1,idim
      rewind 33
      do 6 i=1,nao
      do 5 idu=1,ix-1
5     read(33)
      read(33)(bao(j,i),j=1,nao)
      do 6 idu=ix+1,idim
6     read(33)
      call taomo2(bao,bmo,cij,nort,nort,nmo,nao,btem)
      do 71 i=1,nmo
71    write(37)(bmo(j,i),j=1,nmo)
      if(ltxt)then
       if(idim.eq.3)then
        open(38,file=fn(if)(1:1)//xyz(ix)//'.MO.SCR.TXT')
        call wmtr38(38,bmo,nort,nmo,fn(if)(1:1)//xyz(ix)//' MO',1)
        call w36(fn(if)(1:1)//xyz(ix)//'.MO.SCR.TXT written')
       else
        open(38,file=fn(if)(1:1)//qxy(ix)//'.MO.SCR.TXT')
        call wmtr38(38,bmo,nort,nmo,fn(if)(1:1)//qxy(ix)//' MO',1)
        call w36(fn(if)(1:1)//qxy(ix)//'.MO.SCR.TXT written')
       endif
       close(38)
      endif
7     continue
      close(37)
8     close(33)
c
      return
      end
