      subroutine nknj(nk,nj,nmo)
c     calculate (JJ|KK) and (JK|JK) for a given range, save in common ckkjj
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nort=700,nkkjj0=nort*(nort+1))
      logical lex,lnknj
      common/kkjj/ckkjj(nkkjj0),enknj(nort),lnknj
      dimension hcore(nort,nort),bcore(nort,nort)
c
      write(3,*)'starting nknj',nk,nj
      if(nk.le.0 )call report('nk<=0 ')
      if(nj.le.0 )call report('nk<=0 ')
      if(nj.lt.nk)call report('nj<nk')
      if(nk.gt.nmo)call report('nk>nmo')
      if(nj.gt.nmo)call report('nj>nmo')
      norb=nj-nk+1
      nkkjj=norb*(norb+1)
      if(nkkjj.gt.nkkjj0)call report('nkkjj>nkkjj0')
c
      inquire(file='NKNJ.SCR',exist=lex)
      if(lex)then
       write(3,*)'NKNJ.SCR found'
       open(23,file='NKNJ.SCR',form='unformatted')
       read(23)nkr,njr
       if(nk.ne.nkr.or.nj.ne.njr)call report('wrong NKNJ.SCR')
       read(23)(ckkjj(i),i=1,nkkjj),(enknj(i),i=1,nj-nk+1)
       close(23)
       return
      endif
c
      lnknj=.true.
c     compute density matrices
      call comdenm
c     compute core hamiltonian::q
      call tep
c     transform it to mo:
      call tepmo
c     read it in:
      open(33,file='CORE.SCR',form='unformatted',status='old')
      read(33)((hcore(i,j),i=1,nmo),j=1,nmo)
      read(33)((bcore(i,j),i=1,nmo),j=1,nmo)
      read(33)((hcore(i,j),i=1,nmo),j=1,nmo)
      read(33)((bcore(i,j),i=1,nmo),j=1,nmo)
      read(33)((hcore(i,j),i=1,nmo),j=1,nmo)
      read(33)((bcore(i,j),i=1,nmo),j=1,nmo)
      close(33)
c     init orbital energies:
      do i=1,nj-nk+1
       enknj(i)=hcore(i+nk-1,i+nk-1)
      enddo
c
      call dox31
c
      open(23,file='NKNJ.SCR',form='unformatted')
      write(23)nk,nj
      write(23)(ckkjj(i),i=1,nkkjj),(enknj(i),i=1,nj-nk+1)
      close(23)
      write(6,*)'NKNJ.SCR written'
      write(3,*)'NKNJ.SCR written'
c
      return
      end
