      function oce2(nxi,nyi,nzi,nxj,nyj,nzj,nxk,nyk,nzk,nxl,nyl,nzl,
     1xij,yij,zij,xkl,ykl,zkl,pqx,pqy,pqz, hsp,hsq,aa,bb,cc,dd,
     2mmx,eep,atol,lsx,lsy,lsz)
c
c      the coulomb integral (ij||kl) (AO) by the eight-term reccurence
c     relationship
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
c
      parameter (mmax=21,lx4=1000)
c
      dimension nm(12,lx4),mp(lx4),mt(lx4),nu(12),nmil(12)
      logical lopt,l333,nosym,tight,lsx,lsy,lsz
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/opts/lopt(300),icha,n1
      equivalence (lopt(33),l333),(lopt(34),nosym),(lopt(35),tight)
      dimension eep(mmax),eeq(mmax),p(lx4),id(lx4),
     1issn(12)
      dimension w(15),ihsp(12),itobb(12),itocb(12),
     1itodb(12),irib(12),ibbb(12),ixb(12),rl(3)
      logical lic
      data issn/1,4,16,64,256,1024,4096,16384,65536,262144,1048576,
     14194304/
      data rl/1.0d0,2.0d0,3.0d0/
      data ihsp /10,10,10, 10,10,10, 11,11,11, 11,11,11/
      data itobb/ 4, 5, 6,  1, 2, 3, 10,11,12,  7, 8, 9/
      data itocb/ 7, 8, 9,  7, 8, 9,  1, 2, 3,  1, 2, 3/
      data itodb/10,11,12, 10,11,12,  4, 5, 6,  4, 5, 6/
      data irib / 7, 8, 9,  7, 8, 9, -7,-8,-9, -7,-8,-9/
      data ibbb /13,13,13, 12,12,12, 15,15,15, 14,14,14/
      data ixb  / 1, 2, 3, -1,-2,-3,  4, 5, 6, -4,-5,-6/
      data i224/16777216/
c
c
      if(mmx.eq.0)then
       oce2=eep(1)
       return
      endif
c
      oce2=0.0d0
c
      if(.not.nosym)then
       if(lsx)then
        mx=nxi+nxj+nxk+nxl
        mx2=mx/2
        if(mx2+mx2.ne.mx)return
       endif
       if(lsy)then
        my=nyi+nyj+nyk+nyl
        my2=my/2
        if(my2+my2.ne.my)return
       endif
       if(lsz)then
        mz=nzi+nzj+nzk+nzl
        mz2=mz/2
        if(mz2+mz2.ne.mz)return
       endif
      endif
c
      do 4444 ii=1,mmx+1
4444  eeq(ii)=z0
c
      l=1
      p(1)=one
      nu( 1)=nxi
      nu( 2)=nyi
      nu( 3)=nzi
      nu( 4)=nxj
      nu( 5)=nyj
      nu( 6)=nzj
      nu( 7)=nxk
      nu( 8)=nyk
      nu( 9)=nzk
      nu(10)=nxl
      nu(11)=nyl
      nu(12)=nzl
      do 4 ii=1,12
4     nm(ii,1)=nu(ii)
c
c     mp is the kind of the error function + 1 (!!!!)
c     mt is sum of momenta
c     id: indentification number, for each [ab|cd](m), m included as m*2^24
      id(1)=nxi+4*(nyi+4*(nzi+4*(nxj+4*(nyj+4*(nzj+
     14*(nxk+4*(nyk+4*(nzk+4*(nxl+4*(nyl+4*nzl))))))))))
      mp(1)=1
      mt(1)=mmx
      w( 1)=xij
      w( 2)=yij
      w( 3)=zij
      w( 4)=xkl
      w( 5)=ykl
      w( 6)=zkl
      w( 7)=pqx
      w( 8)=pqy
      w( 9)=pqz
      w(10)=hsp
      w(11)=hsq
      w(12)=aa
      w(13)=bb
      w(14)=cc
      w(15)=dd
c
      asiani=hsp*hsq
c
c     look at all indices:
      do 1 itoa=1,12
      if(nu(itoa).gt.0)THEN
c
c     expand (A+1 b cd)
      asi=w(ihsp(itoa))
      itob=itobb(itoa)
      itoc=itocb(itoa)
      itod=itodb(itoa)
      iri=irib(itoa)
      riasi=w(abs(iri))*asi
      if(iri.lt.0)riasi=-riasi
      ix=ixb(itoa)
      tbe=w(ibbb(itoa))*w(abs(ix))*asi
      if(ix.lt.0)tbe=-tbe
      iid=issn(itoa)
c
      istart=1
50    lic=.false.
      newl=l
c
c     look over all current expantion terms (ijkl)(m)
      do 3 il=istart,l
      if(nm(itoa,il).gt.0)then
c
c      expand [a+1i ...](m) if a+1>0
c
c      ID for [ab|cd](m)
       ida=id(il)-iid
c
c      write abcd into temporary buffer and record mp,m
       do 5 io=1,12
5      nmil(io)=nm(io,il)
       nai=nmil(itoa)
       nbi=nmil(itob)
       nci=nmil(itoc)
       ndi=nmil(itod)
       naim=nai-1
       nmil(itoa)=naim
       if(nai.gt.1)then
        if(.not.lic)then
         istart=il
         lic=.true.
        endif
       endif
       pold=p(il)
       mpold=mp(il)
       mpoldp=mpold+1
       mold=mt(il)
       moldm=mold-1
       moldmm=moldm-1
c  (8)
       if(ndi.gt.0)then
        p1=pold*rl(ndi)*asiani
        if(mold.eq.2)then
c        take off the term [00|00][m]
         eeq(mpoldp)=eeq(mpoldp)+p1
        else
c
c        ID for [ab|cd-1](m+1)
         idd=ida-issn(itod)+i224
c        look, if it already exists
         do 80 i1=newl,1,-1
         if(idd.eq.id(i1))then
          p(i1)=p(i1)+p1
          goto 81
         endif
80       continue
         newl=newl+1
         p(newl)=p1
         id(newl)=idd
         mt(newl)=moldmm
         mp(newl)=mpoldp
         do io=1,12
          nm(io,newl)=nmil(io)
         enddo
         nm(itod,newl)=nmil(itod)-1
81       continue
        endif
       endif
c  (7)
       if(nci.gt.0)then
        p1=pold*rl(nci)*asiani
        if(mold.eq.2)then
c        take off the term [00|00][m]
         eeq(mpoldp)=eeq(mpoldp)+p1
        else
c
c        ID for [ab|c-1d](m+1)
         idd=ida-issn(itoc)+i224
         do 82 i1=newl,1,-1
         if(idd.eq.id(i1))then
          p(i1)=p(i1)+p1
          goto 83
         endif
82       continue
         newl=newl+1
         p(newl)=p1
         id(newl)=idd
         mt(newl)=moldmm
         mp(newl)=mpoldp
         do io=1,12
          nm(io,newl)=nmil(io)
         enddo
         nm(itoc,newl)=nmil(itoc)-1
83       continue
        endif
       endif
c  (6,5)
       if(nbi.gt.0)then
        p1=pold*rl(nbi)*asi
        p2=-p1*asi
        if(mold.eq.2)then
c        take off the terms [00|00][m]
         eeq(mpold)=eeq(mpold)+p1
         eeq(mpoldp)=eeq(mpoldp)+p2
        else
c
c        ID for [ab-1|cd](m)
         idd1=ida-issn(itob)
         do 72 i1=newl,1,-1
         if(idd1.eq.id(i1))then
          p(i1)=p(i1)+p1
          goto 73
         endif
72       continue
         newl=newl+1
         p(newl)=p1
         id(newl)=idd1
         mp(newl)=mpold
         mt(newl)=moldmm
         do io=1,12
          nm(io,newl)=nmil(io)
         enddo
         nm(itob,newl)=nmil(itob)-1
73       continue
c
c        ID for [ab-1|cd](m+1)
         idd=idd1+i224
         do 74 i1=newl,1,-1
         if(idd.eq.id(i1))then
          p(i1)=p(i1)+p2
          goto 75
         endif
74       continue
         newl=newl+1
         p(newl)=p2
         id(newl)=idd
         mp(newl)=mpoldp
         mt(newl)=moldmm
         do io=1,12
          nm(io,newl)=nmil(io)
         enddo
         nm(itob,newl)=nmil(itob)-1
75       continue
        endif
       endif
c  (4,3)
       if(nai.gt.1)then
        p1=pold*rl(naim)*asi
        p2=-p1*asi
        if(mold.eq.2)then
c        take off the terms [00|00][m], [00|00][m+1]
         eeq(mpold)=eeq(mpold)+p1
         eeq(mpoldp)=eeq(mpoldp)+p2
        else
c
c        ID for [a-1b|cd](m)
         idd=ida-iid
         do 76 i1=newl,1,-1
         if(idd.eq.id(i1))then
          p(i1)=p(i1)+p1
          goto 77
         endif
76       continue
         newl=newl+1
         p(newl)=p1
         id(newl)=idd
         mp(newl)=mpold
         mt(newl)=moldmm
         do 6 io=1,12
6        nm(io,newl)=nmil(io)
         nm(itoa,newl)=nmil(itoa)-1
77       continue
c
c        ID for [a-1b|cd](m+1)
         idd=ida-iid+i224
         do 78 i1=newl,1,-1
         if(idd.eq.id(i1))then
          p(i1)=p(i1)+p2
          goto 79
         endif
78       continue
         newl=newl+1
         p(newl)=p2
         id(newl)=idd
         mp(newl)=mpoldp
         mt(newl)=moldmm
         do 7 io=1,12
7        nm(io,newl)=nmil(io)
         nm(itoa,newl)=nmil(itoa)-1
79       continue
        endif
       endif
c
c  (2)
       p1=pold*riasi
       if(abs(p1).gt.atol)then
        if(mold.eq.1)then
c        take off the term [00|00][m+1]
         eeq(mpoldp)=eeq(mpoldp)+p1
        else
c
c        ID for [ab|cd](m+1)
         idd=ida+i224
         do 70 i1=newl,1,-1
         if(idd.eq.id(i1))then
          p(i1)=p(i1)+p1
          goto 71
         endif
70       continue
         newl=newl+1
         p(newl)=p1
         id(newl)=idd
         mp(newl)=mpoldp
         mt(newl)=moldm
         do 8 io=1,12
8        nm(io,newl)=nmil(io)
71       continue
        endif
       endif
c  (1)
c
c      ID for [ab|cd](m)
       p1=pold*tbe
       if(mold.eq.1)then
        eeq(mpold)=eeq(mpold)+p1
        goto 300
       endif
       if(abs(p1).lt.atol)goto 300
       do 68 i1=newl,1,-1
       if(ida.eq.id(i1))then
        if(i1.ne.il)then
         p(i1)=p(i1)+p1
         goto 300
        endif
       endif
68     continue
c
c      accept it:
       id(il)=ida
       p(il)=p1
       mt(il)=moldm
c      mp(il)the same
       nm(itoa,il)=naim
      endif
3     continue
      goto 301
c
c     get rid of the il term outside the loop 3
300   do 302 i1=il,newl-1
      ip=i1+1
      p (i1)=p (ip)
      id(i1)=id(ip)
      mp(i1)=mp(ip)
      mt(i1)=mt(ip)
      do 302 io=1,12
302   nm(io,i1)=nm(io,ip)
      newl=newl-1
      if(.not.lic)then
       istart=il
       lic=.true.
      endif
301   l=newl
      if(l+8.ge.lx4)goto 9999
      if(lic)goto 50
c
      ENDIF
1     continue
c
      sum=z0
      do 2 i1=1,mmx+1
2     sum=sum+eeq(i1)*eep(i1)
      oce2=sum
      return
c
9999  write(3,3001) nxi,nyi,nzi,nxj,nyj,nzj,nxk,nyk,nzk,nxl,nyl,nzl,
     1xij,yij,zij,xkl,ykl,zkl,pqx,pqy,pqz, hsp,hsq,aa,bb,cc,dd,
     2mmx,eep(1),atol,lsx,lsy,lsz
      write(3,*)lsx,lsy,lsz
      do ll=1,l
       write(3,8000)ll,(nm(io,ll),io=1,12),mp(ll),mt(ll)
8000   format(i4,12i2,2i5)
      enddo
3001  format(      'nxi,nyi,nzi,nxj,nyj,nzj,nxk,nyk,nzk,nxl,nyl,nzl',/,
     14(1x,3i2),/,
     2'xij,yij,zij,xkl,ykl,zkl,pqx,pqy,pqz, hsp,hsq,aa,bb,cc,dd,',/,
     33(3f12.6,/),/,
     32f12.6,/,4f12.6,/,
     4'mmx,eep(1),atol,lsx,lsy,lsz',/,
     5i3,2f10.5,3l2)
      call report('expansion overflow in oce2 - OS RR')
      end
