      subroutine oce5(nxi,nyi,nzi,nxj,nyj,nzj,nxk,nyk,nzk,nxl,nyl,nzl,
     1xij,yij,zij,xkl,ykl,zkl,pqx,pqy,pqz, hsp,hsq,aa,bb,cc,dd,
     2mmx,eep,atol,npbstart,npbend,o4d)
c
c     The coulomb integral (ij||kl) (AO) by the eight-term reccurence
c     relationship - make several primitive integrals at once
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
c
      parameter (mmax=21,lx4=1000,npb0=10000,npbe=500)
c
      integer*4 nm(12*lx4),mp(lx4),mt(lx4),nu(12),nmil(12),
     1nai,nbi,nci,ndi,mold,mpold,i1z0,i1z1,i1z2
c
      logical lic,l_R
      dimension id(2,lx4),issn(12),w(6),ihsp(12),itobb(12),
     1itocb(12),itodb(12),irib(12),ibbb(12),ixb(12),rl(3)
      dimension pqx(npb0),pqy(npb0),pqz(npb0),hsp(npb0),hsq(npb0),
     1aa(npb0),bb(npb0),cc(npb0),dd(npb0),eep(npb0,mmax)
      dimension ww(npbe*15),P(npbe*lx4),p1(npbe),p2(npbe),
     1riasi(npbe),tbe(npbe),pold(npbe),eeq(npbe*mmax),o4d(npbe),
     2asiani(npbe),asi(npbe)
c
c
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      data issn/1,3,36,216,1296,7776,1,3,36,216,1296,7776/
      data rl/1.0d0,2.0d0,3.0d0/
      data ihsp/10,10,10, 10,10,10, 11,11,11, 11,11,11/
      data itobb/ 4, 5, 6,  1, 2, 3, 10,11,12,  7, 8, 9/
      data itocb/ 7, 8, 9,  7, 8, 9,  1, 2, 3,  1, 2, 3/
      data itodb/10,11,12, 10,11,12,  4, 5, 6,  4, 5, 6/
      data irib / 7, 8, 9,  7, 8, 9, -7,-8,-9, -7,-8,-9/
      data ibbb /13,13,13, 12,12,12, 15,15,15, 14,14,14/
      data ixb  / 1, 2, 3, -1,-2,-3,  4, 5, 6, -4,-5,-6/
      data i1z0,i1z1,i1z2/0,1,2/
      data i66/46656/
c
      if(mmx.eq.0)then
       do ii=npbstart,npbend
        o4d(ii-npbstart+1)=eep(ii,1)
       enddo
       return
      endif
c
      do ii=npbstart,npbend
       o4d(ii-npbstart+1)=z0
      enddo
c
      l=1
c
      npbt=npbend-npbstart+1
      do 4444 ii=1,(mmx+1)*npbt
4444  eeq(ii)=z0
c
      nu( 1)=nxi
      nu( 2)=nyi
      nu( 3)=nzi
      nu( 4)=nxj
      nu( 5)=nyj
      nu( 6)=nzj
      nu( 7)=nxk
      nu( 8)=nyk
      nu( 9)=nzk
      nu(10)=nxl
      nu(11)=nyl
      nu(12)=nzl
      do ii=1,12
       nm(ii)=nu(ii)
      enddo
      mt(1)=mmx
      w( 1)=xij
      w( 2)=yij
      w( 3)=zij
      w( 4)=xkl
      w( 5)=ykl
      w( 6)=zkl
      npbt7 = 6*npbt
      npbt8 = npbt7 +npbt
      npbt9 = npbt8 +npbt
      npbt10= npbt9 +npbt
      npbt11= npbt10+npbt
      npbt12= npbt11+npbt
      npbt13= npbt12+npbt
      npbt14= npbt13+npbt
      npbt15= npbt14+npbt
      do ii=1,npbt
       P(ii)=one
       ww(ii+npbt7)=pqx(ii+npbstart-1)
       ww(ii+npbt8)=pqy(ii+npbstart-1)
       ww(ii+npbt9)=pqz(ii+npbstart-1)
       ww(ii+npbt10)=hsp(ii+npbstart-1)
       ww(ii+npbt11)=hsq(ii+npbstart-1)
       ww(ii+npbt12)=aa(ii+npbstart-1)
       ww(ii+npbt13)=bb(ii+npbstart-1)
       ww(ii+npbt14)=cc(ii+npbstart-1)
       ww(ii+npbt15)=dd(ii+npbstart-1)
       asiani(ii)=hsp(ii+npbstart-1)*hsq(ii+npbstart-1)
      enddo
c
c     mp is the kind of the error function + 1 (!!!!)
      mp(1)=i1z1
c
c     ID: indentification numbers, for each [ab|cd](m), m included as m*6^6
c     by this only s,p,d,f,g,h functions can be indexed
c     id(1,     for   ( |             id(2,     for  | )
      id(1,1)=nxi+6*(nyi+6*(nzi+6*(nxj+6*(nyj+6*nzj))))
      id(2,1)=nxk+6*(nyk+6*(nzk+6*(nxl+6*(nyl+6*nzl))))
c
c
      do 1 itoa=1,12
      if(nu(itoa).gt.i1z0)THEN
      iri=irib(itoa)
      iriabs=abs(iri)
      ii1=ihsp(itoa)
      itob=itobb(itoa)
      itoc=itocb(itoa)
      itod=itodb(itoa)
      ix=ixb(itoa)
      ixabs=abs(ix)
      ii3=ibbb(itoa)
      iid=issn(itoa)
      iid2=(itoa-1)/6+1
      l_R=.false.
      RX=w(ixabs)
      i11=(ii1-1)*npbt
      i33=(ii3-1)*npbt
      irr=(iriabs-1)*npbt
      do ii=1,npbt
       asic=ww(ii+i11)
       asi(ii)=asic
       riasi(ii)=ww(ii+irr)*asic
       if(abs(riasi(ii)).gt.atol)l_R=.true.
       tbe(ii)=ww(ii+i33)*RX*asic
      enddo
      if(iri.lt.0)then
       do ii=1,npbt
        riasi(ii)=-riasi(ii)
       enddo
      endif
      if(ix.lt.0)then
       do ii=1,npbt
        tbe(ii)=-tbe(ii)
       enddo
      endif
c
      istart=1
50    lic=.false.
      newl=l
      do 3 il=istart,l
      if(nm(itoa+(il-1)*12).gt.i1z0)then
c
c      expand [a+1i ...](m)
c
c      IDs for [ab|cd](m)
       ida1=id(1,il)
       ida2=id(2,il)
       if(iid2.eq.1)then
        ida1=ida1-iid
       else
        ida2=ida2-iid
       endif
c
c      write abcd into temporary buffer and record mp,m
       do ii=1,12
        nmil(ii)=nm(ii+12*(il-1))
       enddo
       nai=nmil(itoa)
       nbi=nmil(itob)
       nci=nmil(itoc)
       ndi=nmil(itod)
       naim=nai-i1z1
       nmil(itoa)=naim
       if(nai.gt.i1z1)then
        if(.not.lic)then
         istart=il
         lic=.true.
        endif
       endif
       isr=(il-1)*npbt
       do ii=1,npbt
        pold(ii)=P(ii+isr)
       enddo
       mpold=mp(il)
       mpoldp=mpold+i1z1
       mold=mt(il)
       moldm=mold-i1z1
       moldmm=moldm-i1z1
c  (8)
       if(ndi.gt.i1z0)then
        rlndi=rl(ndi)
        do ii=1,npbt
         p1(ii)=pold(ii)*rlndi*asiani(ii)
        enddo
        if(mold.eq.i1z2)then
c        take off the term [00|00][m]
         isr=(mpoldp-1)*npbt
         do ii=1,npbt
          eeq(isr+ii)=eeq(isr+ii)+p1(ii)
         enddo
        else
c
c        ID for [ab|cd-1](m+1)
         idd1=ida1+i66
         idd2=ida2+i66
         if(iid2.eq.1)then
          idd2=idd2-issn(itod)
         else
          idd1=idd1-issn(itod)
         endif
c        look, if it already exists
         do 80 i1=newl,1,-1
         if(idd1.eq.id(1,i1).and.idd2.eq.id(2,i1))then
          isr=(i1-1)*npbt
          do ii=1,npbt
           P(ii+isr)=P(ii+isr)+p1(ii)
          enddo
          goto 81
         endif
80       continue
         newl=newl+1
         isr=(newl-1)*npbt
         do ii=1,npbt
          P(ii+isr)=p1(ii)
         enddo
         id(1,newl)=idd1
         id(2,newl)=idd2
         mt(newl)=moldmm
         mp(newl)=mpoldp
         do ii=1,12
          nm(ii+(newl-1)*12)=nmil(ii)
         enddo
         nm(itod+(newl-1)*12)=nmil(itod)-i1z1
81       continue
        endif
       endif
c  (7)
       if(nci.gt.i1z0)then
        rlnci=rl(nci)
        do ii=1,npbt
         p1(ii)=pold(ii)*rlnci*asiani(ii)
        enddo
        if(mold.eq.i1z2)then
c        take off the term [00|00][m]
         isr=(mpoldp-1)*npbt
         do ii=1,npbt
          eeq(isr+ii)=eeq(isr+ii)+p1(ii)
         enddo
        else
c
c        ID for [ab|c-1d](m+1)
         idd1=ida1+i66
         idd2=ida2+i66
         if(iid2.eq.1)then
          idd2=idd2-issn(itoc)
         else
          idd1=idd1-issn(itoc)
         endif
         do 82 i1=newl,1,-1
         if(idd1.eq.id(1,i1).and.idd2.eq.id(2,i1))then
          isr=(i1-1)*npbt
          do ii=1,npbt
           P(ii+isr)=P(ii+isr)+p1(ii)
          enddo
          goto 83
         endif
82       continue
         newl=newl+1
         isr=(newl-1)*npbt
         do ii=1,npbt
          p(ii+isr)=p1(ii)
         enddo
         id(1,newl)=idd1
         id(2,newl)=idd2
         mt(newl)=moldmm
         mp(newl)=mpoldp
         do ii=1,12
          nm(ii+(newl-1)*12)=nmil(ii)
         enddo
         nm(itoc+(newl-1)*12)=nmil(itoc)-i1z1
83       continue
        endif
       endif
c  (6,5)
       if(nbi.gt.i1z0)then
        rlnbi=rl(nbi)
        do ii=1,npbt
         p1(ii)=pold(ii)*rlnbi*asi(ii)
         p2(ii)=-p1(ii)*asi(ii)
        enddo
        if(mold.eq.i1z2)then
c        take off the terms [00|00][m]
         istart1=(mpold -1)*npbt
         istart2=(mpoldp-1)*npbt
         do ii=1,npbt
          eeq(ii+istart1)=eeq(ii+istart1)+p1(ii)
          eeq(ii+istart2)=eeq(ii+istart2)+p2(ii)
         enddo
        else
c
c        ID for [ab-1|cd](m)
         idd11=ida1 
         idd12=ida2 
         if(iid2.eq.1)then
          idd11=idd11-issn(itob)
         else
          idd12=idd12-issn(itob)
         endif
         do 72 i1=newl,1,-1
         if(idd11.eq.id(1,i1).and.idd12.eq.id(2,i1))then
          isr=(i1-1)*npbt
          do ii=1,npbt
           P(ii+isr)=P(ii+isr)+p1(ii)
          enddo
          goto 73
         endif
72       continue
         newl=newl+1
         isr=(newl-1)*npbt
         do ii=1,npbt
          P(ii+isr)=p1(ii)
         enddo
         id(1,newl)=idd11
         id(2,newl)=idd12
         mp(newl)=mpold
         mt(newl)=moldmm
         do ii=1,12
          nm(ii+(newl-1)*12)=nmil(ii)
         enddo
         nm(itob+(newl-1)*12)=nmil(itob)-i1z1
73       continue
c
c        ID for [ab-1|cd](m+1)
         idd1=idd11+i66
         idd2=idd12+i66
         do 74 i1=newl,1,-1
         if(idd1.eq.id(1,i1).and.idd2.eq.id(2,i1))then
          isr=(i1-1)*npbt
          do ii=1,npbt
           P(ii+isr)=P(ii+isr)+p2(ii)
          enddo
          goto 75
         endif
74       continue
         newl=newl+1
         isr=(newl-1)*npbt
         do ii=1,npbt
          p(ii+isr)=p2(ii)
         enddo
         id(1,newl)=idd1
         id(2,newl)=idd2
         mp(newl)=mpoldp
         mt(newl)=moldmm
         do ii=1,12
          nm(ii+(newl-1)*12)=nmil(ii)
         enddo
         nm(itob+(newl-1)*12)=nmil(itob)-i1z1
75       continue
        endif
       endif
c  (4,3)
       if(nai.gt.i1z1)then
        rlnaim=rl(naim)
        do ii=1,npbt
         p1(ii)=pold(ii)*rlnaim*asi(ii)
         p2(ii)=-p1(ii)*asi(ii)
        enddo
        if(mold.eq.i1z2)then
c        take off the terms [00|00][m]
         istart1=(mpold -1)*npbt
         istart2=(mpoldp-1)*npbt
         do ii=1,npbt
          eeq(ii+istart1)=eeq(ii+istart1)+p1(ii)
          eeq(ii+istart2)=eeq(ii+istart2)+p2(ii)
         enddo
        else
c
c        ID for [a-1b|cd](m)
         idd1=ida1-iid
         idd2=ida2
         do 76 i1=newl,1,-1
         if(idd1.eq.id(1,i1).and.idd2.eq.id(2,i1))then
          isr=(i1-1)*npbt
          do ii=1,npbt
           P(ii+isr)=P(ii+isr)+p1(ii)
          enddo
          goto 77
         endif
76       continue
         newl=newl+1
         isr=(newl-1)*npbt
         do ii=1,npbt
          P(ii+isr)=p1(ii)
         enddo
         id(1,newl)=idd1
         id(2,newl)=idd2
         mp(newl)=mpold
         mt(newl)=moldmm
         do ii=1,12
          nm(ii+(newl-1)*12)=nmil(ii)
         enddo
         nm(itoa+(newl-1)*12)=nmil(itoa)-i1z1
77       continue
c
c        ID for [a-1b|cd](m+1)
         idd1=ida1-iid+i66
         idd2=ida2+i66
         do 78 i1=newl,1,-1
         if(idd1.eq.id(1,i1).and.idd2.eq.id(2,i1))then
          isr=(i1-1)*npbt
          do ii=1,npbt
           P(ii+isr)=P(ii+isr)+p2(ii)
          enddo
          goto 79
         endif
78       continue
         newl=newl+1
         isr=(newl-1)*npbt
         do ii=1,npbt
          p(ii+isr)=p2(ii)
         enddo
         id(1,newl)=idd1
         id(2,newl)=idd2
         mp(newl)=mpoldp
         mt(newl)=moldmm
         do ii=1,12
          nm(ii+(newl-1)*12)=nmil(ii)
         enddo
         nm(itoa+(newl-1)*12)=nmil(itoa)-i1z1
79       continue
        endif
       endif
c
c  (2)
       do ii=1,npbt
        p1(ii)=pold(ii)*riasi(ii)
       enddo
       if(l_R)then
        if(mold.eq.i1z1)then
c        take off the term [00|00][m]
         isr=(mpoldp-1)*npbt
         do ii=1,npbt
          eeq(ii+isr)=eeq(ii+isr)+p1(ii)
         enddo
        else
c
c        ID for [ab|cd](m+1)
         idd1=ida1+i66
         idd2=ida2+i66
         do 70 i1=newl,1,-1
         if(idd1.eq.id(1,i1).and.idd2.eq.id(2,i1))then
          isr=(i1-1)*npbt
          do ii=1,npbt
           P(ii+isr)=P(ii+isr)+p1(ii)
          enddo
          goto 71
         endif
70       continue
         newl=newl+1
         isr=(newl-1)*npbt
         do ii=1,npbt
          P(ii+isr)=p1(ii)
         enddo
         id(1,newl)=idd1
         id(2,newl)=idd2
         mp(newl)=mpoldp
         mt(newl)=moldm
         do ii=1,12
          nm(ii+(newl-1)*12)=nmil(ii)
         enddo
71       continue
        endif
       endif
c  (1)
c
c      ID for [ab|cd](m)
       do ii=1,npbt
        p1(ii)=pold(ii)*tbe(ii)
       enddo
       if(mold.eq.i1z1)then
        isr=(mpold-1)*npbt
        do ii=1,npbt
         eeq(ii+isr)=eeq(ii+isr)+p1(ii)
        enddo
        goto 300
       endif
       if(abs(RX).lt.atol)goto 300
       do 68 i1=newl,1,-1
       if(ida1.eq.id(1,i1).and.ida2.eq.id(2,i1))then
        if(i1.ne.il)then
         isr=(i1-1)*npbt
         do ii=1,npbt
          P(ii+isr)=P(ii+isr)+p1(ii)
         enddo
         goto 300
        endif
       endif
68     continue
       id(1,il)=ida1
       id(2,il)=ida2
       isr=(il-1)*npbt
       do ii=1,npbt
        P(ii+isr)=p1(ii)
       enddo
       mt(il)=moldm
c      mp(il)the same
       nm(itoa+(il-1)*12)=naim
      endif
3     continue
      goto 301
300   do 302 i1=il,newl-1
      ip=i1+1
      isr=(i1-1)*npbt
      isr2=(ip-1)*npbt
      do ii=1,npbt
       P(ii+isr)=p(ii+isr2)
      enddo
      id(1,i1)=id(1,ip)
      id(2,i1)=id(2,ip)
      mp(i1)=mp(ip)
      mt(i1)=mt(ip)
      do 302 ii=1,12
302   nm(ii+(i1-1)*12)=nm(ii+(ip-1)*12)
      newl=newl-1
      if(.not.lic)then
       istart=il
       lic=.true.
      endif
301   l=newl
      if(l+8.ge.lx4)goto 9999
      if(lic)goto 50
c
      ENDIF
1     continue
c
      do 2 i1=1,mmx+1
      isr=(i1-1)*npbt
      do 2 ii=1,npbt
2     o4d(ii)=o4d(ii)+eeq(ii+isr)*eep(ii+npbstart-1,i1)
      return
9999  call report('expansion overflow in ocE5 - OS RR')
      end
