      subroutine osnake(i,nr,rx,ry,rz,db)
c
c     amplitude of orbital i
c     without initialization of fd, in nr points of r,
c     put it to db
c     nr0:dimension of the buffer of coordinates
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700,nr0=1000)
      integer*4 u0
      parameter (u0=28)
      character*2 at
      character*1 ok,ty
      common/atoms/q(nat0),zsum,xv(3,nat0)
      logical ld5,lf7,lopt,special
      common/opts/lopt(300),icha,n1
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      equivalence (lopt(4),ld5),(lopt(8),lf7)
      dimension aai(u0,u0),cci(u0),nxi(u0),nyi(u0),nzi(u0)
      common/snell/aa1(u0,u0),aad(u0,u0),aaf(u0,u0)
      dimension ry(nr),rz(nr),rx(nr),db(nr)
      dimension axs(4,nr0),ays(4,nr0),azs(4,nr0),ar2(nr0),psii(nr0),
     1b6(nr0),ef(nr0)
c
c
      do 203 ii=1,nr
203   psii(ii)=z0
c
c     MO psi(i)=sum over AOs
c     sum over atoms
      io=0
      do 2 ia=1,noa
      xn=xv(1,ia)
      yn=xv(2,ia)
      zn=xv(3,ia)
      do 200 ii=1,nr
      x=rx(ii)-xn
      y=ry(ii)-yn
      z=rz(ii)-zn
      xx=x*x
      yy=y*y
      zz=z*z
      xxx=xx*x
      yyy=yy*y
      zzz=zz*z
      ar2(ii)=xx+yy+zz
      axs(1,ii)=one
      axs(2,ii)=x
      axs(3,ii)=xx
      axs(4,ii)=xxx
      ays(1,ii)=one
      ays(2,ii)=y
      ays(3,ii)=yy
      ays(4,ii)=yyy
      azs(1,ii)=one
      azs(2,ii)=z
      azs(3,ii)=zz
200   azs(4,ii)=zzz
c
c     sum over primitives
      do 3 ip=1,nop(ia)
      a=alpha(ia,ip)
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,ld5,lf7,ia,ip)
      special=npi.ne.npii
      ic=nr
      do 205 ii=1,nr
      ecp=a*ar2(ii)
      if(ecp.gt.12.0D0)then
       ef(ii)=z0
       ic=ic-1
      else
       ef(ii)=exp(-ecp)
      endif
205   continue
      if(ic.eq.0)goto 3
c
      if(special)then
       do 4 ipx=1,npi
       c1=cci(ipx)
       nx= nxi(ipx)+1
       ny= nyi(ipx)+1
       nz= nzi(ipx)+1
       do 206 ii=1,nr
206    b6(ii)=c1*ef(ii)*axs(nx,ii)*ays(ny,ii)*azs(nz,ii)
       do 74 ioo=1,npii
       c2=aai(ioo,ipx)*cij(i,io+ioo)
       do 74 ii=1,nr
74     psii(ii)=psii(ii)+c2*b6(ii)
4      continue
      else
       do 41 ipx=1,npi
       cciipx=cci(ipx)*cij(i,io+ipx)
       nx= nxi(ipx)+1
       ny= nyi(ipx)+1
       nz= nzi(ipx)+1
       do 201 ii=1,nr
201    psii(ii)=psii(ii)+cciipx*ef(ii)*axs(nx,ii)*ays(ny,ii)*azs(nz,ii)
41     continue
      endif
c
3     if(ish(ia,ip+1).gt.ish(ia,ip))io=io+npii
2     continue
c
      do 204 ii=1,nr
204   db(ii)=psii(ii)
c
      return
      end
