      subroutine overpot(xl,yl,zl,vm)
c
c     calculates vm(i,j)(r)=<i(r')|(r-r')^-1|j(r')>; i,j .. AOs
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      character*2 at
      character*1 ok,ty
      parameter (nat0=190,nor=80,nort=700,mmax=21)
      integer*4 u0
      parameter (u0=28)
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/const/pi,clau,spt,bohr,debye
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension cci(u0),ccj(u0),
     3sv(u0,nort),b6(u0,u0),aai(u0,u0),aaj(u0,u0),
     4aad(u0,u0),aaf(u0,u0),aa1(u0,u0),
     4aag(u0,u0),aah(u0,u0),aaii(u0,u0),
     5nxi(u0),nyi(u0),nzi(u0),nxj(u0),nyj(u0),nzj(u0)
      logical lsprint,ld5,lf7,lrec,lopt
      common/opts/lopt(300),icha,n1
      equivalence (lopt(1),lsprint),(lopt(4 ),ld5),
     1(lopt(8),lf7),(lopt(25),lrec)
      dimension eep(mmax),vm(nort,nort)
      common/atoms/z(nat0),zsum,xv(3,nat0)
      data i0,tol/0,23.0D0/
c
      call initfd(aa1,aad,aaf,aag,aah,aaii)
      call vz(sv,z0,u0*nort)
c
c
C     atom i, orbital io
      io=0
      do 2 ia=1,noa
      xi=xv(1,ia)
      yi=xv(2,ia)
      zi=xv(3,ia)
c
c     primitive functions on atom ia:
      do 2 ip=1,nop(ia)
      ai=alpha(ia,ip)
      aa=ai+ai
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
c
C     atom j, orbital jo
      jo=0
      do 4 ja=1,noa
      xj=xv(1,ja)
      yj=xv(2,ja)
      zj=xv(3,ja)
      xij=xj-xi
      yij=yj-yi
      zij=zj-zi
      x2ij=xij*xij
      y2ij=yij*yij
      z2ij=zij*zij
      r2ij=x2ij+y2ij+z2ij
c
c     primitive functions on atom ja:
      do 5 jp=1,nop(ja)
      aj=alpha(ja,jp)
      bb=aj+aj
      call nppp(ty(ja,jp),npj,npjj,ccj,nxj,nyj,nzj,
     1aaj,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ja,jp)
      aij=ai+aj
      tt=one/aij
      hsp=half*tt
c
C     Loop over orbitals to which the primitives ip, jp contribute
      do 71 joo=1,npj
      njx=nxj(joo)
      njy=nyj(joo)
      njz=nzj(joo)
      con2=ccj(joo)
c
      do 71 ioo=1,npi
      nix=nxi(ioo)
      niy=nyi(ioo)
      niz=nzi(ioo)
      mij=nix+niy+niz+njx+njy+njz
      coe2=con2*cci(ioo)
      ecp=ai*aj*tt*r2ij
      up=z0
      if(ecp.lt.tol)then
       up=pi*tt
       up=sqrt(up*up*up)*exp(-ecp)
      endif
      px=(ai*xi+aj*xj)*tt
      py=(ai*yi+aj*yj)*tt
      pz=(ai*zi+aj*zj)*tt
c     uq multiplied by sqrt((al/pi)^3), to have a delta-function
c     u=up
      mij=nix+niy+niz+njx+njy+njz
      call iactivate(mij,i0,xl,yl,zl,px,py,pz,eep,
     1               pqx,pqy,pqz,hsp,z0,tol)
c     (ab|cd), a=infinity, b=0, c= ai, d=aj, sigmap=0, sigmaq=1/(ai+aj)
71    b6(ioo,joo)=coe2*up*oc4d(nix,niy,niz,njx,njy,njz,
     1eep, xij,yij,zij,pqx,pqy,pqz,
     1hsp,aa,bb,i0)
c
      if(npi.ne.npii.or.npjj.ne.npj)then
       do 74 ioo=1,npii
       do 74 joo=1,npjj
       ioj=joo+jo
       do 74 ipp=1,npi
       aiii=aai(ioo,ipp)
       do 74 jpp=1,npj
       ajjj=aaj(joo,jpp)*aiii
74     sv(ioo,ioj)=sv(ioo,ioj)+ajjj*b6(ipp,jpp)
      else
       do 7 joo=1,npj
       ioj=joo+jo
       do 7 ioo=1,npi
7      sv(ioo,ioj)=sv(ioo,ioj)+b6(ioo,joo)
      endif
c
      if(ish(ja,jp+1).gt.ish(ja,jp)) jo=jo+npjj
c
5     continue
4     continue
C
      if(ish(ia,ip+1).gt.ish(ia,ip))then
c     if last primitive of the orbitals io+1 ... io+npii, then write them
       do 33 ii=1,npii
       do 33 jj=1,nao
33     vm(io+ii,jj)=sv(ii,jj)
       io=io+npii
c
c      zero-out temporary buffer:
       do 9 ii=1,u0
       do 9 jj=1,nao
9      sv(ii,jj)=z0
      endif
2     continue
c
      return
      end
