      SUBROUTINE PROJECT3(P,N,XV,ixx)
c     Projects transl/rotations from AAT or APT
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      PARAMETER (nat0=190,N0=nat0*3)
      DIMENSION P(nat0,3,3),A(N0,N0),XV(3,N/3),PTEM(nat0,3,3)
c
      NAT=N/3
      CALL DOMA33(A,N0,N,XV,ixx)
      DO 1 LA=1,NAT
      DO 1 LX=1,3
      I=3*(LA-1)+LX
      PTEM(LA,IXX,LX)=0.0D0
      DO 1 IA=1,NAT
      DO 1 IX=1,3
      II=3*(IA-1)+IX
1     PTEM(LA,IXX,LX)=PTEM(LA,IXX,LX)+A(I,II)*P(IA,IXX,IX)
      DO 2 IA=1,NAT
      DO 2 IX=1,3
2     P(IA,IXX,IX)=PTEM(IA,IXX,IX)
      RETURN
      END
c
      SUBROUTINE DOMA33(A,NDIM,N,C,ix)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      PARAMETER (nat0=190)
      DIMENSION C(3,nat0),A(NDIM,N),TEM(nat0*3,nat0*3)
      AMACH=0.00000000000001
      NAT=N/3
      DO 12 I=1,N
      DO 12 J=1,6
12    A(I,J)=0.0D0
      DO 1 I=1,NAT
      if(ix.eq.3)then
       A(3*I-2,4)=-C(2,I)
       A(3*I-1,4)= C(1,I)
      endif
      if(ix.eq.1)then
       A(3*I-1,5)=-C(3,I)
       A(3*I  ,5)= C(2,I)
      endif
      if(ix.eq.2)then
       A(3*I-2,6)= C(3,I)
       A(3*I  ,6)=-C(1,I)
      endif
1     CONTINUE
      N6=6
      CALL ORT(A,NDIM,N6,NAT)
      ICOL=1
5     IF(ICOL.GT.N6)GOTO 8
      S=0.0d0
      DO 6 J=1,N
6     S=S+A(J,ICOL)**2
      IF(S.LT.1000.0d0*AMACH)THEN
       DO 7 J=1,N
7      A(J,ICOL)=A(J,N6)
       N6=N6-1
       GOTO 5
      ENDIF
      ICOL=ICOL+1
      GOTO 5
8     CONTINUE
      WRITE(*,*)N6,' coordinates projected'
      DO 2 I=1,N
      DO 2 J=1,N
      TEM(I,J)=0.0d0
      DO 2 II=1,N6
2     TEM(I,J)=TEM(I,J)+A(I,II)*A(J,II)
      DO 3 I=1,N
      DO 4 J=1,N
4     A(I,J)=-TEM(I,J)
3     A(I,I)=A(I,I)+1.0d0
      RETURN
      END
