      subroutine readtm
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
c
      parameter (nat0=190,nor=80,nort=700)
      character*2 at
      character*1 ok,ty
      character*80 s80
      common/const/pi,clau,spt,bohr,debye
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/spdfgh/ccs(nat0,nor),ccp(nat0,nor),ccd(nat0,nor,2),
     1ccf(nat0,nor,3),cci_G(nat0,nor,15),cci_H(nat0,nor,21),
     2cci_I(nat0,nor,28),nxig(15),nyig(15),nzig(15),
     2nxih(21),nyih(21),nzih(21),nxii(28),nyii(28),nzii(28)
      common/rundiff/step,idif,igeo,ibasis,ieigen
      common/atoms/z(nat0),zsum,xv(3,nat0)
      logical lsprint,lpprint,lqprint,ld5,levprint,lvprint,llprint,lf7,
     1ld2,lzmat,SCALED,TTT,RAMAN,XYZ,ABINI,CC5,LAN,LDO,lvv,lsp,lex,
     1lscf,lres,lcndo,fspec,lrec,lc5,lg94,
     9lopt,lconfig,lqq,lsymaos
      common/opts/lopt(300),icha,n1
      equivalence (lopt(1),lsprint),(lopt(2),lpprint),(lopt(3),lqprint),
     1(lopt(4 ),ld5    ),(lopt(5),levprint),(lopt(6),lvprint),
     1(lopt(7 ),llprint),(lopt(8),lf7     ),(lopt(9),ld2    ),
     1(lopt(10),SCALED ),(lopt(11),TTT    ),(lopt(12),RAMAN ),
     1(lopt(13),XYZ    ),(lopt(14),ABINI  ),(lopt(15),cc5   ),
     1(lopt(16),lan    ),(lopt(17),ldo    ),(lopt(18),lvv    ),
     1(lopt(19),lsp    ),(lopt(20),lex    ),(lopt(21),lscf   ),
     1(lopt(22),lres   ),(lopt(23),lcndo  ),(lopt(24),fspec  ),
     1(lopt(25),lrec   ),(lopt(26),lc5    ),(lopt(27),lg94   ),
     1(lopt(28),lzmat  ),(lopt(65),lconfig)
      dimension it(nor)
      character*2 tmsy(nat0)
      character*4 statesym
      real*8,allocatable::ds(:)
c
      call w36('Turbomole files coord,basis and mos')
c
      id5=6
      if7=10
      if(ld5)id5=5
      if(lf7)if7=7

      do 10000 i=1,nort
      do 10000 j=1,nort
      bij(i,j)=0.0d0
10000 cij(i,j)=0.0d0
c
      inquire(file='coord',exist=lqq)
      if(.not.lqq)call report('coord does not exist')
      igeo=igeo+1
      open(4,file='coord')
1     read(4,4010)ok
4010  format(a1)
      if(ok.eq.'$')goto 400
      goto 1
400   i=0
33    read(4,4010)ok
      if(ok.eq.'$')goto 401
      backspace 4
      i=i+1
      if(i.gt.nat0)call report('too many atoms')
      read(4,4001)(xv(ix,i),ix=1,3),ok
4001  format(f20.14,2f22.14,6x,a1)
      z(i)=0.0d0
      if(ok.eq.'h')z(i)=1
      if(ok.eq.'c')z(i)=6
      if(ok.eq.'n')z(i)=7
      if(ok.eq.'o')z(i)=8
      tmsy(i)(1:1)=ok
      if(z(i).lt.1)call report('unknown atom')
      goto 33
401   close(4)
      noa=i
      write(6,*)noa,' atoms'
c
      inquire(file='mos',exist=lqq)
      if(.not.lqq)call report('mos does not exist')
      statesym='1234'
      nao=0
      ieigen=ieigen+1
      open(4,file='mos')
      naot=0
2     read(4,4009)s80
4009  format(a80)
      if(s80(16:25).eq.'eigenvalue')goto 299
      goto 2
299   i=0
3     i=i+1
      if(i.gt.nort)call report('too many eigenvalues')
      if(s80(7:9).ne.statesym)then
       naot=naot+nao
      endif
      statesym=s80(7:9)
      read(s80,4002)e(i),nao
      if(nao.gt.nort)call report('too many orbitals')
      if(naot+nao.gt.nort)call report('too many tot. orbitals')
4002  format(26x,d20.14,9x,i3)
      read(4,4003)(cij(i,naot+j),j=1,nao)
4003  format(4d20.14)
      be(i)=e(i)
      do 50 j=1,nao
50    bij(i,j+naot)=cij(i,j+naot)
      read(4,4009)s80
      if(s80(1:4).ne.'$end') goto 3
      close(4)
      nori=i
      nmo=nori
      nao=nao+naot
      write(6,*)nmo,' MOs read in, ',nao,' AOs'

c
      inquire(file='basis',exist=lqq)
      if(.not.lqq)call report('basis does not exist')
      ibasis=ibasis+1
      open(4,file='basis')
      nao=0
      isht=0
c
      do 4 j=1,noa
      at(j)='  '
      at(j)(1:1)=tmsy(j)(1:1)
      nop(j)=0
      rewind 4
5     read(4,4010)ok
      if(ok.eq.tmsy(j)(1:1))goto 555
      goto 5
555   k=0
7     read(4,4010)ok
      if(ok.eq.'*')goto 778
      goto 7
778   read(4,4005)ipr,ok
      isht=isht+1
4005  format(i4,2x,a1)
      if(ok.eq.'s')nao=nao+1
      if(ok.eq.'p')nao=nao+3
      if(ok.eq.'d')nao=nao+id5
      if(ok.eq.'f')nao=nao+if7
      do 6 i=1,ipr
      k=k+1
      if(k.gt.nor)call report('Too many primitives on one atom')
      if(ok.eq.'s')ty(j,k)='S'
      if(ok.eq.'p')ty(j,k)='P'
      if(ok.eq.'d')ty(j,k)='D'
      if(ok.eq.'f')ty(j,k)='F'
c
c     temporarily record angular momentum for arrangement:
      if(ok.eq.'s')it(k)=0
      if(ok.eq.'p')it(k)=1
      if(ok.eq.'d')it(k)=2
      if(ok.eq.'f')it(k)=3
c
      ish(j,k)=isht
      read(4,*)alpha(j,k),cc(j,k)
c
      aa=alpha(j,k)
c
c     SNO normalization factor to S:
      SNO=sqrt(sqrt(    8.0d0*aa**3/pi**3))
c
c     SNP normalization factor for P:
      SNP=sqrt(sqrt(  128.0d0*aa**5/pi**3))
c
c     SND normalization factor for D:
      SND=sqrt(sqrt( 2048.0d0*aa**7/pi**3))
      SNDD=SND/sqrt(dble(3))
c
c     SNFx normalization factors for F(fxxx,fxxy,fxyz):
      SNF=sqrt(sqrt(32786.0d0*aa**9/pi**3))
      SNF1=SNF/sqrt(dble(15))
      SNF2=SNF/sqrt(dble(3))
      SNF3=SNF
c
      ccs(j,k)=cc(j,k)*SNO
      ccp(j,k)=cc(j,k)*SNP
      ccd(j,k,1)=cc(j,k)*SNDD
      ccd(j,k,2)=cc(j,k)*SND
      ccf(j,k,1)=cc(j,k)*SNF1
      ccf(j,k,2)=cc(j,k)*SNF2
      ccf(j,k,3)=cc(j,k)*SNF3
6     continue
      read(4,4010)ok
      if(ok.ne.'*')then
       backspace 4
       goto 778
      endif
      nop(j)=k
      write(8,*)k,' primitives for atom ',j
c
c     reorder according to the angular momentum
403   do 402 k=1,nop(j)-1
      if(it(k).gt.it(k+1))then
       call swi(   it(  k  ),   it(  k+1))
       call swi(  ish(j,k  ),  ish(j,k+1))
       call swh(   ty(j,k  ),   ty(j,k+1))
       call sw8(alpha(j,k  ),alpha(j,k+1))
       call sw8(   cc(j,k  ),   cc(j,k+1))
       call sw8(  ccs(j,k  ),  ccs(j,k+1))
       call sw8(  ccp(j,k  ),  ccp(j,k+1))
       call sw8(  ccd(j,k,1),  ccd(j,k+1,1))
       call sw8(  ccd(j,k,2),  ccd(j,k+1,2))
       call sw8(  ccf(j,k,1),  ccf(j,k+1,1))
       call sw8(  ccf(j,k,2),  ccf(j,k+1,2))
       call sw8(  ccf(j,k,3),  ccf(j,k+1,3))
       goto 403
      endif
402   continue
c
c     adjpust reordered ish
      ist=ish(j,1)
      do 405 k=1,nop(j)
      if(ish(j,k).lt.ist)ist=ish(j,k)
405   it(k)=ish(j,k)
c
      ish(j,1)=ist
      do 404 k=2,nop(j)
      if(it(k-1).ne.it(k))ist=ist+1
404   ish(j,k)=ist
c
4     continue
      close(4)
      write(6,*)nao,' AOs'
c
      zsum=0.0d0
      nat=noa
      do 1000 iat=1,noa
1000  zsum=zsum+z(iat)
      noe=nint(zsum)-icha
      ndo=noe/2
      ichm=0
      mtp=1
      nsa=noe-2*ndo
      nsb=0
c
      if(ibasis.gt.0)idif=ieigen-1
      write(3,4004)idif,ieigen,igeo,ibasis
      write(6,4004)idif,ieigen,igeo,ibasis
4004  format(I4,' point of the differentiation:',/,
     1 '----',  ' -----------------------------',/,
     2 ' Eigenvectors read',I4,' times',/,
     3 ' Geometry read    ',I4,' times',/,
     4 ' Basis read       ',I4,' times',/)

      inquire(file='symaos',exist=lsymaos)
      if(lsymaos)then
       write(6,*)'symmetrized AO coefficients found in symaos'
       allocate(ds(nao*nao))
       call vz(ds,0.0d0,nao*nao)
       call writecon(0)
       call readsymaos('symaos',nao,ds)
       call trafosymmo(cij,ds,nao,nmo,nort)
       call trafosymmo(bij,ds,nao,nmo,nort)
       write(6,*)'cij transformed into non-symmetric AOs'
       write(3,*)'cij transformed into non-symmetric AOs'
      endif

      close(2)
      return
      end
c
      subroutine sw8(a,b)
      real*8 a,b,c
      c=a
      a=b
      b=c
      return
      end
c
      subroutine swi(a,b)
      integer*4 a,b,c
      c=a
      a=b
      b=c
      return
      end
c
      subroutine swh(a,b)
      character*1 a,b,c
      c=a
      a=b
      b=c
      return
      end

      subroutine readsymaos(f,nao,ds)
      implicit none
      integer*4 nao,icum,icur,atom,shell,nort,ii,j,i
      parameter (nort=700)
      character*(*) f
      character*80 s80
      real*8 ds(*)
      character*3 aot,typ
      integer*4 iat,isha
      common/aotypes/aot(nort),iat(nort),isha(nort)
      write(6,*)f
      open(9,file=f)
1     read(9,900,err=99,end=99)s80
      write(6,900)s80
900   format(a80)
31    read(s80(1:35),*,err=88,end=88)icum,icur
3     read(s80(35:44),*,end=88,err=88)atom
      read(s80(48:52),*,end=88,err=88)shell
      typ=s80(54:56)
      write(6,*)icum,icur,atom,shell,typ
      j=0
      do 2 ii=1,nao
2     if(iat(ii).eq.atom.and.isha(ii).eq.shell.
     1and.aot(ii).eq.typ)j=ii
      write(6,*)'j=',j
      if(j.eq.0)then
       write(6,900)s80
       write(6,*)'atom ',atom
       write(6,*)'shell ',shell
       write(6,*)'type ',typ
       call report('AO not found')
      endif
      read(s80(59:71),*)ds(icum+nao*(j-1))
      read(9,900,end=99,err=99)s80
      write(6,900)s80
      if(s80(1:10).eq.'          ') goto 3
      goto 31
88    goto 1
99    close(9)
      if(icum.ne.nao)call report('nao does not agree')
      do i=1,nao
       write(6,*)'SAO',i,':'
       do j=1,nao
        if(dabs(ds(i+(j-1)*nao)).gt.0.0d0)write(6,89)j,ds(i+(j-1)*nao)
 89     format(i8,f12.6)
       enddo
      enddo
      return
      end

      subroutine  trafosymmo(cij,ds,nao,nmo,nort)
      implicit none
      integer*4 nao,nmo,nort,i,j,is
      real*8 cij(nort,nort),ds(*)
      real*8,allocatable:: tij(:,:)
      allocate(tij(nort,nort))
      do 1 i=1,nmo
      do 1 j=1,nao
      tij(i,j)=0.0d0
      do 1 is=1,nao
1     tij(i,j)=tij(i,j)+cij(i,is)*ds(is+nao*(j-1))
      do 2 i=1,nmo
      do 2 j=1,nao
2     cij(i,j)=tij(i,j)
      return
      end
