      SUBROUTINE ROAAI(NATF,ALPH,G,A,nmos,R,av,al0,al0v,a0,g0)
c
c     ab initio (SOS) calculations
c
      IMPLICIT REAL*8 (A-H,O-Z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700,N30=3*nat0,nsw0=70)
c
C     nat0: # of atoms, nor: # of orbitals on one atom,
C     ndf0: # of basis functions,
c
      DIMENSION ALPH(N30,3,3),G(N30,3,3),A(N30,3,3,3),R(3,nat0),
     1av(N30,3,3)
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/atoms/z(nat0),zsum,xv(3,nat0)
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      logical lsprint,lpprint,lqprint,ld5,levprint,lvprint,llprint,lf7,
     1ld2,lzmat,SCALED,TTT,RAMAN,XYZ,ABINI,CC5,LAN,LDO,lvv,lsp,lex,
     1lscf,lres,lcndo,fspec,lrec,lc5,lg94,lnmr,lapt,lader,lcnmr,
     9lopt,lhell,lsuper,lgrad,lssup,lsupinv,lplot,lcroa,lgvir,loo,
     1lci,li3,lconfig,lroax,lnormao,lfuzzy,lgradc,laolo,ldipole,
     1laol3,lcaz,lbasred,lcazdip,lswing,lord,lboys,lsrx,lorban,ltdhf,
     1lsx
      common/iopts/iopt(300)
      common/ropts/ropt(300)
      common/opts/lopt(300),icha,n1
      equivalence (ropt(22),btol)
      equivalence (lopt(1),lsprint),(lopt(2),lpprint),(lopt(3),lqprint),
     1(lopt(4 ),ld5    ),(lopt(5),levprint),(lopt(6),lvprint),
     1(lopt(7 ),llprint),(lopt(8),lf7     ),(lopt(9),ld2    ),
     1(lopt(10),SCALED ),(lopt(11),TTT    ),(lopt(12),RAMAN ),
     1(lopt(13),XYZ    ),(lopt(14),ABINI  ),(lopt(15),cc5   ),
     1(lopt(16),lan    ),(lopt(17),ldo    ),(lopt(18),lvv    ),
     1(lopt(19),lsp    ),(lopt(20),lex    ),(lopt(21),lscf   ),
     1(lopt(22),lres   ),(lopt(23),lcndo  ),(lopt(24),fspec  ),
     1(lopt(25),lrec   ),(lopt(26),lc5    ),(lopt(27),lg94   ),
     1(lopt(28),lzmat  ),(lopt(29),lnmr   ),(lopt(30),lapt   ),
     1(lopt(31),lader  ),(lopt(41),lhell  ),(lopt(43),lsuper),
     1(lopt(45),lgrad  ),(lopt(46),lssup  ),(lopt(47),lsupinv),
     1(lopt(48),lplot  ),(lopt(52),lcroa  ),(lopt(54),lgvir  ),
     1(lopt(56),lcnmr  ),(lopt(59),lci    ),(lopt(54),li3    ),
     1(lopt(83),laol3  ),(lopt(84),lcaz   ),(lopt(92),lbasred ),
     1(lopt(65),lconfig),(lopt(76),lnormao),(lopt(73),lroax  ),
     1(lopt(81),laolo  ),(lopt(82),ldipole),(lopt(77),lfuzzy ),
     1(lopt(78),lgradc ),(lopt(94),lcazdip),(lopt(97),lord),
     1(lopt(103),lboys),(lopt(104),lsrx),(lopt(106),lorban),
     1(lopt(107),ltdhf),(lopt(108),loo)
      equivalence (iopt(11),multi),(iopt(12),ndog),(iopt(13),nsi),
     1(iopt(2),inormo  ),(iopt(7),ioe     ),(iopt(1),ncnmr   ),
     1(iopt(23),nk     ),(iopt(24),nj     ),(iopt(31),idiff),
     1(iopt(32),ibiter )
      common/rundiff/step,idif,igeo,ibasis,ieigen
      character*80 ifn
      common/filenames/ifn
      common/sobs/sbe(nort*2),ndogc,nsic,nsorb,isos(2*nort),
     1isomo(2*nort)
      dimension ac(3,3,3),a0(3,3,3),alc(3,3),al0(3,3),gpc(3,3),
     1g0(3,3),alcv(3,3),al0v(3,3)
      parameter (nkkjj0=nort*(nort+1))
      logical lnknj
      common/kkjj/ckkjj(nkkjj0),enknj(nort),lnknj
      real*8 ctc(nsw0,nort)
      real*8,allocatable::sdm(:),cijt(:,:),sdmmo(:)
c
      call w36('       ')
      call w36('Roaai')
      call w36('^^^^^')
      call w36('       ')
C
      idif=0
      lnknj=.false.
      nmo=nmos
      do 1 i=1,nat0
      do 1 j=1,nor
1     ish(i,j)=32000
c
c
c     Define the ab initio output file and open it:
      if(ifn(2:3).eq.'  ')ifn='roa.inp'
      close(2)
      open(2,file=ifn)
c
c     Extra-file with MO coefficients
      if(lex)open(22,file='EX.SCR',status='old',form='unformatted')
c
c     read in basic geometry, basis set, and wavefunction
      NDIFF=0
      ieigen=0
      igeo=0
      ibasis=0
      call roainp(NDIFF)
      natf=nat
      write(6,*)nat
c
c     control output
      call writecon(NDIFF)
c
      if(lnormao)then
       call normorb
       write(3,*)'AOs have been renormalized'
       write(6,*)'AOs have been renormalized'
      endif
c
c     one electron integrals for starting point
      call overlap6

c     analysis of MOs in terms of AOs
      if(lorban)call orban

c     nuclear derivatives of S-matrix, trasformed to MOs:
      if(lsrx)then
       inquire(file='SXA.SCR.TXT',exist=lsx)
       if(lsx)then
        write(6,*)' S/P overlap derivatives found on disk'
       else
        write(6,*)' Doing S/P overlap derivatives ...'
        allocate(sdm(3*nat*nao*nao*7),sdmmo(3*nat*nao*nao*7))
        call dsm(sdm,nao,noa,alpha,ty,nop,ish)
        allocate(cijt(nao,nao))
        do 3 i=1,nmo
        do 3 j=1,nao
3       cijt(i,j)=cij(i,j)
        sdmmo=sdm
        call trsc(sdmmo,cijt,3*nat,nao,nmo,7,'A')
        do 4 i=1,nmo
        do 4 j=1,nao
4       cijt(i,j)=bij(i,j)
        sdmmo=sdm
        call trsc(sdmmo,cijt,3*nat,nao,nmo,7,'B')
        deallocate(sdm)
        write(6,*)'                               .... done.'
       endif
      endif

c     density matrix
      call densitymat
c
c     check basis set for redundancy:
      if(lbasred)call aoredcheck
c
      if(lvv)call roatest
      if(lvv)write(6,*)'*test*'
c
c     make spin-orbitals
      ii=0
      do i=1,nmo
       ii=ii+1
       isomo(ii)=i
       isos(ii)=1
       sbe(ii)=e(i)
       ii=ii+1
       isomo(ii)=i
       isos(ii)=-1
       sbe(ii)=be(i)
      enddo
      nsorb=2*ndo+nsa+nsb
      write(6,6000)nmo,ii,nsorb
6000  format(i5,' orbs produced ',i5,' spinorbitals',i5,' occupied')
c

c     skip old section
      goto 8989
      if(lconfig)then
       ndogc=ndog
       nsic=nsi
      else
       ndogc=ndo
       nsic=0
      endif
c
      ii=0
c
c     double-occupied:
      do 1003 i=1,ndogc
      ii=ii+1
      isomo(ii)=i
      isos(ii)=1
      sbe(ii)=e(i)
      ii=ii+1
      isomo(ii)=i
      isos(ii)=-1
1003  sbe(ii)=be(i)
c
c     single-occupied:
      do 1004 i=1,nsic
      ii=ii+1
      isomo(ii)=i+ndogc
      isos(ii)=1
1004  sbe(ii)=e(i+ndogc)
      nsorb=ii
c
c     empty with singles
      do 1005 i=1,nsic
      ii=ii+1
      isomo(ii)=i+ndogc
      isos(ii)=-1
1005  sbe(ii)=be(i+ndogc)
c
c     empty alone
      do 1006 i=ndogc+nsic+1,nmo
      ii=ii+1
      isomo(ii)=i
      isos(ii)=1
      sbe(ii)=e(i)
      ii=ii+1
      isomo(ii)=i
      isos(ii)=-1
1006  sbe(ii)=be(i)
8989  continue
c
c     molecular properties for the equilibrium geometry:
      inquire(file='SWING.MO',exist=lswing)
      if(ldipole)then
       call charge(1)
       write(6,*)'Charge has been calculated'
      endif
      if(inormo.eq.2)call normc
      if(inormo.eq.2)write(6,*)'MOs have been normalized'
      if(inormo.eq.3)call ortog
      if(inormo.eq.3)write(6,*)'MOs have been orthonormalized'
      if(inormo.ne.1.and.ldipole)call charge(0)

      if(lswing)then
       call mu
       open(34,file='SWING.MO')
       read(34,*)nswing
       if(nswing.gt.nsw0)call report('cannot redefine so many states')

       do i=1,nsw0
        do ii=1,nao
         ctc(i,ii)=cij(i,ii)
        enddo
       enddo

       do i=1,nswing
        read(34,*)isw1,e(isw1),nw
        write(6,*)' Orbital ',isw1,' redefined!'
        write(3,*)' Orbital ',isw1,' redefined!'
        do ii=1,nao
         cij(isw1,ii)=0.0d0
        enddo
        do iu=1,abs(nw)
         if(nw.lt.0)then
          read(34,4000)ia1,a1
4000      format(11x,i3,4x,f12.5)
         else
          read(34,*)a1,ia1
         endif
         write(6,4000)ia1,a1
         write(3,4000)ia1,a1
         if(ia1.gt.nsw0)call report('orbital number too high')
         do jj=1,nao
          cij(isw1,jj)=cij(isw1,jj)+a1*ctc(ia1,jj)
         enddo
        enddo
       enddo

       close(34)
       call ortog
       write(6,*)'MOs have been orthonormalized'
       call charge(0)
       call mu
      endif
c
      if(lplot)then
       call og
       call report('plotting finished')
      endif
c
c     if lgrad then calculate gradient by Hellmann-Feynmann-theorem and get out
      if(lgradc)call gradc
      if(lgrad)then
       if(lfuzzy)then
        call hfuzzy
       else
        call gradhf
       endif
      endif
c
      if(ldipole)then
       call mu
       write(6,*)'dipole calculated'
       call theta
       write(6,*)'quadrupole calculated'
      else
       write(6,*)'dipole calculation skipped'
      endif
c
      write(3,*)'ioe = ',ioe
      write(6,*)'ioe = ',ioe
      if(nk.ne.0)call nknj(nk,nj,nmo)
      if(lboys)then
       call boyso2(1,1,6,btol,ibiter)
       call doCRE
      endif
      call dqmpol3(al0,a0,g0,al0v,ioe)
      if(ltdhf)call tdhf(ioe)
      if(lcaz)call dqmpol3k(ioe)
      if(lcazdip)call overla68
      if(lci)then
       call dcipol(al0,a0,g0,al0v)
      endif
c
c     save equilibrium geometry
      do 2 ia=1,nat
      do 2 ix=1,3
2     r(ix,ia)=xv(ix,ia)
c
      if(lnmr)then
       if(laolo)then
        call dnmrao(ioe)
       else
        if(laol3)then
         call dnmrao3(ioe)
        else
         call dnmr(ioe)
        endif
       endif
      endif
c
      if(lcnmr)call dcoupl(ioe)
      if(lapt)call dapt(ioe)
      if(lsuper)call super(ioe)
      if(lssup)call ssup(ioe)
      if(lsupinv)call ssupcor(ioe)
      if(lhell)call hell(ioe)
      if(loo)call oo
c     fitted coulomb potential, for debugigng:
c     if(lhell)call hell2(ioe)
      if(lgvir)call dpolp(ioe)
      if(lroax)then
       call aderx(ioe,ALPH,G,A,av)
       return
      endif
      if(lcroa)then
       call acor(ioe,ALPH,G,A,av)
       if(lader)then
        write(3,*)'ADER option ignored'
        write(6,*)'ADER option ignored'
       endif
       return
      endif
      if(lader)then
       call ader(ioe,ALPH,G,A,av)
       return
      endif
      if(lsp)call report('Single point requested only')
c
c     numerical differentiations
      if(lord)then
       if(idiff.eq.22)call orbdif22
       call ordnbo(ioe)
       call report('ord finished')
      endif

      ndtot=1
      if(ld2)ndtot=2
      write(3,*)ndtot,' - point differentiation (see ld2)'
      if(step.lt.-300.0)call report('Step size has not been set')
      write(3,3003)step
3003  format(' Step ',F10.5,' Bohr')
      do 200 it=1,ndtot
      do 101 ia=1,nat
      do 102 ix=1,3
      write(6,*)it,ia,ix
      ndiff=ndiff+1
      call roainp(ndiff)
      call writecon(ndiff)
c
c     idif  - according to the eigenvectors read
c     ndiff - according to the required part
      WRITE(3,1116)IDIF,ndiff
1116  FORMAT(I3,' (',I3,'). Point of the numerical differentiation.')
      if(idif.ne.ndiff)call report('output sees different point')
c
      call overlap6
      call dqmpol3(alc,ac,gpc,alcv,ioe)
c
      sf=dble(one)/step
      IF(IDIF.LE.3*NAT)THEN
         DO 41 I=1,3
         DO 41 J=1,3
         ALPH(IDIF,I,J)=(ALc(I,J)-AL0(I,J))*sf
         av(IDIF,I,J)=(ALcv(I,J)-AL0v(I,J))*sf
         G(IDIF,I,J)=(Gpc(I,J)-g0(I,J))*sf
         DO 41 K=1,3
41       A(IDIF,I,J,K)=(Ac(I,J,K)-A0(I,J,K))*sf
      ELSE
         IC=IDIF-3*NAT
         DO 412 I=1,3
         DO 412 J=1,3
         ALPH(IC,I,J)=half*(ALPH(IC,I,J)-
     1                      (Alc(I,J)-AL0(I,J))*sf)
         av(IC,I,J)=half*(av(IC,I,J)-
     1                      (Alcv(I,J)-AL0v(I,J))*sf)
         G(IC,I,J)=half*(G(IC,I,J)-(Gpc(I,J)-g0(I,J))*sf)
         DO 412 K=1,3
412      A(IC,I,J,K)=
     1   half*( A(IC,I,J,K) - (Ac(I,J,K)-A0(I,J,K)) *sf )
      ENDIF
102   continue
101   continue
200   continue
      close(2)
      if(lex)close(22)
c
      RETURN
      END
