      subroutine roatest
c     alpha, A and G' tensors (static limits)
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700,nel=15)
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension pix(nort),piy(nort),piz(nort),dmo(nel,nort),
     4vx(nort),vy(nort),vz(nort),dmor(3,200,200),qilx(nort),
     1qily(nort),qilz(nort)
      write(3,4001)nmo,nao
4001  format(' A,alpha,G',1H',' calculation, NMO = ',I3,' NAO = ',I3)
c
c     construct MO overlaps:
c     <MO|r|MO>, <MO|rr|MO>,<MO|0.5rxgrad|MO> <MO|grad|MO>
C      <I|o|J>=cIi*cJj<i|o|j>
c    k=1 2 3  4  5  6  7  8  9 10 11 12 13 14 15
c      x y z xx xy xz yy yz zz lx ly lz vx vy vz
c     write lines into MOTEST.SCR
      open(36,file='MOTEST.SCR',form='unformatted')
      open(33,file='P.SCR',form='unformatted')
      open(34,file='L.SCR',form='unformatted')
      open(37,file='V.SCR',form='unformatted')
      do 20 imo=1,nmo
c     do and write the i-MO block:
c
      do 3 k=1,nel
      do 3 j=1,nmo
3     dmo(k,j)=z0
c
      rewind 33
      rewind 34
      rewind 35
      rewind 37
      do 1 i=1,nao
      cimoi=cij(imo,i)
      read(33)(pix(j),j=1,nao)
      read(33)(piy(j),j=1,nao)
      read(33)(piz(j),j=1,nao)
      read(34)(qilx(j),j=1,nao)
      read(34)(qily(j),j=1,nao)
      read(34)(qilz(j),j=1,nao)
      read(37)(vx(j),j=1,nao)
      read(37)(vy(j),j=1,nao)
      read(37)(vz(j),j=1,nao)
      do 1 j=1,nao
      do 1 jmo=1,nmo
      cjmoj=cimoi*cij(jmo,j)
      dmo( 1,jmo)=dmo( 1,jmo)+cjmoj*pix(j)
      dmo( 2,jmo)=dmo( 2,jmo)+cjmoj*piy(j)
      dmo( 3,jmo)=dmo( 3,jmo)+cjmoj*piz(j)
      dmo(10,jmo)=dmo(10,jmo)+cjmoj*qilx(j)
      dmo(11,jmo)=dmo(11,jmo)+cjmoj*qily(j)
      dmo(12,jmo)=dmo(12,jmo)+cjmoj*qilz(j)
      dmo(13,jmo)=dmo(13,jmo)+cjmoj*vx(j)
      dmo(14,jmo)=dmo(14,jmo)+cjmoj*vy(j)
1     dmo(15,jmo)=dmo(15,jmo)+cjmoj*vz(j)
      do 21 K=1,3
      do 21 j=1,nmo
21    dmor(k,imo,j)=dmo(k,j)
20    write(36)((dmo(k,j),k=1,nel),j=1,nmo)
      close(33)
      close(34)
      close(37)
c
c
      rewind 36
      write(6,3003)
3003  format('   I   J   A  <I|0.5r x grad|J> 0.5<I|r|e><e|r|J>*EeJ')
c
      do 8 k=1,ndo
      read(36)((dmo(kk,j),kk=1,nel),j=1,nmo)
      do 9 j=1,nmo
      do 10 ix=1,3
c
c     matrix element <K|lx|J>
      sum=z0
      jx=ix+1
      if(jx.eq.4)jx=1
      kx=jx+1
      if(kx.eq.4)kx=1
      do 11 ie=1,nmo
      de2=half*(e(ie)-e(j))
11    sum=sum-
     1de2*(dmor(jx,k,ie)*dmor(kx,ie,j)-dmor(kx,k,ie)*dmor(jx,ie,j))
c
      write(6,3001)k,j,ix,dmo(9+ix,j),sum
10    continue
9     continue
8     continue
c
      rewind 36
      write(3,3000)
3000  format('   I   J   A         <I|r|J>*EIJ          <I|grad|J>')
3001  format(3I4 ,2F20.10)
      del=z0
      in=0
      do 5 k=1,ndo
      read(36)((dmo(kk,j),kk=1,nel),j=1,nmo)
      do 6 j=1,nmo
      ejk=e(j)-e(k)
      do 7 ix=1,3
      write(3,3001)k,j,ix,dmo(ix,j)*ejk,dmo(ix+12,j)
      a=(dmo(ix,j)*ejk-dmo(ix+12,j))**2
      if(a.gt.0.0000001)then
       del=del+a
       in=in+1
      endif
7     continue
6     continue
5     continue
      del=sqrt(del/dble(in))
      write(6,*)del
c
      close(36)
      return
      end
