      PROGRAM SOS
      IMPLICIT REAL*8 (A-H,O-Z)
      implicit integer*4 (i-n)
      PARAMETER (nat0=190,N30=3*nat0)
      DIMENSION FCAR(N30,N30),R(3,nat0),A0(3,3),A0V(3,3),
     1S(N30,N30),ALPHA(N30,3,3),A(N30,3,3,3),G(N30,3,3),
     3alphav(n30,3,3),aa0(3,3,3),g0(3,3)
      COMMON//E(N30),N7
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      logical SCALED,TTT,RAMAN,XYZ,ABINI,CC5,LAN,LDO,lex,lopt,
     1lspace,lrul,lpolar,ldoroa
      common/opts/lopt(300),icha,n1
      equivalence
     1(lopt(10),SCALED ),(lopt(11),TTT    ),(lopt(12),RAMAN ),
     1(lopt(13),XYZ    ),(lopt(14),ABINI  ),(lopt(15),cc5   ),
     1(lopt(16),lan    ),(lopt(17),ldo    ),(lopt(20),lex   ),
     1(lopt(36),lspace ),(lopt(49),lrul   ),(lopt(50),lpolar),
     1(lopt(51),ldoroa )
      common/rundiff/step,idif,igeo,ibasis,ieigen
C
c     activate the /const/ and /numbers/ commons
      write(*,*)'start'
      call init
c
      WRITE(*,6666)
      OPEN(3,FILE='SOS.OUT')
      WRITE(3,6666)
6666  FORMAT(/,/,
     A'          * * * * * * * * * * * * * * * * * * * * * *',/,
     1'        *                                         *  ',/,
     2'      *           Sum-Over-States Calculations  *    ',/,
     3'        *                                         *  ',/,
     4'          * * * * * * * * * * * * * * * * * * * * * *',/,
     5'                                                     ',/,
     6'     polarizabilities,magnetic susceptibilities,     ',/,
     7'     ROA, VCD, NMR, orbital plotting                 ',/,
     8'                                                     ',/,
     9'                     Petr Bour, September 1997       ',/,/,
     A'     Options defined in SOS.OPT                      ')
      N7=7
      N1=7
      IDIF=-1
      CALL IOPAR(nmo,step,ifit)
c
c     Ab initio calculations:
      IF(ABINI)CALL ROAAI(NAT,ALPHA,G,A,nmo,R,alphav,A0,A0V,
     1 AA0,G0)
c
c     ROA tensors and geo from sepparate files:
      IF(TTT)CALL READTEN(N30,NAT,ALPHA,G,A,alphav)
c
c     Read zero point variables:
      IF(XYZ)THEN
       CALL READXYZ(R,NAT,N30)
      ELSE
       IC=0
       IF(.NOT.ABINI) CALL READC5(N30,NAT,ALPHA,G,A,R,S,N7,FCAR,IC,
     1 alphav,a0,A0V,aa0,g0)
       write(6,*)'zero point read'
      ENDIF
c
c     S-matrix from F.INP:
      IF(SCALED)CALL READS(N30,S)
c
c     ROA tensors form Cadpac output:
      IF(CC5.and.(.not.abini))THEN
       IC=1
       CALL READC5(N30,NAT,ALPHA,G,A,R,S,N7,FCAR,IC,alphav,A0,A0V,
     1  AA0,g0)
       write(6,*)'last point read'
      ENDIF
c
      IF(.NOT.SCALED.and.(.not.lopt(300)))CALL CONTROL(N30,S,FCAR,3*NAT)
c
      IF(RAMAN)THEN
       WRITE(3,*)' ROA tensors zeroed out ...'
       ndim=9*n30
       call vz(alpha,z0,ndim)
       call vz(g,z0,ndim)
       ndim=27*n30
       call vz(a,z0,ndim)
      ENDIF
c
c     compare the length and velocity forms of alpha
      call covr(N30,ALPHA,ALPHAV,NAT)
c
c     Transform ROA tensors into local origins
      ic=1
      call ttai(N30,ALPHA,ALPHAV,A,G,NAT,IC,R)
c
c     Write the tensors to LOCAL.TTT
      open(2,file='LOCAL.TTT')
      CALL WRITETTT(N30,NAT,ALPHA,A,G)
      close(2)
      write(3,*)' Local tensors written into LOCAL.TTT'
c
c     The polar model:erase local G and A
      if (lpolar)then
       ic=3
       call tttt(N30,ALPHA,A,G,NAT,IC,R)
      endif
c
c     analytical alpha-derivatives - look at input file:
      CALL READAAL(N30,NAT,ALPHA,LAN)
c
c     analytical alpha-derivatives - look at ALPHA.TTT:
      CALL ALTT(N30,3*NAT,ALPHA,LAN)
c
c     Transform ROA tensors back into common origin
      ic=2
      if(ldoroa) then
       call tttt(N30,ALPHA,A,G,NAT,IC,R)
      else
       call ttai(N30,ALPHA,ALPHAV,A,G,NAT,IC,R)
      endif
c
c     Check sum rules:
      call rul(n30,nat0,nat,alpha,a,g,r,a0,aa0,g0)
c
c     Write the tensors to CON.TTT:
      open(2,file='CON.TTT')
      CALL WRITETTT(N30,NAT,ALPHA,A,G)
      close(2)
      write(3,*)' Tensors written into CON.TTT'
c
      if(.not.SCALED.and.abini)call report('program finished')
c
c     transform tensors into internal coordinates
      CALL TRTEN(N30,S,3*NAT,ALPHA,A,G)
c
c     calculate the spectra
      CALL DORAMAN(N30,3*NAT,ALPHA,G,A)
c
      call report(' Good Bye ... ')
      END
