      subroutine tepmo
c
c     transforms core hamiltonian ao->mo
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      character*2 at
      character*1 ok,ty
      parameter (nat0=190,nor=80,nort=700)
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/tep002/s(nort,nort),st(nort,nort)
      logical lsprint,lex,lopt
      common/opts/lopt(300),icha,n1
      equivalence (lopt(1),lsprint)
      common/tep001/hcore(nort,nort),bcore(nort,nort),
     1hkin(nort,nort),hpot(nort,nort),
     1bkin(nort,nort),bpot(nort,nort),temij(nort,nort)
c
      inquire(file='CORE.SCR',exist=lex)
      if(lex)then
       write(3,*)'CORE.SCR on disk'
       return
      endif
c
      write(6,*)'making CORE.SCR'
      open(33,file='LAPLACE.SCR',form='unformatted',status='old')
      do 34 i=1,nao
34    read(33)(st(i,j),j=1,nao)
      close(33)
      if(lsprint)call wmtr(st,nort,nao,'Kinetic energy, AO',i0)
      call taomo2(st,hkin,cij,nort,nort,nmo,nao,temij)
      call taomo2(st,bkin,bij,nort,nort,nmo,nao,temij)
c
      open(33,file='EP.SCR',form='unformatted',status='old')
      do 36 i=1,nao
36    read(33)(s(i,j),j=1,nao)
      close(33)
      if(lsprint)call wmtr(s,nort,nao,'Electronic-nuclear pot., AO',i0)
      call taomo2(s,hpot,cij,nort,nort,nmo,nao,temij)
      call taomo2(s,bpot,bij,nort,nort,nmo,nao,temij)
c
      do 42 i=1,nmo
      do 42 j=1,nmo
      hcore(i,j)=hpot(i,j)+hkin(i,j)
42    bcore(i,j)=bpot(i,j)+bkin(i,j)
c
      open(33,file='CORE.SCR',form='unformatted')
      write(33)((hkin(i,j),i=1,nmo),j=1,nmo)
      write(33)((bkin(i,j),i=1,nmo),j=1,nmo)
      write(33)((hpot(i,j),i=1,nmo),j=1,nmo)
      write(33)((bpot(i,j),i=1,nmo),j=1,nmo)
      write(33)((hcore(i,j),i=1,nmo),j=1,nmo)
      write(33)((bcore(i,j),i=1,nmo),j=1,nmo)
      close(33)
      write(3,*)'CORE.SCR written'
      write(6,*)'CORE.SCR written'
      return
      end
