      SUBROUTINE ALTT(NS,N,ALPHA,LAN)
      IMPLICIT REAL*8 (A-H,O-Z)
      implicit integer*4 (i-n)
      DIMENSION ALPHA(NS,3,3)
      logical lan,lex
c
      write(3,*)'Trying to read analytical alpha-der from ALPHA.TTT'
      inquire(file='ALPHA.TTT',exist=lex)
      if(.not.lex)then
       write(3,*)'ALPHA.TTT not found'
       return
      endif
      NAT=N/3
      OPEN(2,FILE='ALPHA.TTT')
      read(2,*)
      read(2,*)nc
      if(nc.ne.nat)call report('Different number of atoms at ALPHA.TTT')
      WRITE(3,3001)
3001  FORMAT(1X,'  POLARIZABILITY DERIVATIVES',/,
     1       1X,'            ANALYTICAL     NUMERICAL',/,
     2       1X,'-------------------------------------')
      read(2,*)
      read(2,*)
      DO 1 I=1,3
      read(2,*)
      DO 1 L=1,NAT
      DO 1 IX=1,3
      IIND=3*(L-1)+IX
      k=iind
      read(2,*)idumm,idumm,aa1,aa2,aa3
      WRITE(3,3000)K,I,AA1,ALPHA(K,I,1)
      WRITE(3,3000)K,I,AA2,ALPHA(K,I,2)
      WRITE(3,3000)K,I,AA3,ALPHA(K,I,3)
3000  FORMAT(1X,2I3,2F15.8)
      IF(LAN)then
       ALPHA(K,I,1)=AA1
       ALPHA(K,I,2)=AA2
       ALPHA(K,I,3)=AA3
      endif
1     continue
      IF(LAN)WRITE(3,3003)
3003  FORMAT(1X,'THE ANALYTICAL FORM OF ALPHA WILL BE USED')
      close(2)
      RETURN
      END

