      subroutine boyson(n1,n2,cc0,DMAO,cdim)
c
c     preparing input for boys, localize orbitals n1....n2
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700,NTT=nort*(nort+1)/2)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c
      character*2 at
      character*1 ok,ty
      integer*4 cdim
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      real*8 DMAO(NTT,3),RIJ(NTT,3),CCO(nort,nort),
     1QPIX(nort),QPJX(nort),MOUse(1),IOrd(nort),IIR(nort),
     1cc0(cdim,cdim)
      real*8,dimension(:,:),allocatable::CL
c
      call w36('Starting boyson')
c
c     Output unit:
      IOut=3
c     Print 0 basic,1 extended:
      IPrint=1
c     Number of orbitals to localize:
      NOrb=n2-n1+1
c     Number of basis functions:
      NBasis=nao
c     Dimension for DMAO:
c     NTT=nort*(nort+1)/2
c     do not use orbital list:
      MOUse(1)=0
c     input orbitals, note that order of indices is opposite in CCO and cc0:
      do 3 i=n1,n2
      do 3 j=1,nao
3     CCO(j,i)=cc0(i,j)
c
      allocate(CL(nort,nort))
      call BoyLoc(IOut,IPrint,NOrb,NBasis,NTT,MOUse,CCO,CL,
     $            nort,DMAO,IOrd,IIR,RIJ,QPIX,QPJX,1.0d-6,1000)
      deallocate(CL)
c
      do 2 i=n1,n2
      do 2 j=1,nao
2     cc0(i,j)=CCO(j,i)

      write(6,609) n1,n2
      write(3,609) n1,n2
609   format(' Orbitals',i5,' - ',i5,' were localized.')

      return
      end
