      subroutine dcipol(alc,ac,g,alcv)
c     alpha, A and G' tensors (static limits), chi
c     using also limited CI
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700,nel=15,
     1nhcir=100000)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c     nel    dimension of the buffer dmo with MO matrix elements
c     nr     something for fitro1
c
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension alp(3,3),a(3,6),g(3,3),
     1alc(3,3),ac(3,3,3),alcv(3,3),alpv(3,3),
     2chip(3,3),chid(3,3)
c
      logical lscf,lres,lrec,lopt,lsp,lmoscr,lall,luvcd,li3,
     1lconfig ,larmp2,lmp2,lmpn4,lonly,gconfig,lci,lhdisk,
     1ltriplets,lene
      common/opts/lopt(300),icha,n1
      common/ropts/ropt(300)
      common/iopts/iopt(300)
      equivalence (lopt(21),lscf),(lopt(22),lres),(lopt(25),lrec),
     1(lopt(19),lsp),(lopt(43),lall),(lopt(55),luvcd),(lopt(60),li3),
     1(lopt(65),lconfig),(lopt(61),lmp2),(lopt(64),lmpn4),
     1(lopt(69),lonly),(lopt(66),gconfig),(lopt(59),lci),
     1(iopt(17),idiago),
     1(lopt(70),lhdisk),(lopt(72),ltriplets),(iopt(21),iham),
     1(ropt(1),wexc)
      common/dum1/onj(nhcir,nel)
      common/dum2/ind(nhcir),d(nhcir),
     1cci(nhcir),fjk(nort,nort)
      common/dum3/btem(nort,nort)
      character*8 fnc(nel)
      data fnc/'CAPX.SCR','CAPY.SCR','CAPZ.SCR',
     1'CAQ1.SCR','CAQ2.SCR','CAQ3.SCR','CAQ4.SCR','CAQ5.SCR','CAQ6.SCR',
     1'CALX.SCR','CALY.SCR','CALZ.SCR',
     1'CAVX.SCR','CAVY.SCR','CAVZ.SCR'/
c
      write(3,4001)nmo,nao
      write(6,4001)nmo,nao
4001  format('dcipol A,alpha,G',1H',' and Chi; NMO = ',I3,' NAO = ',I3)
c
      inquire(file='VMO.SCR',exist=lmoscr)
      if(.not.lmoscr)call makemos2(nao,cij,nmo)
      if(.not.lmoscr.and.nsb.gt.0)call makemosb(nao,bij,nmo)
c
c
      tol=1.0d-6
      do 4 j=1,6
      do 4 i=1,3
4     a(i,j)=z0
      do 11 i=1,3
      do 11 j=1,3
      alp(j,i)=z0
      alpv(j,i)=z0
      chid(i,j)=z0
      chip(i,j)=z0
11    g(i,j)=z0
c
      mc=mclock()
      call inibe4
      if(lmpn4.and..not.li3)then
       inquire(file='BBCD.SCR',exist=larmp2)
       if(.not.larmp2)call report('BBCD.SCR does not exist')
      endif
c
      call overlav
c
      iloop=1
      if(ltriplets)iloop=3
      do 1 ist=1,iloop,2

c     generate CI states - singlets/triplets, write them to CI.STA/CIT.STA:
      call cig2(nmo,noe,ist,ncih,nsl,nsg)
c
c     make CI Hamiltonian, write it to A.SCR/AT.SCR
      if(li3)then
       call overlall(fjk)
       call taomo3(fjk,cij,nort,nort,nmo,nao,btem)
       call overla66(fjk)
       call cighs(nmo,ncih,nsl,ist)
      else
       if(lhdisk)then
        if(iham.eq.0)then
         call cighd(nmo,ncih,nsl,ist)
        else
         call cighd1(nmo,ncih,nsl,ist)
        endif
       else
c
c       fill Aabcd common
        call filla(nmo)
        call cigh(nmo,ncih,nsl,ist)
       endif
      endif
c
c     diagonalize singlet/triplet H:
      if(ist.eq.1)inquire(file='ECI.SCR',exist=lene)
      if(ist.eq.3)inquire(file='ECIT.SCR',exist=lene)
      IF(.not.lene)THEN
       write(6,*)'diagonalizing'
       if(idiago.gt.0)then
        nv=ncih
       else
        nv=1
       endif
       if(idiago.eq.1)then
        call diagodd(ncih,ist)
       else
        if(abs(idiago).eq.2)then
         call diagodsk(ncih,nv,ist)
        else
         if(abs(idiago).eq.3)then
          call diagomit(ncih,nv,ist)
         else
          call report('unknown diagonalization option')
         endif
        endif
       endif
      ELSE
       write(6,*)'energies found on disk, diagonalization skipped'
      ENDIF
c
      if(ist.eq.1)open(23,file='ECI.SCR',form='unformatted')
      if(ist.eq.3)open(23,file='ECIT.SCR',form='unformatted')
      read(23)nv
      do i=1,nv
       read(23)d(i)
      enddo
      do i=1,nv
       ind(i)=i
      enddo
      read(23,err=8999)(ind(i),i=1,nv)
8999  close(23)
      if(ist.eq.1)eground=d(1)
      if(ist.eq.1)call w36('SINGLETS:')
      if(ist.eq.3)call w36('TRIPLETS:')
      write(3,8001)
      write(6,8001)
8001  format(
     1'state       E(au)      Eexc  Eexc(eV)  Eexc(nm)    coef:',
     2/,80(1h-))
      if(ist.eq.1)open(23,file='EV.SCR',form='unformatted')
      if(ist.eq.3)open(23,file='EVT.SCR',form='unformatted')
      do i=1,nv
       read(23)(cci(j),j=1,ncih)
       jmax=1
       do j=2,ncih
        if(abs(cci(j)).gt.abs(cci(jmax)))jmax=j
       enddo
       jmax1=1
       if(jmax.eq.jmax1)jmax1=2
       do j=1,ncih
        if(abs(cci(j)).gt.abs(cci(jmax1)).and.j.ne.jmax)jmax1=j
       enddo
       del=d(i)-eground
       delev=del*27.210d0
       delnm=0.0d0
       if(del.gt.1.0d-6)delnm=1.0d0/(del*219470.0d0)*1.0d7
       write(3,9000)
     1 i,d(i),del,delev,delnm,jmax,cci(jmax),jmax1,cci(jmax1)
       if(i.le.10)write(6,9000)
     1 i,d(i),del,delev,delnm,jmax,cci(jmax),jmax1,cci(jmax1)
9000   format(i5,f12.4,f10.6,2f10.4,2(i5,':',f10.6))
      enddo
      close(23)
      mcp=mclock()
      write(6,*)' Time spent ',mcp-mc
      write(3,*)' Time spent ',mcp-mc
      mc=mcp
c
      if(ist.eq.1)nv1=nv
      if(ist.eq.1)ncih1=ncih
      if(ist.eq.1)nsl1=nsl
1     continue
c
c     rest for singlets only:
c
c     make dipole moments in CI basis
      call cigd(nmo,ncih1,nsl1)
c
c     transform integrals
      call cigt(ncih1,nv1,nat)
c
      nv=nv1
c
c     read ground state only
      do i=1,nel
       open(20+i,file=fnc(i),form='unformatted')
       read(20+i)(onj(j,i),j=1,nv)
       close(20+i)
      enddo
c
c     use groud state quadrupole for chid:
      xx=onj(1,4)
      xy=onj(1,5)
      xz=onj(1,6)
      yy=onj(1,7)
      yz=onj(1,8)
      zz=onj(1,9)
      chid(1,1)=-qua*(yy+zz)
      chid(2,2)=-qua*(xx+zz)
      chid(3,3)=-qua*(yy+xx)
      chid(1,2)=qua*xy
      chid(2,1)=qua*xy
      chid(1,3)=qua*xz
      chid(3,1)=qua*xz
      chid(2,3)=qua*yz
      chid(3,2)=qua*yz
c
      sp=(chid(1,1)+chid(2,2)+chid(3,3))/three
      write(3,*)'Susceptibility, diamagnetic, in atomic units:'
      write(3,4006)((chid(i,j),i=1,3),j=1,3),sp
4006  format(/,'                          ',15x,'X',15x,'Y',15x,'Z',/,
     1         '    Chi                   ',3F16.8,/,
     1         '                          ',3F16.8,/,
     2         '                          ',3F16.8,/,
     3         '                          ',16(1H-),/,
     3         '    (Tr Chi)/3            ',F16.8,/,/)
c
c     sum over excited states j:

      do 5 j=2,nv
      write(6,*)j,d(j)
      enj=d(j)-d(1)
      if(abs(enj-wexc).lt.tol)then
       write(3,*)'resonance ',j,enj
       goto 5
      else
       f2=2.0d0/((enj+wexc)*(enj-wexc))
       wjnf=enj*f2
       do 12 ix=1,3
       do 12 jx=1,3
       alp( ix,jx  )=alp( ix,jx  )+onj(j,  ix)*onj(j,   jx)*wjnf
       a(   ix,jx  )=a(   ix,jx  )+onj(j,  ix)*onj(j,3 +jx)*wjnf
       a(   ix,jx+3)=a(   ix,jx+3)+onj(j,  ix)*onj(j,6 +jx)*wjnf
       g(   ix,jx  )=g(   ix,jx  )-onj(j,  ix)*onj(j,9 +jx)*  f2
       alpv(ix,jx  )=alpv(ix,jx  )+onj(j,  ix)*onj(j,12+jx)*  f2
12     chip(ix,jx  )=chip(ix,jx  )+onj(j,9+ix)*onj(j,9 +jx)*wjnf
      endif
5     continue
c
c     construct the traceless A:
      do 8 ix=1,3
      xx=a(ix,1)
      xy=a(ix,2)
      xz=a(ix,3)
      yy=a(ix,4)
      yz=a(ix,5)
      zz=a(ix,6)
      a(ix,1)=half*(two*xx-zz-yy)
      a(ix,2)=half*three*xy
      a(ix,3)=half*three*xz
      a(ix,4)=half*(two*yy-zz-xx)
      a(ix,5)=half*three*yz
8     a(ix,6)=half*(two*zz-xx-yy)
c
      open(33,file='AL.TEN')
      write( 3,4000)'Alpha   (au)',wexc,((alp(ix,jx),ix=1,3),jx=1,3)
      write(33,4000)'Alpha   (au)',wexc,((alp(ix,jx),ix=1,3),jx=1,3)
4000  format(a12,/,
     1       ' (wexc=',f12.6,' au)',/,19x,'X',19x,'Y',19x,'Z',/,
     2       3(3F20.9,/),/)
      close(33)
      write(3,4004)(alp(1,1)+alp(2,2)+alp(3,3))/3.0d0
4004  format('Trace/3 = ',f20.9,/)
c
      open(33,file='ALV.TEN')
      write(3 ,4000)'Alpha V (au)',wexc,((alpv(ix,jx),jx=1,3),ix=1,3)
      write(33,4000)'Alpha V (au)',wexc,((alpv(ix,jx),jx=1,3),ix=1,3)
      close(33)
      write(3,4004)(alpv(1,1)+alpv(2,2)+alpv(3,3))/3.0d0
c
      open(33,file='A.TEN')
      write(33,4003)a(1,1),a(1,4),a(1,6),a(1,2),a(1,3),a(1,5),
     1             a(2,1),a(2,4),a(2,6),a(2,2),a(2,3),a(2,5),
     1             a(3,1),a(3,4),a(3,6),a(3,2),a(3,3),a(3,5)
      write(3,4003)a(1,1),a(1,4),a(1,6),a(1,2),a(1,3),a(1,5),
     1             a(2,1),a(2,4),a(2,6),a(2,2),a(2,3),a(2,5),
     1             a(3,1),a(3,4),a(3,6),a(3,2),a(3,3),a(3,5)
4003  format(' Electric dipole - electric quadrupole polarizability',/,
     1       ' (A, in atomic units)',/,
     1        11x,'XX',11x,'YY',11x,'ZZ',11x,'XY',11x,'XZ',11x,'YZ',/,
     2       3(6F18.8,/),/)
      close(33)
c
      open(33,file='G.TEN')
      write(3 ,4002)((g(i,j),j=1,3),i=1,3)
      write(33,4002)((g(i,j),j=1,3),i=1,3)
4002  format(' Electric dipole - magnetic dipole polarizability',/,
     1' (static limit of the tensor, w^-1G',1h',', in atomic units)',/,
     1        18x,'BX',18x,'BY',18x,'BZ',/,
     2       3(3F20.9,/),/)
      close(33)
c
      do 22 i=1,3
      do 22 j=1,3
      alc(i,j)=alp(i,j)
22    alcv(i,j)=alpv(i,j)
      ii=0
      do 21 i=1,3
      do 21 j=i,3
      ii=ii+1
      do 21 k=1,3
      ac(k,i,j)=a(k,ii)
21    ac(k,j,i)=a(k,ii)
c
      write(3,*)
     1'Susceptibility, paramagnetic, static limit, in atomic units:'
      spap=(chip(1,1)+chip(2,2)+chip(3,3))/three
      write(3,4006)((chip(i,j),i=1,3),j=1,3),spap
c
      do 14 i=1,3
      do 14 j=1,3
14    chid(i,j)=chid(i,j)+chip(i,j)
      spa=spap+sp
      write(3,*)'Susceptibility, total, in atomic units:'
      write(3,4006)((chid(i,j),i=1,3),j=1,3),spa
c
      write(6,*)' Leaving dcipol ..'
      return
      end
