      SUBROUTINE DOMA(A,NDIM,N,C,NAT)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      parameter (nat0=190,n30=3*nat0,AMACH=1.0D-9)
      DIMENSION C(3,NAT0),A(NDIM,N),TEM(n30,n30)
C
      call vz(A,0.0D0,NDIM*N)
      DO 1 I=1,NAT
C     Tx,Ty,Tz:
      A(3*I-2,1)= 1.00D0
      A(3*I-1,2)= 1.00D0
      A(3*I  ,3)= 1.00D0
C     Rz=Yx-Xy
      A(3*I-1,4)= C(1,I)
      A(3*I-2,4)=-C(2,I)
c     Ry=Xz-Zx
      A(3*I-2,5)= C(3,I)
      A(3*I  ,5)=-C(1,I)
c     Rx=Zy-Yz
      A(3*I  ,6)= C(2,I)
1     A(3*I-1,6)=-C(3,I)
      N6=6
      call wmtr(a,ndim,3*nat,'AA',1)
      CALL ORT(A,NDIM,N6,NAT)
      call wmtr(a,ndim,3*nat,'AAN',1)
      ICOL=1
5     IF(ICOL.GT.N6)GOTO 8
      S=0.0D0
      DO 6 J=1,N
6     S=S+A(J,ICOL)**2
      IF(S.LT.AMACH)THEN
       DO 7 J=1,N
7      A(J,ICOL)=A(J,N6)
       N6=N6-1
       GOTO 5
      ENDIF
      ICOL=ICOL+1
      GOTO 5
8     CONTINUE
      WRITE(*,*)N6,' coordinates projected'
      DO 2 I=1,N
      DO 2 J=1,N
      TEM(I,J)=0.0D0
      DO 2 II=1,N6
2     TEM(I,J)=TEM(I,J)+A(I,II)*A(J,II)
      DO 3 I=1,N
      DO 4 J=1,N
4     A(I,J)=-TEM(I,J)
3     A(I,I)=A(I,I)+1.0D0
      call wmtr(a,ndim,3*nat,'AAR',1)
      RETURN
      END
C     ============================================================
      SUBROUTINE ORT(A,NDIM,N6,NAT)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      DIMENSION A(NDIM,N6)
      AMACH=1.0D-12
      NAT3=3*NAT
      C=0.0D0
      DO 1 I=1,NAT3
1     C=C+A(I,1)**2
      IF(C.GT.AMACH)C=1.0D0/SQRT(C)
      DO 2 I=1,NAT3
2     A(I,1)=A(I,1)*C
      DO 3 IC=2,N6
C     Column IC, orthonormalize to previous columns:
      DO 3 ICP=1,IC-1
      SP=0.0D0
      DO 5 J=1,NAT3
5     SP=SP+A(J,IC)*A(J,ICP)
C     Subtract projection to ICP:
      DO 6 J=1,NAT3
6     A(J,IC)=A(J,IC)-SP*A(J,ICP)
C     Normalize :
      SP=0.0D0
      DO 7 J=1,NAT3
7     SP=SP+A(J,IC)**2
      IF(SP.GT.AMACH)SP=1.0D0/SQRT(SP)
      DO 3 J=1,NAT3
3     A(J,IC)=A(J,IC)*SP
      RETURN
      END
C     ===
