      SUBROUTINE DOMA3(A,NDIM,N)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      PARAMETER (nat0=190)
      DIMENSION A(NDIM,N),TEM(nat0*3,nat0*3)
      AMACH=0.00000000000001
      NAT=N/3
      DO 12 I=1,N
      DO 12 J=1,6
12    A(I,J)=0.0
      DO 1 I=1,NAT
      A(3*I-2,1)= 1.00
      A(3*I-1,2)= 1.00
      A(3*I  ,3)= 1.00
C
C     comment out the rotational invariance
c     A(3*I-2,4)=-C(2,I)
c     A(3*I-1,4)= C(1,I)
c     A(3*I-1,5)=-C(3,I)
c     A(3*I  ,5)= C(2,I)
c     A(3*I-2,6)= C(3,I)
c     A(3*I  ,6)=-C(1,I)
1     CONTINUE
      N6=6
      CALL ORT(A,NDIM,N6,NAT)
      ICOL=1
5     IF(ICOL.GT.N6)GOTO 8
      S=0.0
      DO 6 J=1,N
6     S=S+A(J,ICOL)**2
      IF(S.LT.1000.0*AMACH)THEN
       DO 7 J=1,N
7      A(J,ICOL)=A(J,N6)
       N6=N6-1
       GOTO 5
      ENDIF
      ICOL=ICOL+1
      GOTO 5
8     CONTINUE
      WRITE(*,*)N6,' coordinates projected'
      WRITE(3,*)N6,' coordinates projected'
      DO 2 I=1,N
      DO 2 J=1,N
      TEM(I,J)=0.0
      DO 2 II=1,N6
2     TEM(I,J)=TEM(I,J)+A(I,II)*A(J,II)
      DO 3 I=1,N
      DO 4 J=1,N
4     A(I,J)=-TEM(I,J)
3     A(I,I)=A(I,I)+1.0
      RETURN
      END
