      subroutine dpolp(ioe)
c
c     g from hypervirial theorem
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700)
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension pix(nort),piy(nort),piz(nort),dmo(3,nort,nort),
     1g(3,3),aj(nort,nort),
     2ak(nort,nort)
      etol=0.00001
c
c     <MO|r|MO>
      do 3 i=1,nmo
      do 3 j=1,nmo
      do 3 k=1,3
3     dmo(k,i,j)=z0
      open(33,file='P.SCR',form='unformatted')
      do 1 i=1,nao
      read(33)(pix(j),j=1,nao)
      read(33)(piy(j),j=1,nao)
      read(33)(piz(j),j=1,nao)
      do 1 j=1,nao
      do 1 jmo=1,nmo
      cxj=cij(jmo,j)*pix(j)
      cyj=cij(jmo,j)*piy(j)
      czj=cij(jmo,j)*piz(j)
      do 1 imo=1,nmo
      dmo(1,imo,jmo)=dmo(1,imo,jmo)+cij(imo,i)*cxj
      dmo(2,imo,jmo)=dmo(2,imo,jmo)+cij(imo,i)*cyj
1     dmo(3,imo,jmo)=dmo(3,imo,jmo)+cij(imo,i)*czj
      close(33)
c
      do 4 i=1,3
      do 4 j=1,3
4     g(i,j)=z0
c
c
      call vz(ak,z0,nort*nao)
      call vz(aj,z0,nort*nao)
      if(ioe.gt.0)then
        open(23,file='AKJK.SCR',form='unformatted')
        read(23)((ak(i,j),i=1,nao),j=1,nao),((aj(i,j),i=1,nao),j=1,nao)
        close(23)
        write(6,*)'Coulomb and exchange terms read from scratch.'
        write(3,*)'Coulomb and exchange terms read from scratch.'
      endif
c
c     sum over occupied
      do 9 k=1,ndo
      ek=e(k)
c
c     sum over unoccupied
      do 10 j=ndo+1,nmo
c     energy difference only from Fock energies
      ejk=e(j)-ek
      if(ioe.eq.2)ejk=ejk-aj(j,k)+two*ak(j,k)
      if(abs(ejk).lt.etol)goto 10
      ejki=two/(ejk*ejk)
      uxkj=dmo(1,k,j)*ejki
      uykj=dmo(2,k,j)*ejki
      uzkj=dmo(3,k,j)*ejki
c
c     sum over unoccupied
      do 12 ie=ndo+1,nmo
c     if(ie.eq.j)goto 12
      eiek=e(ie)-ek
      if(ioe.eq.2)eiek=eiek-aj(ie,k)+two*ak(ie,k)
      if(abs(eiek).lt.etol)goto 12
      ax=eiek*(dmo(2,j,ie)*dmo(3,ie,k)-dmo(3,j,ie)*dmo(2,ie,k))
      ay=eiek*(dmo(3,j,ie)*dmo(1,ie,k)-dmo(1,j,ie)*dmo(3,ie,k))
      az=eiek*(dmo(1,j,ie)*dmo(2,ie,k)-dmo(2,j,ie)*dmo(1,ie,k))
      g(1,1)=g(1,1)-uxkj*ax
      g(1,2)=g(1,2)-uxkj*ay
      g(1,3)=g(1,3)-uxkj*az
      g(2,1)=g(2,1)-uykj*ax
      g(2,2)=g(2,2)-uykj*ay
      g(2,3)=g(2,3)-uykj*az
      g(3,1)=g(3,1)-uzkj*ax
      g(3,2)=g(3,2)-uzkj*ay
      g(3,3)=g(3,3)-uzkj*az
12    continue
10    continue
9     continue
      write(3,*)' w^-1G by hypervirial theorem (atomic units):'
      write(3,4000)((g(j,i),i=1,3),j=1,3)
4000  format(/,'                          ',15x,'X',15x,'Y',15x,'Z',/,
     1         '              x           ',3F16.8,/,
     1         '              y           ',3F16.8,/,
     2         '              z           ',3F16.8,/)
c
      return
      end
