      subroutine edo(DMAO,ri,rj,nao,noa,alpha,ty,nop,ish)
c     electric dipole overlaps, AO
      implicit none
      integer*4  nat0,nor,nort,n1e,NTT,u0
      parameter (nat0=190,nor=80,nort=700,n1e=4,NTT=nort*(nort+1)/2,
     1u0=28)
      real*8 DMAO(NTT,3),cci(u0),ccj(u0),alpha(nat0,nor),
     3sv(n1e,u0,nort),b6(n1e,u0,u0),aai(u0,u0),aaj(u0,u0),
     4aad(u0,u0),aaf(u0,u0),aa1(u0,u0),tol,spi,ri(nat0,3),rj(nat0,3),
     4aag(u0,u0),aah(u0,u0),aaii(u0,u0),
     5xi,yi,zi,ai,xj,yj,zj,aj,tt,aij,ef,ec,con,
     2xij,yij,zij,t,r2ij,coe,oi,x2ij,y2ij,z2ij,
     1ox,oy,oz,sx,sy,sz,aiii,ajjj
      integer*4 nxi(u0),nyi(u0),nzi(u0),nxj(u0),nyj(u0),nzj(u0),
     1i,j,k,io,ia,noa,nop(nat0),ish(nat0,nor),icha,n1,ii,ioj,ioo,iorb,
     2ip,ipp,ja,jj,jo,joo,jp,jpp,kk,nao,npi,npii,npj,npjj
      real*8 pi,clau,spt,bohr,debye
      common/const/pi,clau,spt,bohr,debye
      character*1 ty(nat0,nor)
      logical ld5,lf7,lsprint,lopt
      common/opts/lopt(300),icha,n1
      equivalence (lopt(1),lsprint),(lopt(4),ld5),(lopt(8),lf7)
      real*8 z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
c
      call inipoly
      call initfd(aa1,aad,aaf,aag,aah,aaii)
      tol=100.0d0
      spi=sqrt(pi*pi*pi)

      do 10 i=1,nao
      do 10 j=1,u0
      do 10 k=1,n1e
10    sv(k,j,i)=z0
C
C     atom i, orbital io
      io=0
      do 2 ia=1,noa
      xi=ri(ia,1)
      yi=ri(ia,2)
      zi=ri(ia,3)
c
c     primitive functions on atom ia:
      do 3 ip=1,nop(ia)
      ai=alpha(ia,ip)
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
c
C     atom j, orbital jo
      jo=0
      do 4 ja=1,noa
      xj=rj(ja,1)
      yj=rj(ja,2)
      zj=rj(ja,3)
      xij=xj-xi
      yij=yj-yi
      zij=zj-zi
      x2ij=xij*xij
      y2ij=yij*yij
      z2ij=zij*zij
      r2ij=x2ij+y2ij+z2ij
c
c     primitive functions on atom ja:
      do 5 jp=1,nop(ja)
      aj=alpha(ja,jp)
      call nppp(ty(ja,jp),npj,npjj,ccj,nxj,nyj,nzj,
     1aaj,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ja,jp)
      aij=ai+aj
      tt=one/aij
      t=sqrt(tt)
      ec=ai*aj*r2ij*tt
      ef=z0
      if(ec.lt.tol)then
       ef=spi*exp(-ec)
      else
       goto 777
      endif
c
C     Loop over orbitals to which the primitives ip, jp contribute
      do 71 joo=1,npj
      con=ef*ccj(joo)
      do 71 ioo=1,npi
      coe=con*cci(ioo)
      sx=oi(0,nxi(ioo),nxj(joo),ai,aj,xij,t,xi,xj)
      sy=oi(0,nyi(ioo),nyj(joo),ai,aj,yij,t,yi,yj)
      sz=oi(0,nzi(ioo),nzj(joo),ai,aj,zij,t,zi,zj)
      ox =oi(1,nxi(ioo),nxj(joo),ai,aj,xij,t,xi,xj)
      oy =oi(1,nyi(ioo),nyj(joo),ai,aj,yij,t,yi,yj)
      oz =oi(1,nzi(ioo),nzj(joo),ai,aj,zij,t,zi,zj)
c     overlap
      b6(1,ioo,joo)=sx*sy*sz
c     electric dipole
      b6(2,ioo,joo)=ox*sy*sz
      b6(3,ioo,joo)=sx*oy*sz
      b6(4,ioo,joo)=sx*sy*oz
      do 71 k=1,n1e
71    b6(k,ioo,joo)=b6(k,ioo,joo)*coe
c
      if(npi.ne.npii.or.npjj.ne.npj)then
       do 74 ioo=1,npii
       do 74 joo=1,npjj
       ioj=joo+jo
       do 74 ipp=1,npi
       aiii=aai(ioo,ipp)
       do 74 jpp=1,npj
       ajjj=aaj(joo,jpp)*aiii
       do 74 k=1,n1e
74     sv(k,ioo,ioj)=sv(k,ioo,ioj)+ajjj*b6(k,ipp,jpp)
      else
       do 7 ioo=1,npi
       do 7 joo=1,npj
       ioj=joo+jo
       do 7 k=1,n1e
7      sv(k,ioo,ioj)=sv(k,ioo,ioj)+b6(k,ioo,joo)
      endif
c
777   if(ish(ja,jp+1).gt.ish(ja,jp)) jo=jo+npjj
c
5     continue
4     continue
C
      if(ish(ia,ip+1).gt.ish(ia,ip))then
c     if last primitive of the orbitals io+1 ... io+npii, then write them
       do 33 ii=1,npii
       iorb=ii+io
       do 33  kk=2,4
       do 33  jj=1,iorb
c      write(6,*)kk,ii,jj,sv(kk,ii,jj)
33     DMAO(iorb+(iorb-1)*iorb/2,kk-1)=sv(kk,ii,jj)
       io=io+npii
c
c      zero-out temporary buffer:
       do 9 ii=1,u0
       do 9 jj=1,nao
       do 9 kk=1,n1e
9      sv(kk,ii,jj)=z0
      endif
3     continue
2     continue
      return
      end
