      subroutine eeget(ee,ioe,kmin,kmax,ndo,lscf,nori,jmin,jmax,lall,
     1lres,lmp2,lmpn4,nzz,lonly,gconfig,Nro,half,xr0,ddG,Nro3,
     1yr0,zr0,delG,rrx,rry,rrz,ijkk,ijkj,is1,is2,Z0,one,lsp,nsa,nsb,
     1dk,mk,alk,rlk,dj,mj,alj,rlj,nr,two,I0,lsubst,nsubst,es,e,nao,
     1nmo,Ione)
      implicit none
      integer*4 ioe,kmin,kmax,ndo,nori,jmin,jmax,Nro,ii,k,Nro3,
     1ijkk(3,Nro3),ijkj(3,Nro3),is1(*),is2(*),Nrk,jstart,io,Nrj,
     2ik,ij,ix,iy,iz,jx,jy,jz,idx,idy,idz,kind,mcp,mclock,
     3nsa,nsb,nr,mk,ndeg,jdeg,mj,I0,nsubst,nmo,i,Ione,ioo,isu,j,jj,
     4mc,nao,nzz
      logical lscf,lall,lar,lres,lmp2,lmpn4,larmp2,lonly,lsp,lsubst,
     1gconfig
      real*8,dimension(:,:),allocatable::ak,aj
      real*8,dimension(:),allocatable::palpha,pbeta,rok,roj
      real*8 e_c,e_x,q_c,q_x,ddG,half,delG,xr0m,yr0m,zr0m,xr0,
     1yr0,zr0,dum,rrx(*),rry(*),rrz(*),delV,c,ck1,ck2,
     2ck3,ajkj,akkj,z0,xk,yk,zk,r1,r2,xjk,yjk,zjk,aex,one,
     1dk(*),dj(*),alk(*),alj(*),rlk(3,nr),rlj(3,nr),
     3ckj,ekj,two,es(*),e(*),ejk,ee(*)

      allocate(ak(nzz,nzz),aj(nzz,nzz),palpha(nao**2),pbeta(nao**2),
     1rok(Nro3),roj(Nro3))
      write(6,*)' eeget - variables allocated'

      if(nsa.ne.0.or.nsb.ne.0)
     1call report('Non zero nsa nsb not implemented')

      jdeg=0
      mc=mclock()
      write(6,*)' time ',mc
      write(6,*)' Nro ',Nro

      if(ioe.ne.0)then
       call inibe4
       if(kmin.eq.0)kmin=1
       if(kmax.eq.0)then
        kmax=ndo
        if(lscf)kmax=nori
       endif
       if(jmin.eq.0)then
        jmin=ndo+1
        if(lscf.or.lall)jmin=1
       endif
       if(jmax.eq.0)jmax=nori
       inquire(file='AKJK.SCR',exist=lar)
       if(lres.and..not.lar)call report('AKJK.SCR does not exist')
       if(lmp2)then
        larmp2=.false.
        if(lmpn4)then
         inquire(file='BBCD.SCR',exist=larmp2)
        endif
        if(.not.larmp2)then
         call w36('MP2 cannot restart')
         lar=.false.
        endif
       endif
       if(lar)then
        lres=.true.
        open(23,file='AKJK.SCR',form='unformatted')
        read(23)((ak(i,j),i=1,nzz),j=1,nzz),((aj(i,j),i=1,nzz),j=1,nzz)
        if(lonly)then
         read(23)(palpha(i),i=1,nao**2),(pbeta(i),i=1,nao**2),e_c,e_x
         if(gconfig)read(23)q_c,q_x
         call w36('density matrix read from scratch')
        endif
        close(23)
        call w36('J,K read from scratch')
       endif
      endif

      if(ioe.eq.4.and..not.lres)then
       call setlr(Nro)
       ddG=half*delG
       xr0m=xr0-ddG
       yr0m=yr0-ddG
       zr0m=zr0-ddG
       do 550 ii=1,Nro
       dum=dble(ii)*delG
       rrx(ii)=xr0m+dum
       rry(ii)=yr0m+dum
550    rrz(ii)=zr0m+dum
       delV=delG**3
       c=1.8811D0/delG
       ck1=0.980886D0/delG
       ck2=0.708495114d0/delG
       ck3=0.578797d0/delG
c
       do 500 k=kmin,kmax
c
c      density for k-orbital:
       call roapp(k,rok,Nro3,ijkk,Nro,Nrk)
       jstart=jmin
c      if(jstart.lt.k)jstart=k
       do 500 j=jstart,jmax
c
c      density for j-orbital:
       if(j.eq.k)then
        do 501 io=1,Nrk
        roj(io)=rok(io)
        do 501 ioo=1,3
501     ijkj(ioo,io)=ijkk(ioo,io)
        Nrj=Nrk
       else
        call roapp(j,roj,Nro3,ijkj,Nro,Nrj)
       endif
       write(6,*)'Calculating J,K for orbitals ',k,',',j
       ajkj=z0
       akkj=z0
       do 400 ik=1,Nrk
       ix=ijkk(1,ik)
       iy=ijkk(2,ik)
       iz=ijkk(3,ik)
       xk=rrx(ix)
       yk=rry(iy)
       zk=rrz(iz)
       r1=rok(ik)
       do 401 ij=1,Nrj
       r2=roj(ij)*r1
       jx=ijkj(1,ij)
       jy=ijkj(2,ij)
       jz=ijkj(3,ij)
       idx=abs(ix-jx)
       idy=abs(iy-jy)
       idz=abs(iz-jz)
       if(idx.gt.1)goto 99
       if(idy.gt.1)goto 99
       if(idz.gt.1)goto 99
       kind=idx+idy+idz
       if(kind.eq.0)then
        ajkj=ajkj+r2*c
       else
        if(kind.eq.1)then
         ajkj=ajkj+r2*ck1
        else
         if(kind.eq.2)then
          ajkj=ajkj+r2*ck2
         else
          ajkj=ajkj+r2*ck3
         endif
        endif
       endif
       goto 401
99     xjk=rrx(jx)-xk
       yjk=rry(jy)-yk
       zjk=rrz(jz)-zk
       ajkj=ajkj+r2/sqrt(xjk*xjk+yjk*yjk+zjk*zjk)
401    continue
400    continue
       ajkj=ajkj*delV*delV
       aj(k,j)=ajkj
       ak(k,j)=akkj
       aj(j,k)=ajkj
       ak(j,k)=akkj
500    continue
      endif
c
      if((ioe.eq.2.or.ioe.eq.3).and..not.lres)then
       call dox31
      endif
c
      if(ioe.eq.1)call report('ioe=1 not implemented')
c
      if(ioe.gt.0)then
       aex=one
       if(ioe.eq.3)aex=z0
       if(lscf)call overlav
       if(.not.lres)then
        open(23,file='AKJK.SCR',form='unformatted')
        write(23)((ak(i,j),i=1,nzz),j=1,nzz),((aj(i,j),i=1,nzz),j=1,nzz)
        if(lonly)then
         write(23)(palpha(i),i=1,nao**2),
     1            ( pbeta(i),i=1,nao**2),e_c,e_x
         if(gconfig)write(23)q_c,q_x
        endif
        close(23)
        write(3,*)'AKJK.SCR written'
        write(6,*)'AKJK.SCR written'
       endif
       if(lsp)lres=.true.
      endif
c
      mcp=mclock()
      write(6,*)' Time spent ',mcp-mc
      write(3,*)' Time spent ',mcp-mc
c
      write(3,3334)
3334  format(
     1'  j  k         ejk =         ej -         ek -      Jjk + 2 x ',
     2'       Kjk',/,80(1H-))
c
      do 5 k=kmin,kmax
c
c     if desired, fit the density of the MO k
      if(ioe.eq.1)then
       mc=mclock()
       call fitro1(k,dk,mk,alk,rlk)
c
c      ro_k=c_kl fl  l=1..M,   fl=exp(-al*(r-rl)^2)
c
       mcp=mclock()
       write(6,*)' fit time ',mcp-mc
       write(3,*)' fit time ',mcp-mc
      endif
c
      do 5 j=jmin,jmax
c
c     energy difference by a vertical excitation scheme
c     dE=ej-ek-Jjk+2Kjk, ei Fock energies, Kjk neglected
      ejk=e(j)-e(k)
      ndeg=1
c
c     check for degeneracy
      if(ioe.gt.0)then
       do 2 jj=1,nmo
       if(jj.eq.j)goto 2
       if(abs(e(j)-e(jj)).lt.0.0001d0)then
        ndeg=ndeg+1
        jdeg=jj
       endif
2      continue
      endif
      if(ndeg.gt.2)call w36('Warning: High degeneracy!')
c
      if(ioe.eq.2.or.ioe.eq.3.or.ioe.eq.4)then
       if(ndeg.eq.1)then
        ckj=aj(k,j)
        ekj=ak(k,j)*aex
       else
        ckj=half*(aj(k,j)+aj(k,jdeg))
        ekj=half*(ak(k,j)+ak(k,jdeg))*aex
       endif
       ejk=ejk-ckj+two*ekj
       write(3,3333)k,j,ejk,e(j),e(k),ckj,ekj
3333  format(I3,'->',I3,': ',F10.5,' = ',F10.4,' - ',F10.4,' - ',F10.4,
     1' + 2 x ',F10.4)
      else
       write(3,3333)k,j,ejk,e(j),e(k)
      endif
c
      if(ioe.eq.1)then
       if(k.eq.1)then
        mc=mclock()
        call fitro1(j,dj,mj,alj,rlj)
        call savero(j,dj,mj,I0,ndo)
        mcp=mclock()
        write(6,*)' fit time ',mcp-mc
        write(3,*)' fit time ',mcp-mc
       else
        call savero(j,dj,mj,Ione,ndo)
       endif
       call dojk(j,k,dj,mj,alj,rlj,dk,mk,alk,rlk)
       ejk=ejk-aj(k,j)+two*ak(k,j)
       write(3,3333)j,k,ejk,e(j),e(k),aj(k,j),ak(k,j)
       write(6,3333)j,k,ejk,e(j),e(k),aj(k,j),ak(k,j)
      endif
c
      if(lsubst)then
       do isu=1,nsubst
        if(k.eq.is1(isu).and.j.eq.is2(isu))then
         write(6,6099)k,j,es(isu)
6099     format(2i4,' energy substituted by ',f12.6)
         ejk=es(isu)
        endif
       enddo
      endif
c
5     ee(j+nmo*(k-1))=ejk
      deallocate(ak,aj,palpha,pbeta,rok,roj)
      return
      end
