      subroutine iactivate(mij,mkl,qx,qy,qz,px,py,pz,
     1           eep,pqx,pqy,pqz,hsp,hsq,tol)
c
c     calculates the [0](m) functions up to mmx
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (mmax=21,nX=2000)
      dimension eep(mmax),eeq(mmax)
      common/ap4/et(nX),ei(mmax,nX),dt(mmax),dt63(mmax),dt62(mmax),
     1ti(mmax),t5(mmax),dtt,t23,dtt2,dtt3
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/const/pi,clau,spt,bohr,debye
      logical l333,lopt
      common/opts/lopt(300),icha,n1
      equivalence (lopt(33),l333)
c
      mmx=mkl+mij
      am=dble(mmx)
      itm=mmx+mmx
      twoam=am+am
      m1=mmx+1
c
      pqx=qx-px
      pqy=qy-py
      pqz=qz-pz
      r2=pqx*pqx+pqy*pqy+pqz*pqz
      sq1=half/(hsp+hsq)
      sq2=sq1+sq1
      sq22=sqrt(sq2)
      t=sq1*r2
c
c     initialize sq22^(2m+1), m=0..mmx:
      eeq(1)=sq22
      dum=sq22*sq22
      do 44 m=1,mmx
      eeq(m+1)=eeq(m)*dum
44    continue
c
c     initialize ee(T,m) * sq22**(2m+1):
c
c     1) initialize function EE4(T,m) for m=mmx
c
c     The approximate error function
c
c                         1
c                         /
c                        |     2m  -Tu^2
c      E(T) = sqrt(2/pi) |    u   e     du    m=0..12
c                        |
c                       /
c                       0
c
c     common app must be initialized befor use
c
c
c     if t>t5, use the limit formula
c
c     for 0<t<t5 use the interpolation formula
      del=dt(m1)
c
c     prevent overflow in some compilers (ftn77):
      ablb=t/del
      if(ablb.ge.dble(nX-3))goto 8882
      jmm=int(ablb)
      jm =jmm+1
      jp =jm +1
      jpp=jp +1
c     if(jpp.ge.nX)goto 8882
      if(jmm.lt.1)then
       jmm=1
       jm =2
       jp =3
       jpp=4
      endif
      fp=ei(m1,jp)
      fm=ei(m1,jm)
      fm2=ei(m1,jmm)
      tm2=del*dble(jmm-1)
      tm=tm2+del
      tms=tm*tm
      tp=tm+del
      if(l333)then
c      quadratic interpolation
       a=(fm2-fm-fm+fp)/(del*(del+del))
       b=(fp-fm)/del-(tm+tm+del)*a
       c=fm-a*tms-b*tm
       E44=c+t*(b+t*a)
      else
c     cubic interpolation
       fp2=ei(m1,jpp)
       tm2s=tm2*tm2
       d=(fp2+three*(fm-fp)-fm2)*dt63(m1)
       c=(fp-fm-fm+fm2-d*(tp*tp*tp-(tm+tm)*tms+tm2*tm2s))*dt62(m1)
       b=(fm-fm2-(c+d*tm)*tms+(c+d*tm2)*tm2s)/del
       a=fm2-tm2*(b+tm2*(c+d*tm2))
       E44=a+t*(b+t*(c+t*d))
      endif
      goto 8989
c
8882  fac=one
      ai=one
      sq=one/sqrt(t+t)
155   fac=ai*fac
      ai=ai+two
      if(ai.lt.twoam)goto 155
      fac=fac*sq
      ig=itm
899   if(ig.gt.0)then
       fac=fac*sq
       ig=ig-1
       goto 899
      endif
      E44=fac
8989  continue
c
c     save it into the array eep:
      eep(m1)=E44
c
c     2)lower ms by the downward recursion
      if(mmx.gt.0)then
       twot=t+t
       if(t.gt.tol-dtt)then
        EP=z0
       else
        if(l333)then
c        quadratic interpolation
         jmm=max(1,int(t/dtt))
         jm=jmm+1
         jp=jm+1
         tm=dtt*dble(jmm)
         fm2=et(jmm)
         fm=et(jm)
         fp=et(jp)
         a=(fm2-fm-fm+fp)*dtt2
         b=(fp-fm)/dtt-(tm+tm+dtt)*a
         c=fm-(a*tm+b)*tm
         EP=c+t*(b+t*a)
        else
         EP=exp(-t)
        endif
       endif
c
       do 444 m=mmx-1,0,-1
       m2=m+1
       eep(m2)=one/dble(m+m2)*(twot*eep(m2+1)+spt*EP)
444    continue
      endif
c
c     form the product and zero-out eeq
c     write(6,*)eep(1),eep(2),mmx,t,spt,ep,one
      do 4444 m=1,m1
4444  eep(m)=eep(m)*eeq(m)
c
      return
      end
