      subroutine normorb
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      character*2 at
      character*1 ok,ty
      parameter (nat0=190,nor=80,nort=700)
      integer*4 u0
      parameter (u0=28)
      common/atoms/q(nat0),zsum,xv(3,nat0)
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/spdfgh/ccs(nat0,nor),ccp(nat0,nor),ccd(nat0,nor,2),
     1ccf(nat0,nor,3),cci_G(nat0,nor,15),cci_H(nat0,nor,21),
     2cci_I(nat0,nor,28),nxig(15),nyig(15),nzig(15),
     2nxih(21),nyih(21),nzih(21),nxii(28),nyii(28),nzii(28)
      common/const/pi,clau,spt,bohr,debye
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension nxi(u0),nyi(u0),nzi(u0),
     1nxj(u0),nyj(u0),nzj(u0),cci(u0),ccj(u0),
     3sv(u0,nort),b6(u0,u0),aai(u0,u0),aaj(u0,u0),
     4aad(u0,u0),aaf(u0,u0),aa1(u0,u0),
     4aag(u0,u0),aah(u0,u0),aaii(u0,u0)
      logical lsprint,lpprint,lqprint,ld5,levprint,lvprint,llprint,lf7,
     1ld2,SCALED,TTT,RAMAN,XYZ,ABINI,CC5,LAN,LDO,lvv,lsp,lex,
     1lscf,lres,lcndo,fspec,lrec,lc5,lg94,
     9lopt,lnno
      common/opts/lopt(300),icha,n1
      equivalence (lopt(1),lsprint),(lopt(2),lpprint),(lopt(3),lqprint),
     1(lopt(4 ),ld5    ),(lopt(5),levprint),(lopt(6),lvprint),
     1(lopt(7 ),llprint),(lopt(8),lf7     ),(lopt(9),ld2    ),
     1(lopt(10),SCALED ),(lopt(11),TTT    ),(lopt(12),RAMAN ),
     1(lopt(13),XYZ    ),(lopt(14),ABINI  ),(lopt(15),cc5   ),
     1(lopt(16),lan    ),(lopt(17),ldo    ),(lopt(18),lvv    ),
     1(lopt(19),lsp    ),(lopt(20),lex    ),(lopt(21),lscf   ),
     1(lopt(22),lres   ),(lopt(23),lcndo  ),(lopt(24),fspec  ),
     1(lopt(25),lrec   ),(lopt(26),lc5    ),(lopt(27),lg94   ),
     1(lopt(57),lnno   )
      dimension anorm(nort)
c
      call inipoly
      i0=0
      call initfd(aa1,aad,aaf,aag,aah,aaii)
c
      tol=100.0
      spi=sqrt(pi*pi*pi)
      do 10 i=1,nao
      anorm(i)=z0
      do 10 j=1,u0
10    sv(j,i)=z0
      write(3,4000)nao,noa
      write(6,4000)nao,noa
4000  format(I4,' orbitals read in',I4,' atoms')
C
c     first loop, determine norms:
      io=0
      do 2 ia=1,noa
      xi=xv(1,ia)
      yi=xv(2,ia)
      zi=xv(3,ia)
      do 3 ip=1,nop(ia)
      ai=alpha(ia,ip)
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
      if(npi.gt.u0)call report('npi > u0')
      jo=0
      do 4 ja=1,noa
      xj=xv(1,ja)
      yj=xv(2,ja)
      zj=xv(3,ja)
      xij=xj-xi
      yij=yj-yi
      zij=zj-zi
      x2ij=xij*xij
      y2ij=yij*yij
      z2ij=zij*zij
      r2ij=x2ij+y2ij+z2ij
      do 5 jp=1,nop(ja)
      aj=alpha(ja,jp)
      call nppp(ty(ja,jp),npj,npjj,ccj,nxj,nyj,nzj,
     1aaj,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ja,jp)
      aij=ai+aj
      tt=one/aij
      t=sqrt(tt)
      ec=ai*aj*r2ij*tt
      ef=z0
      if(ec.lt.tol)then
       ef=spi*exp(-ec)
      else
       goto 777
      endif
c
C     Loop over orbitals to which the primitives ip, jp contribute
      do 71 joo=1,npj
      con=ef*ccj(joo)
      do 71 ioo=1,npi
      coe=con*cci(ioo)
      sx=oi(i0,nxi(ioo),nxj(joo),ai,aj,xij,t,xi,xj)
      sy=oi(i0,nyi(ioo),nyj(joo),ai,aj,yij,t,yi,yj)
      sz=oi(i0,nzi(ioo),nzj(joo),ai,aj,zij,t,zi,zj)
71    b6(ioo,joo)=sx*sy*sz*coe
c
      if(npi.ne.npii.or.npjj.ne.npj)then
       do 74 ioo=1,npii
       do 74 joo=1,npjj
       ioj=joo+jo
       do 74 ipp=1,npi
       aiii=aai(ioo,ipp)
       do 74 jpp=1,npj
       ajjj=aaj(joo,jpp)*aiii
74     sv(ioo,ioj)=sv(ioo,ioj)+ajjj*b6(ipp,jpp)
      else
       do 7 ioo=1,npi
       do 7 joo=1,npj
       ioj=joo+jo
7      sv(ioo,ioj)=sv(ioo,ioj)+b6(ioo,joo)
      endif
c
777   if(ish(ja,jp+1).gt.ish(ja,jp)) jo=jo+npjj
c
5     continue
4     continue
C
      if(ish(ia,ip+1).gt.ish(ia,ip))then
c     if last primitive of the orbitals io+1 ... io+npii, then write them
       do 33 ii=1,npii
       iorb=ii+io
33     anorm(iorb)=sv(ii,iorb)
       io=io+npii
       do 9 ii=1,u0
       do 9 jj=1,nao
9      sv(ii,jj)=z0
      endif
3     continue
2     continue
c
      write(3,*)'atomic orbital norms before normalization:'
      write(6,*)'atomic orbital norms before normalization:'
      write(3,3000)(anorm(i),i=1,nao)
      write(6,3000)(anorm(i),i=1,nao)
3000  format(6f12.6)
c
c     second loop, normalize
C     atom i, orbital io
      io=0
      fac=1.0d0/sqrt(anorm(1))
      do 8 ia=1,noa
      do 6 ip=1,nop(ia)
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
      ccs(ia,ip  )=ccs(ia,ip  )*fac
      ccp(ia,ip  )=ccp(ia,ip  )*fac
      ccd(ia,ip,1)=ccd(ia,ip,1)*fac
      ccd(ia,ip,2)=ccd(ia,ip,2)*fac
      ccf(ia,ip,1)=ccf(ia,ip,1)*fac
      ccf(ia,ip,2)=ccf(ia,ip,2)*fac
      ccf(ia,ip,3)=ccf(ia,ip,3)*fac
      do i1=1,15
       cci_G(ia,ip,i1)=cci_G(ia,ip,i1)*fac
      enddo
      do i1=1,21
       cci_H(ia,ip,i1)=cci_H(ia,ip,i1)*fac
      enddo
      do i1=1,28
       cci_I(ia,ip,i1)=cci_I(ia,ip,i1)*fac
      enddo
      if(ish(ia,ip+1).gt.ish(ia,ip))then
       io=io+npii
       fac=1.0d0/sqrt(anorm(io+1))
      endif
6     continue
8     continue
      return
      end
