      function oc22(nxi,nyi,nzi,nxj,nyj,nzj,
     1eep, xij,yij,zij,pqx,pqy,pqz, hsp,aa,bb,ider,jder)
c
c      second derivative of the coulomb integral (ij||k=0 l=0) (AO) according
c      to the ider,jder-coordinates of the center of the l orbital.
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (mmax=21,lx4=10000)
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension eep(mmax),p(lx4),mp(lx4),nm(lx4,6),
     1 nderi(lx4), nderj(lx4)
      logical lider,ljder,ldiag
c
      ldiag=ider.eq.jder
      l=1
      p(1)=one
      nm(1, 1)=nxi
      nm(1, 2)=nyi
      nm(1, 3)=nzi
      nm(1, 4)=nxj
      nm(1, 5)=nyj
      nm(1, 6)=nzj
c
c     mp is the kind of the error function + 1 (!!!!)
      mp(1)=1
c
c     nderi: the power of (PQ)_ider in the coef of [ab|cd](m) term, nderj simila
      nderi(1)=0
      nderj(1)=0
c
      do 1 itoa=1,6
      goto(101,102,103,104,105,106)itoa
101   if(nxi.eq.0)goto 1
      itob=4
      ri=pqx
      tbe=bb*xij*hsp
      lider=ider.eq.1
      ljder=jder.eq.1
      goto 50
102   if(nyi.eq.0)goto 1
      itob=5
      ri=pqy
      tbe=bb*yij*hsp
      lider=ider.eq.2
      ljder=jder.eq.2
      goto 50
103   if(nzi.eq.0)goto 1
      itob=6
      ri=pqz
      tbe=bb*zij*hsp
      lider=ider.eq.3
      ljder=jder.eq.3
      goto 50
104   if(nxj.eq.0)goto 1
      itob=1
      ri=pqx
      tbe=-aa*xij*hsp
      lider=ider.eq.1
      ljder=jder.eq.1
      goto 50
105   if(nyj.eq.0)goto 1
      itob=2
      ri=pqy
      tbe=-aa*yij*hsp
      lider=ider.eq.2
      ljder=jder.eq.2
      goto 50
106   if(nzj.eq.0)goto 1
      itob=3
      ri=pqz
      tbe=-aa*zij*hsp
      lider=ider.eq.3
      ljder=jder.eq.3
c
50    continue
c
      ic=0
      newl=l
      do 3 il=1,l
      if(nm(il,itoa).gt.0)then
c
c      expand [a+1i b|c d](m) (c=d=0)
c
c      [ab|cd](m)
       nai=nm(il,itoa)
       if(nai.gt.1)ic=1
       pold=p(il)
       mpold=mp(il)
       nm(il,itoa)=nai-1
       nderiold=nderi(il)
       nderjold=nderj(il)
c
c  (8 and 7 never, c=d=0)
c
c  (6,5)
       if(nm(il,itob).gt.0)then
        p1=pold*dble(nm(il,itob))*hsp
        p2=-p1*hsp
c
c       [ab-1|cd](m)
        newl=newl+1
        p(newl)=p1
        mp(newl)=mpold
        do 96 i1=1,6
96      nm(newl,i1)=nm(il,i1)
        nm(newl,itob)=nm(newl,itob)-1
        nderi(newl)=nderiold
        nderj(newl)=nderjold
c
c       [ab-1|cd](m+1)
        newl=newl+1
        p(newl)=p2
        mp(newl)=mpold+1
        do 95 i1=1,6
95      nm(newl,i1)=nm(il,i1)
        nm(newl,itob)=nm(newl,itob)-1
        nderi(newl)=nderiold
        nderj(newl)=nderjold
       endif
c  (4,3)
       if(nai.gt.1)then
        p1=pold*dble(nm(il,itoa))*hsp
        p2=-p1*hsp
c
c       [a-1b|cd](m)
        newl=newl+1
        p(newl)=p1
        mp(newl)=mpold
        do 94 i1=1,6
94      nm(newl,i1)=nm(il,i1)
        nm(newl,itoa)=nm(newl,itoa)-1
        nderi(newl)=nderiold
        nderj(newl)=nderjold
c
c       [a-1b|cd](m+1)
        newl=newl+1
        p(newl)=p2
        mp(newl)=mpold+1
        do 93 i1=1,6
93      nm(newl,i1)=nm(il,i1)
        nm(newl,itoa)=nm(newl,itoa)-1
        nderi(newl)=nderiold
        nderj(newl)=nderjold
       endif
c
c  (2)
       p1=pold*hsp
       newl=newl+1
       if(ldiag)then
        if(lider)then
         nderi(newl)=nderiold+1
         nderj(newl)=nderjold+1
        else
         p1=p1*ri
         nderi(newl)=nderiold
         nderj(newl)=nderjold
        endif
       else
        if(lider)then
         nderi(newl)=nderiold+1
         nderj(newl)=nderjold
        else
         if(ljder)then
          nderj(newl)=nderjold+1
          nderi(newl)=nderiold
         else
          p1=p1*ri
          nderi(newl)=nderiold
          nderj(newl)=nderjold
         endif
        endif
       endif
c
c      [ab|cd](m+1)
       p(newl)=p1
       mp(newl)=mpold+1
       do 92 i1=1,6
92     nm(newl,i1)=nm(il,i1)
c  (1)
c
c      [ab|cd](m)
       p1=pold*tbe
       p(il)=p1
      endif
3     continue
      l=newl
      if(l+8.ge.lx4)goto 9999
      if(ic.eq.1)goto 50
c
1     continue
c
      sum=z0
      if(ider.eq.0.and.jder.eq.0)then
       do 22 i1=1,l
22     sum=sum+p(i1)*eep(mp(i1))
       goto 23
      endif
c
      if(ider.eq.1)ri=pqx
      if(ider.eq.2)ri=pqy
      if(ider.eq.3)ri=pqz
c
c     diagonal derivatives
      if(ldiag)then
       do 4 i1=1,l
c      V=sum of p(i1)*eep(mp(i1)) where p(i1)~(R_ider)^nderi(i1)
c
c      now, we need second derivative according to the R_ider
       nri=nderi(i1)
       m=mp(i1)
       if(nri.eq.0)then
        xn=one
       else
        xn=ri**nri
       endif
       sum=sum-p(i1)*eep(m+1)*xn*(1+dble(nri+nri))
     1        +p(i1)*eep(m+2)*ri**(nri+2)
       if(nri.gt.1)then
        if(nri.eq.2)then
         sum=sum+two*eep(m)*p(i1)
        else
         sum=sum+dble(nri)*real(nri-1)*eep(m)*ri**(nri-2)*p(i1)
        endif
       endif
4      continue
      else
c
c      off-diagonal derivatives
c
       if(jder.eq.1)rj=pqx
       if(jder.eq.2)rj=pqy
       if(jder.eq.3)rj=pqz
       do 2 i1=1,l
        nri=nderi(i1)
        nrj=nderj(i1)
        xnp1=ri**(nri+1)
        ynp1=rj**(nrj+1)
        m=mp(i1)
        sum=sum+eep(m+2)*p(i1)*xnp1*ynp1
        if(nrj.gt.0)then
         if(nrj.eq.1)then
          sum=sum-eep(m+1)*p(i1)*xnp1
         else
          sum=sum-dble(nrj)*eep(m+1)*p(i1)*xnp1*rj**(nrj-1)
         endif
        endif
        if(nri.gt.0)then
         if(nri.eq.1)then
          sum=sum-eep(m+1)*p(i1)*ynp1
         else
          sum=sum-dble(nri)*eep(m+1)*p(i1)*ynp1*ri**(nri-1)
         endif
        endif
        if(nri.gt.0.and.nrj.gt.0)then
         if(nri.eq.1)then
          px=one
         else
          px=dble(nri)*ri**(nri-1)
         endif
         if(nrj.eq.1)then
          py=one
         else
          py=dble(nrj)*rj**(nrj-1)
         endif
         sum=sum+p(i1)*px*py*eep(m)
        endif
2      continue
      endif
c
23    oc22=sum
      return
9999  call report('expansion overflow in oc22')
      end
