      subroutine oo
c
c     do the gradient < O > integrals
c
      implicit none
      integer*4 nat0,nor,nort
      parameter (nat0=190,nor=80,nort=700)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c
      character*2 at
      character*1 ok,ty
      real*8 escf,cc,alpha,rcp,cij,bij,e,be
      integer*4 nat,nao,nmo,noe,ichm,mtp,ndo,nsa,nsb,noa,nori,nop,
     1ish
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      logical lx
      integer*4 lat,ix,io
      real*8,allocatable::buff(:,:),tem(:,:),dd(:,:),g(:,:)

      write(6,*)' < o > gradient integrals'
      call inibe4

      allocate(buff(nort,nort),tem(nort,nort),dd(nort,nort),g(noa,3))
c
      inquire(file='OO.SCR.TXT',exist=lx)
      if(lx)return
      open(39,file='OO.SCR.TXT')
c     First loop over atoms - calculate <K|grad|J>(MO), save it to MX,MY,MZ
      write(6,*)'no scratch files found for gradient, recalculate'
      write(3,*)'no scratch files found for gradient, recalculate'
      do 1 lat=1,noa
      write(6,*)' Atom ',lat
      do 1 ix=1,3
      write(39,*)
      write(39,*)' Atom ',lat,' coordinate ',ix
c
c     calculate AO integrals (i|gradH_^latix|j), put them in buff
      call overlagg2(lat,ix,buff)
c
c     transform into MO basis and write into MXi.SCR:
      call taomo2(buff,dd,cij,nort,nort,nmo,nao,tem)

c     use if to calculate gradient as a by-product:
      g(lat,ix)=0.0d0
      do 2 io=1,ndo
2     g(lat,ix)=g(lat,ix)+dd(io,io)

1     call wmtr38(39,dd,nort,nmo,' ',1)
c
      WRITE(6,*)' OO.SCR.TXT written ...'
      WRITE(3,*)' OO.SCR.TXT written ...'

      call wgrad(g,nat)
      return
      end

      subroutine wgrad(g,nat)
c     write the Hellman-Feynman gradient in the Gausssian format
      implicit none
      integer*4 nat,ia,ix,nat0
      parameter (nat0=190)
      real*8 g(nat,3),z,zsum,xv
      common/atoms/z(nat0),zsum,xv(3,nat0)
      open(80,file='GRAD.SCR.TXT')
      write(80,803)
      write(80,801)
801   format(1x,'Center',5x,'Atomic',19x,'Forces (Hartrees/Bohr)',/,
     21x,'Number',5x,'Number',14x,'X',14x,'Y',14x,'Z')
      write(80,803)
      do 1 ia=1,nat
1     write(80,802)ia,int(z(ia)),(g(ia,ix),ix=1,3)
802   format(i7,i9,7x,3f15.9)
      write(80,803)
803   format(1x,67(1h-))
      close(80)
      write(6,*)'GRAD.SCR.TXT written'
      return
      end
