      subroutine ortog2(s,nao,c,nmo)
c     re-ortonormalizes MOs, as ortog, but AO overlap supplied as param.
c     nao .. number of AOs, but common dimension for s and c!
      implicit none
      integer*4 nao,nmo,i,j,ii,jj
      real*8 s(nao,nao),c(nao,nao),aij,an
c
c     orthonormalize
      do 3 i=1,nmo
c
      do 4 j=1,i-1
      aij=0.0d0
      do 1 ii=1,nao
      do 1 jj=1,nao
1     aij=aij+c(i,ii)*c(j,jj)*s(ii,jj)
      do 4 ii=1,nao
4     c(i,ii)=c(i,ii)-aij*c(j,ii)
c
      an=0.0d0
      do 2 ii=1,nao
      do 2 jj=1,nao
2     an=an+c(i,ii)*c(i,jj)*s(ii,jj)
      an=1.0d0/dsqrt(an)
      do 3 ii=1,nao
3     c(i,ii)=c(i,ii)*an
      return
      end

      subroutine scm(sc,s,nao,c,nmo)
      implicit none
      integer*4 nao,nmo,i,j,ii
      real*8 s(nao,nao),c(nao,nao),sc(nao,nmo)
      do 3 i=1,nao
      do 3 j=1,nmo
      sc(i,j)=0.0d0
      do 3 ii=1,nao
3     sc(i,j)=sc(i,j)+s(i,ii)*c(j,ii)
      return
      end

      subroutine pum(pu,c,sc,nao,nmo)
      implicit none
      integer*4 nao,nmo,i,j,ii
      real*8 sc(nao,nmo),c(nao,nao),pu(nmo,nmo)
      do 3 i=1,nmo
      do 3 j=1,nmo
      pu(i,j)=0.0d0
      do 3 ii=1,nao
3     pu(i,j)=pu(i,j)+c(i,ii)*sc(ii,j)
      return
      end
