      subroutine overgr(ic)
c
c     ic=0     <AOm| (1/2)[r-(1/2)(rn+rm)] x grad |AOn>
c     ic=1     <AOm| (1/2)[r-      rn    ] x grad |AOn>
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      character*2 at
      character*1 ok,ty
      parameter (nat0=190,nor=80,nort=700,n1e=3)
      integer*4 u0
      parameter (u0=28)
c     n1e ... number of kinds of one-electron integrals
      common/atoms/q(nat0),zsum,xv(3,nat0)
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/const/pi,clau,spt,bohr,debye
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension s(nort,nort),nxi(u0),nyi(u0),nzi(u0),
     1nxj(u0),nyj(u0),nzj(u0),cci(u0),ccj(u0),
     3sv(n1e,u0,nort),b6(n1e,u0,u0),aai(u0,u0),aaj(u0,u0),
     4aad(u0,u0),aaf(u0,u0),aa1(u0,u0),
     4aag(u0,u0),aah(u0,u0),aaii(u0,u0)
      logical lsprint,lpprint,lqprint,ld5,levprint,lvprint,llprint,lf7,
     1ld2,SCALED,TTT,RAMAN,XYZ,ABINI,CC5,LAN,LDO,lvv,lsp,lex,
     1lscf,lres,lcndo,fspec,lrec,lc5,lg94,
     9lopt,lnno,ldisk
      common/opts/lopt(300),icha,n1
      equivalence (lopt(1),lsprint),(lopt(2),lpprint),(lopt(3),lqprint),
     1(lopt(4 ),ld5    ),(lopt(5),levprint),(lopt(6),lvprint),
     1(lopt(7 ),llprint),(lopt(8),lf7     ),(lopt(9),ld2    ),
     1(lopt(10),SCALED ),(lopt(11),TTT    ),(lopt(12),RAMAN ),
     1(lopt(13),XYZ    ),(lopt(14),ABINI  ),(lopt(15),cc5   ),
     1(lopt(16),lan    ),(lopt(17),ldo    ),(lopt(18),lvv    ),
     1(lopt(19),lsp    ),(lopt(20),lex    ),(lopt(21),lscf   ),
     1(lopt(22),lres   ),(lopt(23),lcndo  ),(lopt(24),fspec  ),
     1(lopt(25),lrec   ),(lopt(26),lc5    ),(lopt(27),lg94   ),
     1(lopt(57),lnno   )
c
      call inipoly
      i0=0
      ione=1
      call initfd(aa1,aad,aaf,aag,aah,aaii)
c
      inquire(file='RGR.SCR',exist=ldisk)
      if(ldisk)return
c
      tol=100.0
      spi=sqrt(pi*pi*pi)
      do 10 i=1,nao
      do 10 j=1,u0
      do 10 k=1,n1e
10    sv(k,j,i)=z0
      write(3,4000)nao,noa
4000  format(I4,' orbitals read in',I4,' atoms')
C
      open(36,file='RGR.SCR',form='unformatted')
c
C     atom i, orbital io
      io=0
      do 2 ia=1,noa
      xi=xv(1,ia)
      yi=xv(2,ia)
      zi=xv(3,ia)
c
c     primitive functions on atom ia:
      do 3 ip=1,nop(ia)
      ai=alpha(ia,ip)
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
c
C     atom j, orbital jo
      jo=0
      do 4 ja=1,noa
      xj=xv(1,ja)
      yj=xv(2,ja)
      zj=xv(3,ja)
      xij=xj-xi
      yij=yj-yi
      zij=zj-zi
      if(ic.eq.0)then
       rijx=half*(xj+xi)
       rijy=half*(yj+yi)
       rijz=half*(zj+zi)
      else
       rijx=xj
       rijy=yj
       rijz=zj
      endif
      x2ij=xij*xij
      y2ij=yij*yij
      z2ij=zij*zij
      r2ij=x2ij+y2ij+z2ij
c
c     primitive functions on atom ja:
      do 5 jp=1,nop(ja)
      aj=alpha(ja,jp)
      call nppp(ty(ja,jp),npj,npjj,ccj,nxj,nyj,nzj,
     1aaj,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ja,jp)
      aij=ai+aj
      tt=one/aij
      t=sqrt(tt)
      ec=ai*aj*r2ij*tt
      ef=z0
      if(ec.lt.tol)then
       ef=spi*exp(-ec)
      else
       goto 777
      endif
c
C     Loop over orbitals to which the primitives ip, jp contribute
      do 71 joo=1,npj
      con=ef*ccj(joo)
      anjx=dble(nxj(joo))
      anjy=dble(nyj(joo))
      anjz=dble(nzj(joo))
      do 71 ioo=1,npi
      coe=con*cci(ioo)
      sx=oi(i0,nxi(ioo),nxj(joo),ai,aj,xij,t,xi,xj)
      sy=oi(i0,nyi(ioo),nyj(joo),ai,aj,yij,t,yi,yj)
      sz=oi(i0,nzi(ioo),nzj(joo),ai,aj,zij,t,zi,zj)
      sxm=z0
      sym=z0
      szm=z0
      if(nxj(joo).gt.0)
     1sxm=oi(i0,nxi(ioo),nxj(joo)-1,ai,aj,xij,t,xi,xj)
      sxp=oi(i0,nxi(ioo),nxj(joo)+1,ai,aj,xij,t,xi,xj)
      if(nyj(joo).gt.0)
     1sym=oi(i0,nyi(ioo),nyj(joo)-1,ai,aj,yij,t,yi,yj)
      syp=oi(i0,nyi(ioo),nyj(joo)+1,ai,aj,yij,t,yi,yj)
      if(nzj(joo).gt.0)
     1szm=oi(i0,nzi(ioo),nzj(joo)-1,ai,aj,zij,t,zi,zj)
      szp=oi(i0,nzi(ioo),nzj(joo)+1,ai,aj,zij,t,zi,zj)
      ox =oi(ione,nxi(ioo),nxj(joo),ai,aj,xij,t,xi,xj)
      oy =oi(ione,nyi(ioo),nyj(joo),ai,aj,yij,t,yi,yj)
      oz =oi(ione,nzi(ioo),nzj(joo),ai,aj,zij,t,zi,zj)
c
      dx=anjx*sxm-two*aj*sxp
      dy=anjy*sym-two*aj*syp
      dz=anjz*szm-two*aj*szp
c
c     (1/2)*(r-rnm/2) x gradient
      b6(1,ioo,joo)=((oy-rijy*sy)*dz-(oz-rijz*sz)*dy)*sx*half*coe
      b6(2,ioo,joo)=((oz-rijz*sz)*dx-(ox-rijx*sx)*dz)*sy*half*coe
71    b6(3,ioo,joo)=((ox-rijx*sx)*dy-(oy-rijy*sy)*dx)*sz*half*coe
c
      if(npi.ne.npii.or.npjj.ne.npj)then
       do 74 ioo=1,npii
       do 74 joo=1,npjj
       ioj=joo+jo
       do 74 ipp=1,npi
       aiii=aai(ioo,ipp)
       do 74 jpp=1,npj
       ajjj=aaj(joo,jpp)*aiii
       do 74 k=1,n1e
74     sv(k,ioo,ioj)=sv(k,ioo,ioj)+ajjj*b6(k,ipp,jpp)
      else
       do 7 ioo=1,npi
       do 7 joo=1,npj
       ioj=joo+jo
       do 7 k=1,n1e
7      sv(k,ioo,ioj)=sv(k,ioo,ioj)+b6(k,ioo,joo)
      endif
c
777   if(ish(ja,jp+1).gt.ish(ja,jp)) jo=jo+npjj
c
5     continue
4     continue
C
      if(ish(ia,ip+1).gt.ish(ia,ip))then
c     if last primitive of the orbitals io+1 ... io+npii, then write them
       do 33 ii=1,npii
c      iorb=ii+io
       do 331 kk=1,3
331    write(36)(sv(kk,ii,jj),jj=1,nao)
33     continue
       io=io+npii
c
c      zero-out temporary buffer:
       do 9 ii=1,u0
       do 9 jj=1,nao
       do 9 kk=1,n1e
9      sv(kk,ii,jj)=z0
c
      endif
3     continue
2     continue
      close(36)
c
      if(lsprint)then
       open(33,file='RGR.SCR',form='unformatted')
       do 47 i=1,nao
       read(33)(s(i,j),j=1,nao)
       read(33)
47     read(33)
       call wmtr(s,nort,nao,'"giao" grads, AO, DX',ione)
       rewind 33
       do 48 i=1,nao
       read(33)
       read(33)(s(i,j),j=1,nao)
48     read(33)
       call wmtr(s,nort,nao,'"giao" grads, AO, DY',ione)
       rewind 33
       do 49 i=1,nao
       read(33)
       read(33)
49     read(33)(s(i,j),j=1,nao)
       call wmtr(s,nort,nao,'"giao" grads, AO, DZ',ione)
       close(33)
      endif
c
      write(6,*)' overgr finished'
      write(3,*)' overgr finished'
c
      return
      end
c
