      subroutine overla55(ik,il,buff)
c
c     calculates AO overlap integrals of gradients
c     <a||r-rL|^(-3)|r-rK|^(-3)((x-xL)(x-xK)+(y-yL)(y-yK)+(z-zL)(z-zK))|b>
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      character*2 at
      character*1 ok,ty
      parameter (nat0=190,nor=80,nort=700,npg=11)
      integer*4 u0
      parameter (u0=28)
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/const/pi,clau,spt,bohr,debye
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension nxi(u0),nyi(u0),nzi(u0),
     1nxj(u0),nyj(u0),nzj(u0),cci(u0),ccj(u0),
     3sv(u0,nort),b6(u0,u0),aai(u0,u0),aaj(u0,u0),
     4aad(u0,u0),aaf(u0,u0),aa1(u0,u0),buff(nort,nort),
     4aag(u0,u0),aah(u0,u0),aaii(u0,u0)
      logical ld5,lf7,lopt
      common/opts/lopt(300),icha,n1
      common/atoms/z(nat0),zsum,xv(3,nat0)
      dimension agg(npg),cgg(npg)
      equivalence (lopt(4 ),ld5),(lopt(8),lf7)
      data i0,ione,tol/0,1,23.0D0/
c
c     fit 1/x by gaussians:
      cgg(1)=        0.1000000000
      cgg(2)=        0.0468750000
      cgg(3)=        0.1031250000
      cgg(4)=        0.0265624999
      cgg(5)=       16.8749999983
      cgg(6)=       61.4999999944
      cgg(7)=        0.3062500000
      cgg(8)=        0.8843750000
      cgg(9)=        1.2000000000
      cgg(10)=        1.4187500000
      cgg(11)=        5.4218750001
      agg(1)=        0.0021054491
      agg(2)=        0.0076261537
      agg(3)=        0.2388209437
      agg(4)=        0.2444931487
      agg(5)=      208.8396718628
      agg(6)=     1977.3079519719
      agg(7)=        0.0600936152
      agg(8)=        0.6929718949
      agg(9)=        3.7908296590
      agg(10)=        7.2310242873
      agg(11)=       31.7058741293
      cgg(1)=        0.1405635951
      cgg(2)=        0.2561214092
      cgg(3)=        0.2383884657
      cgg(4)=        0.5093477936
      cgg(5)=        0.1317908972
      cgg(6)=        0.9530330346
      cgg(7)=        0.1316480575
      cgg(8)=        3.4286847158
      cgg(9)=       10.1526193837
      cgg(10)=       60.0502056920
      cgg(11)=       13.6562000640

      agg(1)=        0.0034489621
      agg(2)=        0.2070142619
      agg(3)=        0.0482164820
      agg(4)=        0.5654491997
      agg(5)=        1.9939731383
      agg(6)=        2.1428825464
      agg(7)=        2.6164790511
      agg(8)=       11.1181105011
      agg(9)=       79.5891609101
      agg(10)=     2146.1652579717
      agg(11)=      393.7900280757
      call initfd(aa1,aad,aaf,aag,aah,aaii)
      spi=sqrt(pi*pi*pi)
      write(3,4000)nao,noa
      write(6,4000)nao,noa
4000  format(I4,' orbitals read in',I4,' atoms',' overla55')
C
c     define atomic coordinates
      xk=xv(1,ik)
      yk=xv(2,ik)
      zk=xv(3,ik)
      xl=xv(1,il)
      yl=xv(2,il)
      zl=xv(3,il)
c
      call vz(sv,z0,u0*nort)
      call vz(buff,z0,nort*nort)
c
C     atom i, orbital io
      io=0
      do 2 ia=1,noa
      xi=xv(1,ia)
      yi=xv(2,ia)
      zi=xv(3,ia)
      rik=(xi-xk)**2+(yi-yk)**2+(zi-zk)**2
      ril=(xi-xl)**2+(yi-yl)**2+(zi-zl)**2
      rkl=(xk-xl)**2+(yk-yl)**2+(zk-zl)**2
c
c     primitive functions on atom ia:
      do 2 ip=1,nop(ia)
      ai=alpha(ia,ip)
      aa=ai+ai
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
c
C     atom j, orbital jo
      jo=0
      do 4 ja=1,noa
      xj=xv(1,ja)
      yj=xv(2,ja)
      zj=xv(3,ja)
      rij=(xi-xj)**2 +(yi-yj)**2+(zi-zj)**2
      rjk=(xj-xk)**2 +(yj-yk)**2+(zj-zk)**2
      rjl=(xj-xl)**2 +(yj-yl)**2+(zj-zl)**2
c
c     primitive functions on atom ja:
      do 5 jp=1,nop(ja)
      aj=alpha(ja,jp)
      call nppp(ty(ja,jp),npj,npjj,ccj,nxj,nyj,nzj,
     1aaj,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ja,jp)
      aij=ai+aj
      sigmap=one/aij
      ecp=ai*aj*sigmap*rij
      if(ecp.lt.tol)then
c
C      Loop over orbitals to which the primitives ip, jp contribute
       do 71 joo=1,npj
       njx=nxj(joo)
       njy=nyj(joo)
       njz=nzj(joo)
       up1=ccj(joo)
       do 71 ioo=1,npi
       nix=nxi(ioo)
       niy=nyi(ioo)
       niz=nzi(ioo)
       up=up1*cci(ioo)
c
       sum=z0
c
       do 73 jc=1,npg
       ak=agg(jc)
       c1=cgg(jc)*ak
       do 73 jd=1,npg
       al=agg(jd)
       c2=c1*cgg(jd)*al
       aa=aij+ak+al
       tt=one/aa
       ce=(ai*aj*rij+ai*ak*rik+ai*al*ril+
     1     aj*ak*rjk+aj*al*rjl+ak*al*rkl)*tt
       if(ce.lt.tol)then
        t=sqrt(tt)
        ax1=oooi(nix,njx,ione,ione,ai,aj,ak,al,xi,xj,xk,xl,aa,t)
        ay1=oooi(niy,njy,ione,ione,ai,aj,ak,al,yi,yj,yk,yl,aa,t)
        az1=oooi(niz,njz,ione,ione,ai,aj,ak,al,zi,zj,zk,zl,aa,t)
        ax0=oooi(nix,njx,  i0,  i0,ai,aj,ak,al,xi,xj,xk,xl,aa,t)
        ay0=oooi(niy,njy,  i0,  i0,ai,aj,ak,al,yi,yj,yk,yl,aa,t)
        az0=oooi(niz,njz,  i0,  i0,ai,aj,ak,al,zi,zj,zk,zl,aa,t)
        sum=sum+c2*(ax1*ay0*az0+ax0*ay1*az0+ax0*ay0*az1)*exp(-ce)
       endif
73     continue
       sum=up*sum*spi*four
71     b6(ioo,joo)=sum
      else
       do 72 joo=1,npj
       do 72 ioo=1,npi
72     b6(ioo,joo)=z0
      endif
c
      if(npi.ne.npii.or.npjj.ne.npj)then
       do 74 ioo=1,npii
       do 74 joo=1,npjj
       ioj=joo+jo
       do 74 ipp=1,npi
       aiii=aai(ioo,ipp)
       do 74 jpp=1,npj
       ajjj=aaj(joo,jpp)*aiii
74     sv(ioo,ioj)=sv(ioo,ioj)+ajjj*b6(ipp,jpp)
      else
       do 7 joo=1,npj
       ioj=joo+jo
       do 7 ioo=1,npi
7      sv(ioo,ioj)=sv(ioo,ioj)+b6(ioo,joo)
      endif
c
      if(ish(ja,jp+1).gt.ish(ja,jp)) jo=jo+npjj
c
5     continue
4     continue
C
      if(ish(ia,ip+1).gt.ish(ia,ip))then
c      if last primitive of the orbitals io+1 ... io+npii, then write them
       do 33 ii=1,npii
       do 33 jj=1,nao
33     buff(io+ii,jj)=sv(ii,jj)
       io=io+npii
c
c      zero-out temporary buffer:
       call vz(sv,z0,u0*nort)
      endif
2     continue
c
      return
      end
