      subroutine overla68
c
c     cazimir/ vacuum interaction eenrgy with the
c     dipolar approximation
c
      implicit none
      integer*4 nat0,nor,nort,nopr0,u0,nat,nao,nmo,noe,ichm,mtp,ndo,nsa,
     1nsb,noa,nori,nop,ish,npi,npii,ia,ip,io,ios,ii,ialo,
     3ko,lo,la,nlx,nly,nlz,ka,nkx,nky,nkz,ja,njx,njy,njz,
     3nix,niy,niz,i,j,nopr,nxi,nyi,nzi,nil,nik,nij,
     3jp,kp,lp,ic,jo,icha,n1,noi,noj,nok,nol,noacc
      parameter (nat0=190,nor=80,nort=700,nopr0=10,u0=28)
      integer*4 nxo(nort),nyo(nort),nzo(nort)
      character*2 at
      character*1 ok,ty
      real*8 escf,cc,alpha,rcp,cij,bij,e,be,pi,clau,spt,bohr,debye,
     1z0,one,two,three,four,five,six,half,qua,a8,a10,
     3aai(u0,u0),aad(u0,u0),aaf(u0,u0),aa1(u0,u0),
     3aag(u0,u0),aah(u0,u0),aaii(u0,u0),
     4cci(u0),b2(nopr0,nopr0),ecp,oooi,a0,na,e2si,e2kcal,e2au,
     1u2si,u2kcal,u2au,psii,tol,x,y,z,akalCD,ajalBD,ajakBC,
     1cor(nort,nopr0),alpr(nort,nopr0),bt(nopr0,nopr0,nopr0),
     1b1(nopr0),xi,yi,zi,xj,yj,zj,xv,
     1xk,yk,zk,xl,yl,zl,b6(nopr0*nopr0*nopr0*nopr0),sum,
     1q,zsum,esum,usum,spi,AB,AC,AD,BC,BD,CD,ai,aj,ak,al,t,aa,
     1c1ij,c2kl(nort),c1ik,c2jl(nort),c1il,c2jk(nort),
     2c1jk,c2il(nort),c1kl,c2ij(nort),c1jl,c2ik(nort)
      real*8 h,e0,c,me,eq,bcaz,hkin,hpot,bkin,bpot,ajs,aks
      dimension nopr(nort),nxi(u0),nyi(u0),nzi(u0),ialo(nort)
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/const/pi,clau,spt,bohr,debye
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      logical ld5,lf7,lopt,lconfigcc
      common/opts/lopt(300),icha,n1
      equivalence (lopt(4),ld5),(lopt(8),lf7)
      common/atoms/q(nat0),zsum,xv(3,nat0)
      data tol/23.0D0/
      common/hsdcom/noacc,lconfigcc,hkin(nort,nort),hpot(nort,nort),
     1bkin(nort,nort),bpot(nort,nort),ajs(nort,nort),aks(nort,nort)
c
      write(6,4000)nao,noa,ndo,nsa,nsb
4000  format(' nao:',i4,' noa:',i4,' ndo:',i4,' nsa:',i4,' nsb:',i4)
c
      call initfd(aa1,aad,aaf,aag,aah,aaii)
c
c     set number of primitive functions on each orbital:
      do 1 io=1,nao
1     nopr(io)=0
c
      ios=1
      do 11 ia=1,noa
      do 11 ip=1,nop(ia)
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
      if(npi.ne.npii)then
       call report('No Sphericals in ovela68 allowed')
       write(6,*)ia,ip,ty(ia,ip),npi,npii
      endif
c     primitive angular function - contributions to orbitals ios...ios+npi-1
      do 13 ii=1,npi
      io=ios+ii-1
      nopr(io)=nopr(io)+1
      if(nopr(io).gt.nopr0)call report('too many prim functions')
      alpr(io,nopr(io))=alpha(ia,ip)
      cor(io,nopr(io))=cci(ii)
      if(nopr(io).eq.1)then
       nxo(io)=nxi(ii)
       nyo(io)=nyi(ii)
       nzo(io)=nzi(ii)
       ialo(io)=ia
      endif
13    continue
11    if(ish(ia,ip+1).gt.ish(ia,ip))ios=ios+npi
c     write(3,*)' orbital atom  type primitives '
c      do 14 io=1,nmo
c     write(3,3444)io,ialo(io),nxo(io),nyo(io),nzo(io),nopr(io)
c3444  format(i4,i4,1x,3i1,i5)
c      do 14 ip=1,nopr(io)
c14    write(3,3445)ip,alpr(io,ip),cor(io,ip)
c3445  format(i22,f10.5,f10.5)
c
      esum=0.0d0
      spi=dsqrt(pi*pi*pi)
      do 2 io=1,nao
      call sta(io,ia,xi,yi,zi,nix,niy,niz,xv,ialo,nxo,nyo,nzo)
      noi=nopr(io)
      do 2 jo=io,nao
      call sta(jo,ja,xj,yj,zj,njx,njy,njz,xv,ialo,nxo,nyo,nzo)
      AB=(xj-xi)**2+(yj-yi)**2+(zj-zi)**2
      noj=nopr(jo)
      do 2 ko=jo,nao
      call sta(ko,ka,xk,yk,zk,nkx,nky,nkz,xv,ialo,nxo,nyo,nzo)
      AC=(xk-xi)**2+(yk-yi)**2+(zk-zi)**2
      BC=(xj-xk)**2+(yj-yk)**2+(zj-zk)**2
      nok=nopr(ko)
      do 2 lo=ko,nao
      call sta(lo,la,xl,yl,zl,nlx,nly,nlz,xv,ialo,nxo,nyo,nzo)
      AD=(xl-xi)**2+(yl-yi)**2+(zl-zi)**2
      BD=(xl-xj)**2+(yl-yj)**2+(zl-zj)**2
      CD=(xl-xk)**2+(yl-yk)**2+(zl-zk)**2
      nol=nopr(lo)
c
c     make (ijkl) in primitives
      ic=0
      do 6 lp=1,nol
      al=alpr(lo,lp)
      nil=(lp-1)*noi*noj*nok
      do 6 kp=1,nok
      ak=alpr(ko,kp)
      nik=(kp-1)*noi*noj+nil
      akalCD=ak*al*CD
      do 6 jp=1,noj
      aj=alpr(jo,jp)
      nij=(jp-1)*noi+nik
      ajalBD=aj*al*BD
      ajakBC=aj*ak*BC
      do 6 ip=1,noi
      ai=alpr(io,ip)
      aa=ai+aj+ak+al
      t=one/dsqrt(aa)
      ecp=(ai*aj*AB+ai*ak*AC+ajakBC+ai*al*AD+ajalBD+akalCD)/aa
      if(ecp.lt.tol)then
       b6(ip+nij)=spi*exp(-ecp)*
     1 oooi(nix,njx,nkx,nlx,ai,aj,ak,al,xi,xj,xk,xl,aa,t)*
     2 oooi(niy,njy,nky,nly,ai,aj,ak,al,yi,yj,yk,yl,aa,t)*
     3 oooi(niz,njz,nkz,nlz,ai,aj,ak,al,zi,zj,zk,zl,aa,t)
       ic=ic+1
      else
       b6(ip+nij)=0.0d0
      endif
6     continue
c
c     if all primitiv integrals zero don't bother:
      if(ic.eq.0)goto 2
c
c     Transform into AO basis
c     1)first index (io jp kp lp) = c(io,ip) (ip,jp,kp,lp)
      do 61 lp=1,nol
      nil=(lp-1)*noi*noj*nok
      do 61 kp=1,nok
      nik=(kp-1)*noi*noj+nil
      do 61 jp=1,noj
      nij=(jp-1)*noi+nik
      sum=0.0d0
      do 62 ip=1,noi
62    sum=sum+b6(ip+nij)*cor(io,ip)
61    bt(jp,kp,lp)=sum
c
c     2)second index (io jo kp lp) = c(jo,jp) (io,jp,kp,lp)
      do 63 kp=1,nopr(ko)
      do 63 lp=1,nopr(lo)
      sum=0.0d0
      do 64 jp=1,nopr(jo)
64    sum=sum+bt(jp,kp,lp)*cor(jo,jp)
63    b2(kp,lp)=sum
c
c     3)third index (io jo ko lp) = c(ko,kp) (io,jo,kp,lp)
      do 66 lp=1,nopr(lo)
      sum=0.0d0
      do 67 kp=1,nopr(ko)
67    sum=sum+b2(kp,lp)*cor(ko,kp)
66    b1(lp)=sum
c
c     4)fourth index (io jo ko lo) = c(lo,lp) (io,jo,ko,lp)
      sum=0.0d0
      do 65 lp=1,nopr(lo)
65    sum=sum+b1(lp)*cor(lo,lp)
c
      sum=sum+sum
c
c     contract with MO coefficients
      if(io.eq.jo)then
c     ii
       if(ko.eq.io)then
c      iii
        if(lo.eq.io)then
         call Uiiii(ndo,nsa,nsb,cij,bij,esum,sum,io)
        else
         call Uiiil(ndo,nsa,nsb,cij,bij,esum,sum,io,lo)
        endif
       else
c      iik
        if(lo.eq.io)then
         call Uiiil(ndo,nsa,nsb,cij,bij,esum,sum,io,ko)
        else
         if(lo.eq.ko)then
          call Uiikk(ndo,nsa,nsb,cij,bij,esum,sum,io,ko)
         else
          call Uiikl(ndo,nsa,nsb,cij,bij,esum,sum,io,ko,lo)
         endif
        endif
       endif
      else
c      ij
       if(ko.eq.io)then
c       iji
        if(lo.eq.io)then
c        ijii
         call Uiiil(ndo,nsa,nsb,cij,bij,esum,sum,io,jo)
        else
         if(lo.eq.jo)then
c         ijij
          call Uiikk(ndo,nsa,nsb,cij,bij,esum,sum,io,jo)
         else
c         ijil
          call Uiikl(ndo,nsa,nsb,cij,bij,esum,sum,io,jo,lo)
         endif
        endif
       else
        if(ko.eq.jo)then
c       ijj
         if(lo.eq.io)then
c         ijjl
          call Uiikl(ndo,nsa,nsb,cij,bij,esum,sum,jo,io,lo)
         else
          if(lo.eq.jo)then
c          ijjj
           call Uiiil(ndo,nsa,nsb,cij,bij,esum,sum,jo,io)
          else
c          ijjl
           call Uiikl(ndo,nsa,nsb,cij,bij,esum,sum,jo,io,lo)
          endif
         endif
        else
c       ijk
         if(lo.eq.io)then
c         ijki
          call Uiikl(ndo,nsa,nsb,cij,bij,esum,sum,io,jo,ko)
         else
          if(lo.eq.jo)then
c          ijkj
           call Uiikl(ndo,nsa,nsb,cij,bij,esum,sum,jo,io,ko)
          else
           if(lo.eq.ko)then
c           ijkk
            call Uiikl(ndo,nsa,nsb,cij,bij,esum,sum,ko,io,jo)
           else
c          ijkl=ijlk=jilk=jikl=klij=klji=lkij=lkji=ljki=..etc
      do 72 j=1,max(ndo,nsa)
      c2ij(j)=cij(j,io)*cij(j,jo)*4.0d0
      c2ik(j)=cij(j,io)*cij(j,ko)*4.0d0
      c2il(j)=cij(j,io)*cij(j,lo)*4.0d0
      c2jk(j)=cij(j,jo)*cij(j,ko)*4.0d0
      c2jl(j)=cij(j,jo)*cij(j,lo)*4.0d0
72    c2kl(j)=cij(j,ko)*cij(j,lo)*4.0d0
      do 70 i=1,ndo
      c1ij=cij(i,io)*cij(i,jo)*sum
      c1ik=cij(i,io)*cij(i,ko)*sum
      c1il=cij(i,io)*cij(i,lo)*sum
      c1jk=cij(i,jo)*cij(i,ko)*sum
      c1jl=cij(i,jo)*cij(i,lo)*sum
      c1kl=cij(i,ko)*cij(i,lo)*sum
      do 70 j=1,ndo
70    esum=esum+c1ij*c2kl(j)+c1ik*c2jl(j)+c1il*c2jk(j)
     2         +c1jk*c2il(j)+c1kl*c2ij(j)+c1jl*c2ik(j)
      do 71 i=1,nsb
      c1ij=bij(i,io)*bij(i,jo)*sum
      c1ik=bij(i,io)*bij(i,ko)*sum
      c1il=bij(i,io)*bij(i,lo)*sum
      c1jk=bij(i,jo)*bij(i,ko)*sum
      c1jl=bij(i,jo)*bij(i,lo)*sum
      c1kl=bij(i,ko)*bij(i,lo)*sum
      do 71 j=1,nsa
71    esum=esum+c1ij*c2kl(j)+c1ik*c2jl(j)+c1il*c2jk(j)
     2         +c1jk*c2il(j)+c1kl*c2ij(j)+c1jl*c2ik(j)
           endif
          endif
         endif
        endif
       endif
      endif

2     continue

      h=1.054589d-34
      e0=8.854187d-12
      c=2.99792458d8
      me=9.109534d-31
      eq=1.602189d-19
      bcaz=7.8d0
      a0=0.529177d-10
      na=6.022045d23
      e2si=h*eq**4*bcaz/12.0d0/e0**2/c**3/pi**2/me**2*esum/a0**3
      e2kcal=e2si*na/1000.0d0/4.184d0
      e2au=e2kcal/627.5d0
      write(6,6001)e2kcal,e2au
      write(3,6001)e2kcal,e2au
 6001 format(/,' E el = ',f15.8,' kcal / mol (',f15.8,' hartree)')
c
c     nuclear part
      usum=0.0d0
      do 80 ia=1,noa
      x=xv(1,ia)
      y=xv(2,ia)
      z=xv(3,ia)
      sum=0.0d0
      do 81 i=1,ndo
81    sum=sum+psii(x,y,z,i,cij)**2
      sum=sum+sum
      do 82 i=1,nsa
82    sum=sum+psii(x,y,z,i,cij)**2
      do 83 i=1,nsb
83    sum=sum+psii(x,y,z,i,bij)**2
80    usum=usum+q(ia)*sum
      u2si=h*eq**4*bcaz/12.0d0/e0**2/c**3/pi**2/me**2*usum/a0**3
      u2kcal=u2si*na/1000.0d0/4.184d0
      u2au=u2kcal/627.5d0
      write(6,6002)u2kcal,u2au
      write(3,6002)u2kcal,u2au
 6002 format(' E nu = ',f15.8,' kcal / mol (',f15.8,' hartree)')
      write(6,6003)u2kcal+e2kcal,u2au+e2au
      write(3,6003)u2kcal+e2kcal,u2au+e2au
 6003 format(' E tot= ',f15.8,' kcal / mol (',f15.8,' hartree)')
c
c     kinetic energy part
c     make <a|Laplace|b> AO (also pot. energy from historical reasons)
c     write -1/2Laplace to LAPLACE.SCR
      call tep
c
c     transform to MO, write to CORE.SCR
      call tepmo
c
c     read kinetic only:
      open(33,file='CORE.SCR',form='unformatted')
      read(33)((hkin(i,j),i=1,nmo),j=1,nmo)
      read(33)((bkin(i,j),i=1,nmo),j=1,nmo)
      read(33)
      read(33)
      read(33)
      read(33)
      close(33)
c
      sum=0.0d0
      do 91 i=1,ndo
91    sum=sum-4.0d0*hkin(i,i)
      do 92 i=1,nsa
92    sum=sum-2.0d0*hkin(i,i)
      do 93 i=1,nsb
93    sum=sum-2.0d0*bkin(i,i)

      e2si=h*eq**2*sum/6.0d0/e0/c/pi**2/me/a0**2
      e2kcal=e2si*na/1000.0d0/4.184d0
      e2au=e2kcal/627.5d0
      write(6,6004)e2kcal,e2au
      write(3,6004)e2kcal,e2au
 6004 format(/,' E1   = ',f15.8,' kcal / mol (',f15.8,' hartree)')

      end

c     ===============================================
      subroutine sta(io,i,x,y,z,nx,ny,nz,xv,ialo,nxo,nyo,nzo)
      implicit none
      integer*4 io,i,nat0,nx,ny,nz,ialo(*),nxo(*),nyo(*),nzo(*)
      parameter (nat0=190)
      real*8 x,y,z,xv(3,nat0)
      i=ialo(io)
      x=xv(1,i)
      y=xv(2,i)
      z=xv(3,i)
      nx=nxo(io)
      ny=nyo(io)
      nz=nzo(io)
      return
      end
c     =================================================================
      function psii(rx,ry,rz,i,coef)
c
c     orbital i at the point rx,ry,rz
c
      implicit none
      integer*4 nat0,nor,nort,u0,i,
     1nat,nao,nmo,noe,ichm,mtp,ndo,nsa,nsb,noa,nori,nop,
     1ish,ia,io,ioo,ip,ipx,npi,npii
      parameter (nat0=190,nor=80,nort=700,u0=28)
      integer*4 nxi(u0),nyi(u0),nzi(u0)
      real*8 psi,rx,ry,rz,coef(nort,nort),aad(u0,u0),aaf(u0,u0),
     1aa1(u0,u0),aai(u0,u0),cci(u0),psii,a,b6,q,xv,zsum,
     1aag(u0,u0),aah(u0,u0),aaii(u0,u0),
     1escf,cc,alpha,rcp,cij,bij,e,x,y,z,be,ecp,ef
      character*2 at
      character*1 ok,ty
      common/atoms/q(nat0),zsum,xv(3,nat0)
      logical ld5,lf7
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
c
      call initfd(aa1,aad,aaf,aag,aah,aaii)
c
      psi=0.0d0
c
c     MO psi(i)=sum over AOs
c
c     sum over atoms
      io=0
      do 2 ia=1,noa
      x=rx-xv(1,ia)
      y=ry-xv(2,ia)
      z=rz-xv(3,ia)
c
c     sum over primitives
      do 3 ip=1,nop(ia)
      a=alpha(ia,ip)
      call nppp(ty(ia,ip),npi,npii,cci,nxi,nyi,nzi,
     1aai,aa1,aad,aaf,aag,aah,aaii,ld5,lf7,ia,ip)
      ecp=a*(x**2+y**2+z**2)
      if(ecp.gt.12.0D0)goto 3
      ef=exp(-ecp)
c
      do 4 ipx=1,npi
      b6=cci(ipx)*ef*x**nxi(ipx)*y**nyi(ipx)*z**nzi(ipx)
      if(npi.ne.npii)then
       do 74 ioo=1,npii
74     psi=psi+aai(ioo,ipx)*b6*coef(i,io+ioo)
      else
       psi=psi+b6*coef(i,io+ipx)
      endif
4     continue
c
3     if(ish(ia,ip+1).gt.ish(ia,ip))io=io+npii
2     continue
      psii=psi
      return
      end

      subroutine Uiiii(ndo,nsa,nsb,cij,bij,esum,sum,io)
      implicit none
      integer ndo,nsa,nort,j,i,io,nsb
      parameter (nort=700)
      real*8 cij(nort,nort),bij(nort,nort),c2ii(nort),c1ii,
     1esum,sum
      do 721 j=1,max(ndo,nsa)
721   c2ii(j)=cij(j,io)*cij(j,io)*sum
      do 701 i=1,ndo
      c1ii=cij(i,io)*cij(i,io)
      do 701 j=1,ndo
701   esum=esum+c1ii*c2ii(j)
      do 711 i=1,nsb
      c1ii=bij(i,io)*bij(i,io)
      do 711 j=1,nsa
711   esum=esum+c1ii*c2ii(j)
      return
      end

      subroutine Uiiil(ndo,nsa,nsb,cij,bij,esum,sum,io,lo)
      implicit none
      integer ndo,nsa,nort,j,i,io,nsb,lo
      parameter (nort=700)
      real*8 cij(nort,nort),bij(nort,nort),c2ii(nort),c1ii,
     1esum,sum,c1il,c2il(nort)
      do 722 j=1,max(ndo,nsa)
      c2ii(j)=cij(j,io)*cij(j,io)
722   c2il(j)=cij(j,io)*cij(j,lo)
      do 702 i=1,ndo
      c1ii=cij(i,io)*cij(i,io)*sum*2.0d0
      c1il=cij(i,io)*cij(i,lo)*sum*2.0d0
      do 702 j=1,ndo
702   esum=esum+c1ii*c2il(j)+c1il*c2ii(j)
      do 712 i=1,nsb
      c1ii=bij(i,io)*bij(i,io)*sum*2.0d0
      c1il=bij(i,io)*bij(i,lo)*sum*2.0d0
      do 712 j=1,nsa
712   esum=esum+c1ii*c2il(j)+c1il*c2ii(j)
      return
      end

      subroutine Uiikk(ndo,nsa,nsb,cij,bij,esum,sum,io,ko)
      implicit none
      integer ndo,nsa,nort,j,i,io,nsb,ko
      parameter (nort=700)
      real*8 cij(nort,nort),bij(nort,nort),c2ii(nort),c1ii,
     1esum,sum,c1ik,c2kk(nort),c2ik(nort),c1kk
      do 724 j=1,max(ndo,nsa)
      c2ii(j)=cij(j,io)*cij(j,io)
      c2ik(j)=cij(j,io)*cij(j,ko)*4.0d0
724   c2kk(j)=cij(j,ko)*cij(j,ko)
      do 704 i=1,ndo
      c1ii=cij(i,io)*cij(i,io)*sum
      c1ik=cij(i,io)*cij(i,ko)*sum
      c1kk=cij(i,ko)*cij(i,ko)*sum
      do 704 j=1,ndo
704   esum=esum+c1ii*c2kk(j)+c1ik*c2ik(j)+c1kk*c2ii(j)
      do 714 i=1,nsb
      c1ii=bij(i,io)*bij(i,io)*sum
      c1ik=bij(i,io)*bij(i,ko)*sum
      c1kk=bij(i,ko)*bij(i,ko)*sum
      do 714 j=1,nsa
714   esum=esum+c1ii*c2kk(j)+c1ik*c2ik(j)+c1kk*c2ii(j)
      return
      end

      subroutine Uiikl(ndo,nsa,nsb,cij,bij,esum,sum,io,ko,lo)
      implicit none
      integer ndo,nsa,nort,j,i,io,nsb,ko,lo
      parameter (nort=700)
      real*8 cij(nort,nort),bij(nort,nort),c2ii(nort),c1ii,
     1esum,sum,c1ik,c2il(nort),c2ik(nort),c1il,c2kl(nort),c1kl
      do 725 j=1,max(ndo,nsa)
      c2ii(j)=cij(j,io)*cij(j,io)*2.0d0
      c2ik(j)=cij(j,io)*cij(j,ko)*4.0d0
      c2il(j)=cij(j,io)*cij(j,lo)*4.0d0
725   c2kl(j)=cij(j,ko)*cij(j,lo)*2.0d0
      do 705 i=1,ndo
      c1ii=cij(i,io)*cij(i,io)*sum
      c1ik=cij(i,io)*cij(i,ko)*sum
      c1il=cij(i,io)*cij(i,lo)*sum
      c1kl=cij(i,ko)*cij(i,lo)*sum
      do 705 j=1,ndo
705   esum=esum+c1ii*c2kl(j)+c1ik*c2il(j)+c1il*c2ik(j)+c1kl*c2ii(j)
      do 715 i=1,nsb
      c1ii=bij(i,io)*bij(i,io)*sum
      c1ik=bij(i,io)*bij(i,ko)*sum
      c1il=bij(i,io)*bij(i,lo)*sum
      c1kl=bij(i,ko)*bij(i,lo)*sum
      do 715 j=1,nsa
715   esum=esum+c1ii*c2kl(j)+c1ik*c2il(j)+c1il*c2ik(j)+c1kl*c2ii(j)
      return
      end

