      subroutine ppot(ic,dm,fi,rx,ry,rz)
c
c     electrostatic potential for the plotting (og)
c
c     ic=0 ... calculate the density matrix, dm, and return
c     ic=1 ... calculate the potential matrix vm for given point
c              and contract with dm to get fi
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700)
      character*2 at
      character*1 ok,ty
      common/atoms/q(nat0),zsum,xv(3,nat0)
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension dm(nort,nort),vm(nort,nort)
c
      if(ic.eq.0)then
       do 1 n=1,nao
       do 1 m=n,nao
       sum=z0
       do 2 i=1,ndo
2      sum=sum+cij(i,n)*cij(i,m)
       dm(m,n)=sum
1      dm(n,m)=sum
       write(3,*)'Density matrix computed'
       fi=0.0d0
       return
      endif
c
      if(ic.eq.1)then
       call overpot(rx,ry,rz,vm)
       sum=z0
       do 3 i=1,nao
       do 3 j=i+1,nao
3      sum=sum-dm(i,j)*vm(i,j)
       sum=sum+sum
       do 5 i=1,nao
5      sum=sum-dm(i,i)*vm(i,i)
       sum=sum+sum
       do 4 i=1,noa
       r=(xv(1,i)-rx)**2+(xv(2,i)-ry)**2+(xv(3,i)-rz)**2
4      if(r.gt.1.0d-10)sum=sum+q(i)/sqrt(r)
       fi=sum
       return
      endif
c
      call report('Uknown option in ppot')
      end
