      subroutine theta
c     calculates quadrupole moment
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700)
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/atoms/z(nat0),zsum,xv(3,nat0)
      common/const/pi,clau,spt,bohr,debye
      dimension qxx(nort),qyy(nort),qzz(nort),
     1qxy(nort),qxz(nort),qyz(nort)
      txx=z0
      txy=z0
      txz=z0
      tyy=z0
      tyz=z0
      tzz=z0
      open(33,file='Q.SCR',form='unformatted')
      do 1 i=1,nao
      read(33)(qxx(j),j=1,nao)
      read(33)(qxy(j),j=1,nao)
      read(33)(qxz(j),j=1,nao)
      read(33)(qyy(j),j=1,nao)
      read(33)(qyz(j),j=1,nao)
      read(33)(qzz(j),j=1,nao)
      do 1 j=1,nao

      do 14 imo=1,ndo
      ff=cij(imo,i)*cij(imo,j)*2.0d0
      txx=txx-ff*qxx(j)
      txy=txy-ff*qxy(j)
      txz=txz-ff*qxz(j)
      tyy=tyy-ff*qyy(j)
      tyz=tyz-ff*qyz(j)
14    tzz=tzz-ff*qzz(j)
      do 13 imo=1,nsa
      ff=cij(imo,i)*cij(imo,j)
      txx=txx-ff*qxx(j)
      txy=txy-ff*qxy(j)
      txz=txz-ff*qxz(j)
      tyy=tyy-ff*qyy(j)
      tyz=tyz-ff*qyz(j)
13    tzz=tzz-ff*qzz(j)
      do 11 imo=1,nsb
      ff=bij(imo,i)*bij(imo,j)
      txx=txx-ff*qxx(j)
      txy=txy-ff*qxy(j)
      txz=txz-ff*qxz(j)
      tyy=tyy-ff*qyy(j)
      tyz=tyz-ff*qyz(j)
11    tzz=tzz-ff*qzz(j)
c     do 1 ii=1,nsorb
c     imo=isomo(ii)
c     if(isos(ii).eq.1)then
c      ff=cij(imo,i)*cij(imo,j)
c     else
c      ff=bij(imo,i)*bij(imo,j)
c     endif
c     txx=txx-ff*qxx(j)
c     txy=txy-ff*qxy(j)
c     txz=txz-ff*qxz(j)
c     tyy=tyy-ff*qyy(j)
c     tyz=tyz-ff*qyz(j)
c     tzz=tzz-ff*qzz(j)
1     continue
      close(33)
      qnxx=z0
      qnxy=z0
      qnxz=z0
      qnyy=z0
      qnyz=z0
      qnzz=z0
      do 2 i=1,noa
      rx=xv(1,i)
      ry=xv(2,i)
      rz=xv(3,i)
      qnxx=qnxx+rx*rx*z(i)
      qnyy=qnyy+ry*ry*z(i)
      qnzz=qnzz+rz*rz*z(i)
      qnxy=qnxy+rx*ry*z(i)
      qnxz=qnxz+rx*rz*z(i)
2     qnyz=qnyz+ry*rz*z(i)
c     qnxx=qnxx+half*(two*rx*rx-ry*ry-rz*rz)*z(i)
c     qnyy=qnyy+ry*ry-rx*rx-rz*rz)*z(i)
c     qnzz=qnzz+f*(two*rz*rz-ry*ry-rx*rx)*z(i)
c     qnxy=qnxy+three/two*rx*ry*z(i)
c     qnxz=qnxz+three/two*rx*rz*z(i)
c2     qnyz=qnyz+three/two*ry*rz*z(i)
      qtxx=qnxx+txx
      qtxy=qnxy+txy
      qtxz=qnxz+txz
      qtyy=qnyy+tyy
      qtyz=qnyz+tyz
      qtzz=qnzz+tzz
      write(3,*)' atomic units:'
      write(3,4000)txx,txy,txz,tyy,tyz,tzz,qnxx,qnxy,qnxz,qnyy,qnyz,
     1qnzz,qtxx,qtxy,qtxz,qtyy,qtyz,qtzz
      write(3,*)' Debye-Angstroms:'
      d=debye*bohr
      write(3,4000)txx*d,txy*d,txz*d,tyy*d,tyz*d,tzz*d,qnxx*d,
     1qnxy*d,qnxz*d,qnyy*d,qnyz*d,
     1qnzz*d,qtxx*d,qtxy*d,qtxz*d,qtyy*d,qtyz*d,qtzz*d
4000  format(/,8x,10x,'XX',10x,'XY',10x,'XZ',10x,'YY',10x,'YZ',
     110x,'ZZ',/,
     1         '  Quadrupole electronic ',/,
     1         8x,6F12.4,/,
     1         '  nuclear ',/,
     1         8x,6F12.4,/,
     2         8x,72(1H-),/,
     3         '  total ',/,
     1         8x,6F12.4,/,/)
      return
      end
