      SUBROUTINE READAAL(N30,NAT,ALPHA,LAN)
      IMPLICIT REAL*8 (A-H,O-Z)
      implicit integer*4 (i-n)
      DIMENSION ALPHA(N30,3,3)
      CHARACTER*25 STRING
      logical lan,lex
      character*80 ifn
      common/filenames/ifn
c
      write(3,*)'trying to read analytical alpha-der from ifn'
      inquire(file=ifn,exist=lex)
      if(.not.lex)goto 1
      write(3,*)ifn,' exists'
      OPEN(2,FILE=ifn)
201   READ(2,1111,END=1)STRING
1111  FORMAT(A25)
C                    1234567890123456789012345
      IF (STRING.EQ.' Cartesian Polarisability') THEN
       WRITE(3,*)' Cartesian Polarisability Derivatives found ... '
       WRITE(6,*)' Cartesian Polarisability Derivatives found ... '
       READ(2,*)
       WRITE(3,3001)
3001  FORMAT(1X,'  POLARIZABILITY DERIVATIVES',/,
     1       1X,'            ANALYTICAL     NUMERICAL',/,
     2       1X,'-------------------------------------')
       N=3*NAT
       DO 203 I=1,3
       DO 203 J=1,3
       DO 203 K=1,N
       READ(2,3002)AA
3002  FORMAT(30X,F18.8)
       WRITE(3,3000)K,I,J,AA,ALPHA(K,I,J)
203    IF(LAN)ALPHA(K,I,J)=AA
3000  FORMAT(1X,3I3,2F15.8)
       IF(LAN)WRITE(3,3003)
3003  FORMAT(1X,'THE ANALYTICAL FORM OF ALPHA WILL BE USED')
       RETURN
      ENDIF
      GOTO  201
1     WRITE(3,*)' Analytical alpha not found, numerical ',
     1'derivatives will be used ...'
      close(2)
      RETURN
      END
