      subroutine rul(n30,nat0,nat,al,a,g,r,a0,aa0,g0)
c     ROA sum rules
      IMPLICIT REAL*8 (A-H,O-Z)
      implicit integer*4 (i-n)
      DIMENSION r(3,nat0),al(n30,3,3),a(n30,3,3,3),g(n30,3,3),
     1a0(3,3),g0(3,3),buff(9),bufr(9),aa0(3,3,3)
      character*1 xs(3)
      character*2 xss(9)
      character*3 xsss(3,9)
      data xs,xss/'x','y','z',
     2           'xx','xy','xz','yx','yy','yz','zx','zy','zz'/
c
      do 9 i=1,3
      do 9 j=1,9
      xsss(i,j)(1:1)=xs(i)
9     xsss(i,j)(2:3)=xss(j)
c
      write(3,*)
      write(3,*)' *** ROA sum rules ****'
      write(3,*)
c     sum(l)[d al(ia,ib)/d R(l,ic)]=0
      write(3,*)' Alpha, translation'
      do 1 ic=1,3
      write(3,3001)xs(ic)
3001  format('Translation along ',A1,1H:)
      write(3,3003)(xss(i),i=1,9)
3003  format(9(6X,A2))
      i=0
      do 2 ia=1,3
      do 2 ib=1,3
      i=i+1
      buff(i)=0.0D0
      do 2 l=1,nat
2     buff(i)=buff(i)+al(3*(l-1)+ic,ia,ib)
1     write(3,3002)(buff(i),i=1,9)
3002  format(9F8.3)
c
c     sum(l)eps(id,ic,ie)R(l,ie)[d al(ia,ib)/d R(l,id)]=eps(ia,ic,ie)al(ie,ib)
c                                                      +eps(ib,ic,ie)al(ia,ie)
      write(3,*)
      write(3,*)' Alpha, rotation'
      do 11 ic=1,3
      write(3,30011)xs(ic)
      write(3,3003)(xss(j),j=1,9)
      i=0
      do 21 ia=1,3
      do 21 ib=1,3
      i=i+1
      buff(i)=0.0D0
      do 21 l=1,nat
      do 21 ie=1,3
      do 21 id=1,3
21    buff(i)=buff(i)+eps(id,ic,ie)*r(ie,l)*al(3*(l-1)+id,ia,ib)
      i=0
      do 22 ia=1,3
      do 22 ib=1,3
      i=i+1
      bufr(i)=0.0D0
      do 22 id=1,3
22    bufr(i)=bufr(i)+eps(ia,ic,id)*a0(id,ib)+eps(ib,ic,id)*a0(ia,id)
      write(3,3002)(buff(i),i=1,9)
11    write(3,3002)(bufr(i),i=1,9)
c
c     sum(l)[d g(ia,ib)/d R(l,ic)]=-0.5*eps(ib,ic,id)*a0(id,ia)
      write(3,*)
      write(3,*)' G/w, translation'
      do 41 ic=1,3
      write(3,3001)xs(ic)
      write(3,3003)(xss(j),j=1,9)
      i=0
      do 51 ia=1,3
      do 51 ib=1,3
      i=i+1
      buff(i)=0.0D0
      do 51 l=1,nat
51    buff(i)=buff(i)+g(3*(l-1)+ic,ia,ib)
      i=0
      do 23 ia=1,3
      do 23 ib=1,3
      i=i+1
      bufr(i)=0.0D0
      do 23 id=1,3
23    bufr(i)=bufr(i)-0.5D0*eps(ib,ic,id)*a0(id,ia)
      write(3,3002)(buff(i),i=1,9)
41    write(3,3002)(bufr(i),i=1,9)
c
c     sum(l)eps(id,ic,ie)R(l,ie)[d g(ia,ib)/d R(l,id)]=0
      write(3,*)
      write(3,*)' G/w, rotation'
      do 12 ic=1,3
      write(3,30011)xs(ic)
      write(3,3003)(xss(j),j=1,9)
      i=0
      do 25 ia=1,3
      do 25 ib=1,3
      i=i+1
      buff(i)=0.0D0
      do 25 l=1,nat
      do 25 ie=1,3
      do 25 id=1,3
25    buff(i)=buff(i)+eps(id,ic,ie)*r(ie,l)*g(3*(l-1)+id,ia,ib)
      i=0
      do 26 ia=1,3
      do 26 ib=1,3
      i=i+1
      bufr(i)=0.0D0
      do 26 ie=1,3
26    bufr(i)=bufr(i)+eps(ia,ic,ie)*g0(ie,ib)
     1               +eps(ib,ic,ie)*g0(ia,ie)
      write(3,3002)(buff(i),i=1,9)
12    write(3,3002)(bufr(i),i=1,9)
c
c     sum(l)[d A(ia,ib,ig)/d R(l,ic)]=3(d(ib,ic)a0(ig,ia)+d(ig,ic)a0(ib,ia)]/2
c                                     -d(ib,ig)a0(ic,ia)
      write(3,*)
      write(3,*)' A, translation'
      do 4 ic=1,3
      write(3,3001)xs(ic)
      do 4 ig=1,3
      write(3,30033)(xsss(ig,i),i=1,9)
30033 format(9(5X,A3))
      i=0
      do 5 ia=1,3
      do 5 ib=1,3
      i=i+1
      buff(i)=0.0D0
      do 5 l=1,nat
5     buff(i)=buff(i)+a(3*(l-1)+ic,ia,ib,ig)
      i=0
      do 24 ia=1,3
      do 24 ib=1,3
      i=i+1
      bufr(i)=0.0D0
      if(ib.eq.ic)bufr(i)=bufr(i)+1.5D0*a0(ig,ia)
      if(ig.eq.ic)bufr(i)=bufr(i)+1.5D0*a0(ib,ia)
24    if(ib.eq.ig)bufr(i)=bufr(i)-a0(ic,ia)
      write(3,3002)(buff(i),i=1,9)
4     write(3,3002)(bufr(i),i=1,9)
c
c     sum(l)eps(id,ic,ie)R(l,ie)[d a(ia,ib,ik)/d R(l,id)]=
c                                         eps(ia,ic,ie)a(ie,ib,ik)
c                                        +eps(ib,ic,ie)a(ia,ie,ik)
c                                        +eps(ik,ic,ie)a(ia,ib,ie)
      write(3,*)
      write(3,*)' A rotation'
      do 6 ic=1,3
      write(3,30011)xs(ic)
30011 format('Rotation around ',A1,1H:)
      do 6 ig=1,3
      write(3,30033)(xsss(ig,i),i=1,9)
      i=0
      do 7 ia=1,3
      do 7 ib=1,3
      i=i+1
      buff(i)=0.0D0
      do 7 l=1,nat
      do 7 ie=1,3
      do 7 id=1,3
7     buff(i)=buff(i)+eps(id,ic,ie)*r(ie,l)*a(3*(l-1)+id,ia,ib,ig)
      i=0
      do 8 ia=1,3
      do 8 ib=1,3
      i=i+1
      bufr(i)=0.0D0
      do 8 ie=1,3
8     bufr(i)=bufr(i)+eps(ia,ic,ie)*aa0(ie,ib,ig)
     1               +eps(ib,ic,ie)*aa0(ia,ie,ig)
     1               +eps(ig,ic,ie)*aa0(ia,ib,ie)
      write(3,3002)(buff(i),i=1,9)
6     write(3,3002)(bufr(i),i=1,9)
      write(3,*)
      return
      end
