      subroutine sppl
c
c     special plot of
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700,nr0=1000)
      integer*4 u0
      parameter (u0=28)
c
c     nat0   number of atoms
c     nor    number of primitives on one atom
c     nort   maximum number of orbitals
c
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/iopts/iopt(300)
      equivalence (iopt(1),ncnmr),(iopt(2),inormo),(iopt(7),ioe)
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      common/atoms/qz(nat0),zsum,xv(3,nat0)
      dimension ak(nort,nort),aj(nort,nort),
     1rx(nr0),ry(nr0),rz(nr0),db(nr0),iiy(nr0),iiz(nr0),
     1dbj(nr0)
c
      dimension
     2oon(nort,nort,3),jdeg(4),
     3rt(3,nat0),r1x(nr0),r2(nr0),
     4r1y(nr0),r1z(nr0)
c    3ttn(nort,nort,6),
      real*8 rofo(nr0,nr0),rofof(nr0,nr0)
      logical l1e,lex
      common/snell/aa1(u0,u0),aad(u0,u0),aaf(u0,u0),
     1aag(u0,u0),aah(u0,u0),aai(u0,u0)
      logical lodia,lopara,lofc
      common/sicon/sie,simu0,simun,sime,sib0,sih,sieps0,sieau,
     1simub,ge,amin(3),amax(3)
      character*80 name
c
      bdel=one/dble(ncnmr)
      nd=3
      write(3,4401)nmo,nao,bdel
      write(6,4401)nmo,nao,bdel
4401  format(' Special Plot NMO = ',I3,' NAO = ',I3,/,
     1' Numerical grid step ',F6.3,' Bohr')
c
      inquire(file='SPPL.INP',exist=lex)
      if(.not.lex)call report('SPPL.INP not found')
      open(36,file='SPPL.INP')
      read(36,*)
      read(36,*)lodia
      if(lodia)read(36,*)kd1,kd2
      read(36,*)lopara
      if(lopara)read(36,*)kp1
      read(36,*)lofc
      if(lofc)read(36,*)kf1
      close(36)
c
      call initfd(aa1,aad,aaf,aag,aah,aai)
c
      etol=0.0001d0
      ione=1
c     tolerance for zero distance
      call inibe4
      do 6001 i=1,3
      do 6001 j=1,noa
6001  rt(i,j)=(xv(i,j)-amin(i))
      i0=int((amax(1)-amin(1))/bdel)
      j0=int((amax(2)-amin(2))/bdel)
      k0=int((amax(3)-amin(3))/bdel)
      if(i0.gt.nr0)call report('too many points, i0')
      if(j0.gt.nr0)call report('too many points, j0')
      if(k0.gt.nr0)call report('too many points, k0')
c
      if(lodia)THEN
       open(4,file='DBBB.SCR',form='unformatted')
       open(41,file='DBBB.cub')
       name='Diamagnetic coupling density'
       n=kd1
       m=kd2
       xn=xv(1,n)
       yn=xv(2,n)
       zn=xv(3,n)
       xm=xv(1,m)
       ym=xv(2,m)
       zm=xv(3,m)
       write(4)name,nd,i0,j0,k0,z0,z0,z0,bdel,bdel,bdel
       call wrhead(name,nd,i0+1,j0+1,k0+1,bdel,xv,noa,amin,amax,qz,41)
       ib=0
       ip0=0
       anro=z0
       x=amin(1)-bdel
       ix=-1
4001   ip=int(100.0d0*(x-amin(1))/(amax(1)-amin(1)))
       if(ip.gt.ip0)then
        write(6,*)ip,'% '
        open(22,file='dnum.progres')
        write(22,*)ip,'%'
        close(22)
       endif
       ip0=ip
       x=x+bdel
       ix=ix+1
       y=amin(2)-bdel
       iy=-1
4002   y=y+bdel
       iy=iy+1
       z=amin(3)-bdel
       iz=-1
4003   z=z+bdel
       iz=iz+1
       ib=ib+1
       rx(ib)=x
       ry(ib)=y
       rz(ib)=z
       iiz(ib)=iz
       iiy(ib)=iy
       if(ib.eq.nr0.or.iz.eq.k0)then
        nb=ib
        call rosnake(nb,rx,ry,rz,db,ione,ndo)
        do 902 ib=1,nb
        ro=db(ib)
        anro=anro+ro
        ik=iiz(ib)
        ij=iiy(ib)
        xr=rx(ib)
        yr=ry(ib)
        zr=rz(ib)
        xxn=xr-xn
        yyn=yr-yn
        zzn=zr-zn
        rn2=xxn*xxn+yyn*yyn+zzn*zzn
        del=z0
        if(rn2.gt.0.001d0)then
         xxm=xr-xm
         yym=yr-ym
         zzm=zr-zm
         rm2=xxm*xxm+yym*yym+zzm*zzm
         if(rm2.gt.0.001d0)then
          del=ro*(xxn*xxm+yyn*yym+zzn*zzm)/(rn2*sqrt(rn2*rm2)*rm2)
         endif
        endif
902     rofo(ik+1,ij+1)=del
        ib=0
       endif
       if(iz.lt.k0)goto 4003
       write(41,4144)(rofo(i,iy),i=1,k0+1)
4144   format(6E13.5)
       if(iy.lt.j0)goto 4002
       write(4)((rofo(i,j),i=1,k0+1),j=1,j0+1)
       if(ix.lt.i0)goto 4001
       write(4)noa,((rt(i,j),i=1,3),j=1,noa),(qz(i),i=1,noa)
       close(4)
       close(41)
       write(3,3030)anro*bdel**3
       write(6,3030)anro*bdel**3
3030   format(' Integration sum: ',F10.4)
       write(3,*)'DBBB.SCR and DBBB.cub written'
       write(6,*)'DBBB.SCR and DBBB.cub written'
      ENDIF
c
      if(lopara.or.lofc)THEN
c
      if(ioe.eq.2.or.ioe.eq.3)then
       aex=one
       if(ioe.eq.3)aex=z0
       open(23,file='AKJK.SCR',form='unformatted',status='old')
       read(23)((ak(i,j),i=1,nao),j=1,nao),((aj(i,j),i=1,nao),j=1,nao)
       close(23)
       write(6,*)'Coulomb and exchange terms read from scratch.'
       write(3,*)'Coulomb and exchange terms read from scratch.'
      endif
c
      if(lopara)then
      n=kp1
      xn=xv(1,n)
      yn=xv(2,n)
      zn=xv(3,n)
      INQUIRE(file='MOLL.SCR',exist=l1e)
      if(.not.l1e)call report('no MOLL.SCR')
      open(46,file='MOLL.SCR',form='unformatted')
      do 102 jj=1,n
      do 102 i2=1,3
102   read(46)((oon(i,j,i2),i=1,nmo),j=1,nmo)
      close(46)
      open(4,file='PBBB.SCR',form='unformatted')
      open(41,file='PBBB.cub')
      name='PSO perturbed density'
      write(4)name,nd,i0,j0,k0,z0,z0,z0,bdel,bdel,bdel
      call wrhead(name,nd,i0+1,j0+1,k0+1,bdel,xv,noa,amin,amax,qz,41)
      endif
c
      if(lofc)then
c     INQUIRE(file='MO22.SCR',exist=l2e)
c     if((.not.l1e).or.(not.l2e))call report('no MO22.SCR')
c     open(47,file='MO22.SCR',form='unformatted')
c     do 104 jj=1,n
c     do 104 ix=1,6
c104  read(47)((ttn(i,j,ix),i=1,nmo),j=1,nmo)
c     close(47)
      open(5,file='FBBB.SCR',form='unformatted')
      open(51,file='FBBB.cub')
      name='FC perturbed density'
      write(5)name,nd,i0,j0,k0,z0,z0,z0,bdel,bdel,bdel
      call wrhead(name,nd,i0+1,j0+1,k0+1,bdel,xv,noa,amin,amax,qz,51)
      m=kf1
      xm=xv(1,m)
      ym=xv(2,m)
      zm=xv(3,m)
      endif
c
      ib=0
      ip0=0
      x=amin(1)-bdel
      ix=-1
8001  ip=int(100.0d0*(x-amin(1))/(amax(1)-amin(1)))
      if(ip.gt.ip0)then
       write(6,*)ip,'% ',x
       open(22,file='pfnum.progres')
       write(22,*)ip,'%'
       close(22)
      endif
      ip0=ip
      x=x+bdel
      ix=ix+1
      y=amin(2)-bdel
      iy=-1
8002  y=y+bdel
      iy=iy+1
      z=amin(3)-bdel
      iz=-1
8003  z=z+bdel
      iz=iz+1
      ib=ib+1
      rx(ib)=x
      ry(ib)=y
      rz(ib)=z
      iiz(ib)=iz
      iiy(ib)=iy
c
c      =========================================================
      if(ib.eq.nr0.or.iz.eq.k0)then
      nb=ib
c
      if(lopara)then
       do 557 i=1,nb
       r1x(i)=z0
       r1y(i)=z0
557    r1z(i)=z0
      endif
      if(lofc)then
       do 556 i=1,nb
556    r2(i)=z0
      endif
c
c     sum over occupied orbitals
      do 55 k=1,ndo
      ek=e(k)
      if(lofc)call forbaa(fkm,m,k)
      call osnake(k,nb,rx,ry,rz,db)
c
c     sum over excited states = virtual orbitals
      do 66 j=ndo+1,nmo
      ej=e(j)
      if(lofc)call forbaa(fjm,m,j)
      call osnake(j,nb,rx,ry,rz,dbj)
c
      ndeg=0
      do 22 jj=ndo+1,nmo
      if(abs(ej-e(jj)).lt.etol)then
       ndeg=ndeg+1
       if(ndeg.gt.4)then
        write(6,*)'Ndeg > 4 (?)'
        write(3,*)'Ndeg > 4 (?)'
        ndeg=4
       endif
       jdeg(ndeg)=jj
      endif
22    continue
c
      sums=z0
      sumt=z0
      if(ioe.eq.2.or.ioe.eq.3)then
       do 23 i2=1,ndeg
       jj=jdeg(i2)
       sumt=sumt-aj(k,jj)
23     sums=sums-aj(k,jj)+(ak(k,jj)+ak(k,jj))*aex
       sums=sums/dble(ndeg)
       sumt=sumt/dble(ndeg)
      endif
c
c     singlet triplet states:
      ejks=ej-ek+sums
      ejkt=ej-ek+sumt
c
      if(ejks.gt.etol)then
       if(lopara)then
        fx=oon(k,j,1)/ejks
        fy=oon(k,j,2)/ejks
        fz=oon(k,j,3)/ejks
        do 558 i=1,nb
        r1x(i)=r1x(i)+dbj(i)*fx*db(i)
        r1y(i)=r1y(i)+dbj(i)*fy*db(i)
558     r1z(i)=r1z(i)+dbj(i)*fz*db(i)
       endif
      endif
c
      if(ejkt.gt.etol)then
       if(lofc)then
        fac=fkm*fjm/ejkt
        do 555 i=1,nb
555     r2(i)=r2(i)+dbj(i)*fac*db(i)
       endif
      endif
c
c      tensor components  1  2  3  4  5  6
c                        xx xy xz yy yz zz
c      NxxMxx+NxyMxy+NxzMxz+NyxMyx+NyyMyy+NyzMyz+NzxMzx+NzyMzy+NzzMzz=
c      NxxMxx+NyyMyy+NzzMzz+2(NxyMxy+NxzMxz+NzyMzy=11+44+66+2*(22+33+55)
c      aco4=-four/three*Pi
c      tnxx=ttn(k,j,1)+aco4*fkn*fjn
c      tnyy=ttn(k,j,4)+aco4*fkn*fjn
c      tnzz=ttn(k,j,6)+aco4*fkn*fjn
c
c      spin-dipolar:
c      asd=asd-(     tnxx*tmxx+tnyy*tmyy+tnzz*tmzz+
c    1          two*(ttn(k,j,2)*+ttn(k,j,3)*+
c    1               ttn(k,j,5)*)/ejkt
c      xxn= ttn(k,j,4)+ttn(k,j,6)
c      yyn= ttn(k,j,1)+ttn(k,j,6)
c      zzn= ttn(k,j,1)+ttn(k,j,4)
c      xyn=-ttn(k,j,2)
c      xzn=-ttn(k,j,3)
c      yzn=-ttn(k,j,5)
c      afcsd=afcsd-(xxn*xxm+yyn*yym+zzn*zzm+
c    1         two*(xyn*xym+xzn*xzm+yzn*yzm))/ejkt
c
66    continue
c
55    continue

        if(lopara)then
         do 904 ib=1,nb
904      rofo(iiz(ib)+1 ,iiy(ib)+1)=
     1     sqrt(r1x(ib)**2+r1y(ib)**2+r1z(ib)**2)
        endif
c
        if(lofc)then
         do 903 ib=1,nb
903      rofof(iiz(ib)+1,iiy(ib)+1)=r2(ib)
        endif
c
        ib=0
       endif
c      =========================================================
c
       if(iz.lt.k0)goto 8003
       write(41,4144)(rofo (i,iy),i=1,k0+1)
       write(51,4144)(rofof(i,iy),i=1,k0+1)
       if(iy.lt.j0)goto 8002
       if(lopara)write(4)((rofo (i,j),i=1,k0+1),j=1,j0+1)
       if(lofc)  write(5)((rofof(i,j),i=1,k0+1),j=1,j0+1)
       if(ix.lt.i0)goto 8001
c
       if(lofc)then
       write(5)noa,((rt(i,j),i=1,3),j=1,noa),(qz(i),i=1,noa)
       close(5)
       close(51)
       write(3,*)'FBBB.SCR and FBBB.cub written'
       write(6,*)'FBBB.SCR and FBBB.cub written'
       endif

       if(lopara)then
       write(4)noa,((rt(i,j),i=1,3),j=1,noa),(qz(i),i=1,noa)
       close(4)
       close(41)
       write(3,*)'PBBB.SCR and PBBB.cub written'
       write(6,*)'PBBB.SCR and PBBB.cub written'
       endif
c
      ENDIF
c
      return
      end
c     =========================================================
      subroutine wrhead(name,nd,i0,j0,k0,bdel,xv,noa,amin,amax,qz,io)
      implicit none
      character*(*) name
      integer*4 nd,noa,i0,j0,k0,nat0,i,j,io
      parameter (nat0=190)
      real*8 bdel,xv(3,nat0),amin(*),amax(*),qz(*)
      write(io,*)name
      write(io,4141)
4141  format(' SCF Molecular Orbitals')
      write(io,4142)-noa,amin(1),amin(2),amin(3)
      write(io,4142)i0,bdel,0.0d0,0.0d0
      write(io,4142)j0,0.0d0,bdel,0.0d0
      write(io,4142)k0,0.0d0,0.0d0,bdel
      do 6002 j=1,noa
6002  write(io,4142)int(qz(j)),qz(j),(xv(i,j),i=1,3)
4142  format(i5,4f12.6)
      write(io,4143)
4143  format('    1    1')
      return
      end
