      subroutine trafosp(ks,je,tol)
c
c     transform AO 2-e int on disk into MO
c     use the sparsity in first transformations
c
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      parameter (nat0=190,nor=80,nort=700,
     1nbuff=400,nrt0=30)
      character*2 at
      character*1 ok,ty
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/numbers/z0,one,two,three,four,five,six,half,qua,
     1a8,a10
      dimension xmm(500),imm(500)
      common/bigb/ amm(nrt0*nrt0*(nrt0+1)/2),
     1 ct(nrt0),bmm(nrt0*nrt0*(nrt0+1)/2),
     1ib(nbuff),jb(nbuff),kb(nbuff),lb(nbuff),bb(nbuff)
      dimension bmmt(100)
      logical lskip,lopt,lci
      common/opts/lopt(300),icha,n1
      equivalence (lopt(59),lci)
c
      inquire(file='BBCD.SCR',exist=lskip)
      if(lskip)then
       write(6,*)' (abcd) integrals found on disk in BBCD.SCR'
       write(3,*)' (abcd) integrals found on disk in BBCD.SCR'
       return
      endif
c
      if(lci)then
       je1=nmo
       ks1=1
      else
       je1=je
       ks1=ks
      endif
      noom=je1-ks1+1

      write(6,*)' transformation (ij|kl)-> (abcd)'
      open(45,file='MPN45.SCR',form='unformatted')
      open(46,file='MPN46.SCR',form='unformatted')
      open(47,file='MPN47.SCR',form='unformatted')
      open(48,file='MPN48.SCR',form='unformatted')
      open(49,file='MPN49.SCR',form='unformatted')
      open(50,file='MPN50.SCR',form='unformatted')
      open(51,file='MPN51.SCR',form='unformatted')
      open(52,file='ABCD.SCR',form='unformatted')
      if(nao.gt.nrt0)call report(' Too many orbitals for trafo')
      nao22=nao*(nao+1)/2
      a0t=dble(mclock())
      do 1 ia=ks1,je1
c     (aijk) for all (i,j,k<=j)
      call vz(amm,z0,nao*(nao+1)*nao/2)
      do 2 i=45 ,51
2     rewind i
      do 3 i=1,nao
3     ct(i)=cij(ia,i)
c
c     iiii
10    read(45,end=20)n,(bb(i),i=1,n),(ib(i),i=1,n)
      do 201 i=1,n
      ii=ib(i)
      ind=(ii-1)*nao22+(ii-1)*ii/2+ii
201   amm(ind)=amm(ind)+bb(i)*ct(ii)
      goto 10
c
c     iiij -> to aiij,ajii,aiii
20    read(46,end=30)n,(bb(i),i=1,n),(ib(i),i=1,n),(jb(i),i=1,n)
      do 202 i=1,n
      b=bb(i)
      ii=ib(i)
      jj=jb(i)
      ind=(ii-1)*nao22+(max(ii,jj)-1)*max(ii,jj)/2+min(ii,jj)
      amm(ind)=amm(ind)+b*ct(ii)
      ind=(jj-1)*nao22+(ii-1)*ii/2+ii
      amm(ind)=amm(ind)+b*ct(ii)
      ind=(ii-1)*nao22+(ii-1)*ii/2+ii
202   amm(ind)=amm(ind)+b*ct(jj)
      goto 20
c
c     iijj -> to aijj,ajii
30    read(47,end=40)n,(bb(i),i=1,n),(ib(i),i=1,n),(jb(i),i=1,n)
      do 203 i=1,n
      b=bb(i)
      ii=ib(i)
      jj=jb(i)
      ind=(jj-1)*nao22+(ii-1)*ii/2+ii
      amm(ind)=amm(ind)+b*ct(jj)
      ind=(ii-1)*nao22+(jj-1)*jj/2+jj
203   amm(ind)=amm(ind)+b*ct(ii)
      goto 30
c
c     ijij -> to aiij,ajij
40    read(48,end=50)n,(bb(i),i=1,n),(ib(i),i=1,n),(jb(i),i=1,n)
      do 204 i=1,n
      b=bb(i)
      ii=max(ib(i),jb(i))
      jj=min(ib(i),jb(i))
      ind=(jj-1)*nao22+(ii-1)*ii/2+jj
      amm(ind)=amm(ind)+b*ct(ii)
      ind=(ii-1)*nao22+(ii-1)*ii/2+jj
204   amm(ind)=amm(ind)+b*ct(jj)
      goto 40
c
c     ijkk -> to ajkk, aikk,akij
50    read(49,end=60)n,(bb(i),i=1,n),(ib(i),i=1,n),(jb(i),i=1,n),
     1                               (kb(i),i=1,n)
      do 205 i=1,n
      b=bb(i)
      ii=max(ib(i),jb(i))
      jj=min(ib(i),jb(i))
      kk=kb(i)
      ind=(jj-1)*nao22+(kk-1)*kk/2+kk
      amm(ind)=amm(ind)+b*ct(ii)
      ind=(ii-1)*nao22+(kk-1)*kk/2+kk
      amm(ind)=amm(ind)+b*ct(jj)
      ind=(kk-1)*nao22+(ii-1)*ii/2+jj
205   amm(ind)=amm(ind)+b*ct(kk)
      goto 50
c
c     ikjk -> to akjk,aijk,akik,ajik
60    read(50,end=70)n,(bb(i),i=1,n),(ib(i),i=1,n),(jb(i),i=1,n),
     1                               (kb(i),i=1,n)
      do 206 i=1,n
      b=bb(i)
      ii=ib(i)
      jj=jb(i)
      kk=kb(i)
      ind=(kk-1)*nao22+(max(jj,kk)-1)*max(jj,kk)/2+min(jj,kk)
      amm(ind)=amm(ind)+b*ct(ii)
      ind=(ii-1)*nao22+(max(jj,kk)-1)*max(jj,kk)/2+min(jj,kk)
      amm(ind)=amm(ind)+b*ct(kk)
      ind=(kk-1)*nao22+(max(ii,kk)-1)*max(ii,kk)/2+min(ii,kk)
      amm(ind)=amm(ind)+b*ct(jj)
      ind=(jj-1)*nao22+(max(ii,kk)-1)*max(ii,kk)/2+min(ii,kk)
206   amm(ind)=amm(ind)+b*ct(kk)
      goto 60
c
c     ijkl -> to ajkl,aikl,akij,alij
70    read(51,end=80)n,(bb(i),i=1,n),(ib(i),i=1,n),(jb(i),i=1,n),
     1                              (kb(i),i=1,n),(lb(i),i=1,n)
      do 207 i=1,n
      b=bb(i)
      ii=ib(i)
      jj=jb(i)
      if(jj.gt.ii)then
       it=ii
       ii=jj
       jj=it
      endif
      kk=kb(i)
      ll=lb(i)
      if(ll.gt.kk)then
       it=kk
       kk=ll
       ll=it
      endif
      ind=(jj-1)*nao22+(kk-1)*kk/2+ll
      amm(ind)=amm(ind)+b*ct(ii)
      ind=ind+(ii-jj)*nao22
      amm(ind)=amm(ind)+b*ct(jj)
      ind=(kk-1)*nao22+(ii-1)*ii/2+jj
      amm(ind)=amm(ind)+b*ct(ll)
      ind=ind+(ll-kk)*nao22
207   amm(ind)=amm(ind)+b*ct(kk)
      goto 70
c
80    na=0
      do 208 i=1,nao*nao22
      if(abs(amm(i)).gt.tol)then
       na=na+1
       xmm(na)=amm(i)
       imm(na)=i
       if(na.eq.500)then
        write(52)na,(xmm(ii),ii=1,na),(imm(ii),ii=1,na)
        na=0
       endif
      endif
208   continue
      if(na.gt.0)write(52)na,(xmm(i),i=1,na),(imm(i),i=1,na)
      i999=-999
      write(52)i999
c
1     continue
c
      do 4 i=45 ,51
4     close(i)
c
      write(6,*)'first index transformed'
c
      open(53,file='BBCD.SCR',form='unformatted')
      do 21 IBB=ks1,je1
c     Aijk->(BAjk) for all (b>=a,j,k<=j)
      IBi=IBB-ks1+1
      call vz(bmm,z0,IBi*nao22)
      do 23 i=1,nao
23    ct(i)=cij(IBB,i)
      rewind 52
      do 24 IA=ks1,IBB
      IAi=IA-ks1+1
c
      call vz(amm,z0,nao*nao22)
500   read(52)na,(xmm(i),i=1,na),(imm(i),i=1,na)
      do 209 i=1,na
209   amm(imm(i))=xmm(i)
      if(na.ne.i999)goto 500
c
      i2=0
      do 24 i=1,nao
      do 24 j=1,nao
      do 24 k=1,j
      i2=i2+1
      ind=k+(j-1)*j/2+(IAi-1)*nao22
24    bmm(ind)=bmm(ind)+ct(i)*amm(i2)
c
      na=0
      do 210 i=1,IBi*nao22
      if(abs(bmm(i)).gt.tol)then
       na=na+1
       xmm(na)=bmm(i)
       imm(na)=i
       if(na.eq.500)then
        write(53)na,(xmm(ii),ii=1,na),(imm(ii),ii=1,na)
        na=0
       endif
      endif
210   continue
      if(na.gt.0)write(53)na,(xmm(i),i=1,na),(imm(i),i=1,na)
      write(53)i999
c
21    continue
c
      write(6,*)'second index transformed'
c
      rewind 52
      do 31 IC=ks1,je1
c     (BACk) for b,a<=b,k
      call vz(bmm,z0,noom*(noom+1)/2*nao)
      do 33 i=1,nao
33    ct(i)=cij(IC,i)
      rewind 53
      do 35 IBB=ks1,je1
      IBi=IBB-ks1+1
c
      call vz(amm,z0,IBi*nao22)
501   read(53)na,(xmm(i),i=1,na),(imm(i),i=1,na)
      do 211 i=1,na
211   amm(imm(i))=xmm(i)
      if(na.ne.i999)goto 501
c
      do 35 IA=ks1,IBB
      IAi=IA-ks1+1
      do 35 k=1,nao
c     bakk -> back
      i2=k+(k-1)*k/2+(IAi-1)*nao22
      ind=k+((IAi-1)+(IBi-1)*IBi/2)*nao
      bmm(ind)=bmm(ind)+ct(k)*amm(i2)
      do 35 l=1,k-1
      i2=l+(k-1)*k/2+(IAi-1)*nao22
c     bakl -> back,bacl
      ind=l+((IAi-1)+(IBi-1)*IBi/2)*nao
      bmm(ind)=bmm(ind)+ct(k)*amm(i2)
      ind=k+((IAi-1)+(IBi-1)*IBi/2)*nao
35    bmm(ind)=bmm(ind)+ct(l)*amm(i2)
31    write(52)(bmm(i),i=1,noom*(noom+1)/2*nao)
c
      write(6,*)'third index transformed'
c
      iin=0
      ito=0
      rewind(53)
      do 41 ID=ks1,je1
      IDi=ID-ks1+1
c     (bacd) for all b,a<=b,c,d>=c, (ab)<(cd)
c     how many of them
      ntest=IDi*(IDi*IDi+1)/2
      call vz(bmm,z0,ntest)
      do 43 i=1,nao
43    ct(i)=cij(ID,i)
      rewind 52
      do 45 IC=ks1,ID
      ICi=IC-ks1+1
      read(52)(amm(i),i=1,noom*(noom+1)/2*nao)
      do 45 IBB=ks1,ID
      IBi=IBB-ks1+1
      iae=IBB
      if(IBB.eq.ID)iae=IC
      do 45 IA=ks1,iae
      IAi=IA-ks1+1
      ind=IAi+(IBi-1)*IBi/2+(ICi-1)*(IDi*(IDi-1)+ICi)/2
      do 45 l=1,nao
      ind_bacl=l+(IAi-1)*nao+IBi*(IBi-1)*nao/2
c     bacl -> bacd
45    bmm(ind)=bmm(ind)+ct(l)*amm(ind_bacl)
c
c     write in 100 word blocks:
      write(53)ntest
      i5=0
      do i=1,ntest
       i5=i5+1
       if(abs(bmm(i)).gt.1.0d-10)iin=iin+1
       ito=ito+1
       bmmt(i5)=bmm(i)
       if(i5.eq.100)then
        write(53)(bmmt(ibb),ibb=1,i5)
        i5=0
       endif
      enddo
      if(i5.gt.0)write(53)(bmmt(ibb),ibb=1,i5)

41    continue
      rewind(52)
      write(52)
      close(52)
      close(53)
      write(6,*)'fourth index transformed, in BBCD.SCR'
      write(6,766)dble(mclock())-a0t
766   format('time of trafo:',f20.0)
c
      return
      end
