      SUBROUTINE TRTEN(NS,S,N,ALPHA,A,G)
      IMPLICIT REAL*8 (A-H,O-Z)
      implicit integer*4 (i-n)
      PARAMETER (nat0=190,N30=3*nat0)
      DIMENSION S(NS,N),A(NS,3,3,3),
     1ALPHA(NS,3,3),G(NS,3,3),V(N30)
      DO 1 I=1,3
      DO 1 J=1,3
      DO 3 JQ=1,N
3     V(JQ)=ALPHA(JQ,I,J)
      DO 1 IQ=1,N
      ALPHAS=0.0
      DO 2 IX=1,N
2     ALPHAS=ALPHAS+S(IX,IQ)*V(IX)
1     ALPHA(IQ,I,J)=ALPHAS
      DO 11 I=1,3
      DO 11 J=1,3
      DO 31 JQ=1,N
31    V(JQ)=G(JQ,I,J)
      DO 11 IQ=1,N
      GS=0.0
      DO 21 IX=1,N
21    GS=GS+S(IX,IQ)*V(IX)
11    G(IQ,I,J)=GS
      DO 12 I=1,3
      DO 12 J=1,3
      DO 12 K=1,3
      DO 32 JQ=1,N
32    V(JQ)=A(JQ,I,J,K)
      DO 12 IQ=1,N
      AS=0.0
      DO 22 IX=1,N
22    AS=AS+S(IX,IQ)*V(IX)
12    A(IQ,I,J,K)=AS
      WRITE(3,3001)
3001  FORMAT(1X,'TENSORS HAVE BEEN TRANSFORMED TO Q COORDINATES',/,
     11X,'ALPHA DERIVATIVES LISTED:')
      DO 4 IQ=1,N
4     WRITE(3,3000)IQ,((ALPHA(IQ,I,J),I=1,3),J=1,3)
3000  FORMAT(1X,I4,' MODE',/,3(3F15.8,/),/)
      WRITE(3,3002)
3002  FORMAT(1X, 11X,'G DERIVATIVES LISTED:')
      DO 5 IQ=1,N
5     WRITE(3,3000)IQ,((G(IQ,I,J),I=1,3),J=1,3)
      WRITE(3,3003)
3003  FORMAT(1X, 11X,'A DERIVATIVES LISTED:')
      DO 6 IQ=1,N
6     WRITE(3,3004)IQ,(((A(IQ,I,J,K),I=1,3),J=1,3),K=1,3)
3004  FORMAT(1X,I4,' MODE',/,3(9F8.5,/),/)
      RETURN
      END

C     ================================================================
      SUBROUTINE READALPHA(ALPHA)
      IMPLICIT REAL*8 (A-H,O-Z)
      implicit integer*4 (i-n)
      DIMENSION ALPHA(3,3)
      CHARACTER*20 STRING
      IC=0
201   READ(2,1111)STRING
      IC=IC+1
1111  FORMAT(A20)
C                    12345678901234567890
      IF (STRING.EQ.' Polarizability tens') THEN
       WRITE(3,*)' Alpha tensor found ... '
       DO 202 I=1,3
202    READ(2,*)
       DO 203 I=1,3
203    READ(2,*)(ALPHA(I,J),J=1,3)
       RETURN
      ENDIF
      IF(IC.GT.20000)THEN
       WRITE(2,*)' Alpha not found, program stopped ... '
       STOP
      ENDIF
      GOTO  201
      END
C     ==============================================================
      SUBROUTINE READA(A)
      IMPLICIT REAL*8 (A-H,O-Z)
      implicit integer*4 (i-n)
      DIMENSION A(3,3,3)
      CHARACTER*20 STRING
      IC=0
201   READ(2,1111)STRING
      IC=IC+1
1111  FORMAT(A20)
C                    12345678901234567890
      IF (STRING.EQ.' Dipole-Quadrupole P') THEN
       WRITE(3,*)' A tensor found ... '
       READ(2,*)
       DO 203 I=1,3
       READ(2,*)A(I,1,1),A(I,2,2),A(I,3,3),A(I,1,2),A(I,1,3),A(I,2,3)
       A(I,2,1)=A(I,1,2)
       A(I,3,1)=A(I,1,3)
203    A(I,3,2)=A(I,2,3)
       RETURN
      ENDIF
      IF(IC.GT.20000)THEN
       WRITE(2,*)' A not found, program stopped ... '
       STOP
      ENDIF
      GOTO  201
      END
C     ==============================================================
      SUBROUTINE READG(G,IFF)
c
c     first index electric, second magnetic
c
      IMPLICIT REAL*8 (A-H,O-Z)
      implicit integer*4 (i-n)
      DIMENSION G(3,3)
      CHARACTER*20 STRING
      IC=0
201   READ(2,1111)STRING
      IC=IC+1
1111  FORMAT(A20)
C                    12345678901234567890
      IF (STRING.EQ.' LOW FREQUENCY LIMIT') THEN
       WRITE(3,3000)
3000  FORMAT(22H  G' tensor found ... )
       DO 202 I=1,3
202    READ(2,*)
       IF(IFF.EQ.0)THEN
        DO 203 I=1,3
        READ(2,*)
 203    READ(2,3002)(G(I,J),J=1,3)
       ELSE
        DO 2031 I=1,3
        READ(2,*)
2031    READ(2,3003)(G(I,J),J=1,3)
       ENDIF
3002  FORMAT(12X,3F20.13)
3003  FORMAT(12X,3F16.8)
       RETURN
      ENDIF
      IF(IC.GT.20000)THEN
       WRITE(2,3001)
3001  FORMAT(36H  G' not found, program stopped ... )
       STOP
      ENDIF
      GOTO  201
      END
C     ===============================================================
      SUBROUTINE READSEC(N0,FCAR,N,IP)
      IMPLICIT REAL*8 (A-H,O-Z)
      implicit integer*4 (i-n)
      DIMENSION FCAR(N0,N)
      CHARACTER*15 STRING
      IC=0
201   READ(2,1111)STRING
      IC=IC+1
1111  FORMAT(A15)
      IF (STRING.EQ.' Total cartesia'.OR.
     1    STRING.EQ.' Cartesian Forc')THEN
       WRITE(3,*)' Second derivatives found ... '
       WRITE(6,*)' Second derivatives found ... '
       DO 202 I=1,7
202    READ(2,*)
       N0C=0
204    NC=6*N0C+1
       MC=NC+5
       IF (MC.GT.N)MC=N
       IF(IP.EQ.0)THEN
        DO 2030 IC=1,N
2030    READ(2,2700)(FCAR(IC,JC),JC=NC,MC)
       ELSE
        DO 203 IC=1,N
203     READ(2,270)(FCAR(IC,JC),JC=NC,MC)
       ENDIF
270    FORMAT(18X,6F10.5)
2700   FORMAT(18X,6F14.9)
       IF(MC.LT.N) THEN
        DO 205 I=1,7
205     READ(2,*)
        N0C=N0C+1
        GOTO 204
       ENDIF
       RETURN
      ENDIF
      IF(IC.GT.20000)THEN
       WRITE(2,*)' Seconds not found, program stopped ... '
       STOP
      ENDIF
      GOTO  201
      END
C     ==============================================================
      SUBROUTINE CONTROL(N3,S,F,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      implicit integer*4 (i-n)
      PARAMETER (nat0=190,N30=3*nat0)
      DIMENSION S(N3,N),F(N3,N),QL(N30,N30)
      COMMON//E(N30),N7
      WRITE(3,*)' NORMALIZATION OF S-MATRIX'
C     SUMijk (SiqSjpFij) = OMp^2 p=q
      DO 1 I=1,N
      DO 1 J=1,N
      QL(I,J)=0.0
      DO 1 II=1,N
      DO 1 JJ=1,N
1     QL(I,J)=QL(I,J)+S(II,I)*S(JJ,J)*F(II,JJ)
      DO 3 J=1,N
3     WRITE(3,2)(QL(I,J),I=1,N)
2     FORMAT(11F7.4)
      SFAC=0.0
      DO 4 I=N7,N
4     SFAC=SFAC+E(I)*E(I)/QL(I,I)
      SFAC=SFAC/DBLE(N-N7+1)
      SFAC=SQRT(SFAC)
      DO 5 I=1,N
      DO 5 J=1,N
5     S(I,J)=S(I,J)*SFAC
      WRITE(3,6)SFAC
6     FORMAT(1X,'FACTOR FOR S-MATRIX: ',F20.10)
      NAT=N/3
      OPEN(4,FILE='S.MAT',FORM='UNFORMATTED')
      WRITE(4)NAT,(E(I),I=1,3*NAT),((S(I,J),J=1,3*NAT),I=1,3*NAT),SFAC
      CLOSE(4)
      WRITE(3,*)' S.MAT written on the disk'
      RETURN
      END
C     ==============================================================
      SUBROUTINE READSMAT(N3,S,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      implicit integer*4 (i-n)
      PARAMETER (nat0=190,N30=3*nat0)
      DIMENSION S(N3,N)
      CHARACTER*15 STRING
      COMMON//E(N30),N7
      CM=219470.0
C     1 a.u.= 2.1947E5 cm^-1
      NAT=N/3
      IC=0
201   READ(2,1111)STRING
      IC=IC+1
1111  FORMAT(A15)
C                    1234567890123456789012345678901234567890
      IF (STRING.EQ.' Transformation')THEN
       WRITE(3,*)' S matrix found ... '
       WRITE(6,*)' S matrix found ... '
       DO 1 I=1,3
1      READ(2,*)
       imode=0
       i=0
800    CONTINUE
       NM=3*NAT-IMODE
       IF(NM.GT.6)NM=6
       READ(2,*)(E(IE),IE=IMODE+1,IMODE+NM)
       IMODE=IMODE+NM
       read(2,*)
       read(2,*)
       DO 2 J=1,NAT
       read(2,200)(S((J-1)*3+1,IMODE-NM+JJ),JJ=1,NM)
       read(2,200)(S((J-1)*3+2,IMODE-NM+JJ),JJ=1,NM)
       read(2,200)(S((J-1)*3+3,IMODE-NM+JJ),JJ=1,NM)
200    FORMAT(17x,6F10.5)
2      CONTINUE
       IF(Imode.LT.3*nat) then
        DO 3 i=1, 3
3       read(2,*)
        goto 800
       endIF
       DO 4 I=1,3*NAT
4      E(I)=E(I)/CM
       RETURN
      ENDIF
      IF (IC.GT.20000)THEN
       WRITE(3,*)' S - matrix not found ...'
       STOP
      ENDIF
      GOTO 201
      end
C     =================================================================
      FUNCTION EPS(I,J,K)
      REAL*8 EPS
      INTEGER*4 I,J,K
      EPS=0.0D0
      IF (I.EQ.1.AND.J.EQ.2.AND.K.EQ.3)EPS= 1.0D0
      IF (I.EQ.1.AND.J.EQ.3.AND.K.EQ.2)EPS=-1.0D0
      IF (I.EQ.2.AND.J.EQ.3.AND.K.EQ.1)EPS= 1.0D0
      IF (I.EQ.2.AND.J.EQ.1.AND.K.EQ.3)EPS=-1.0D0
      IF (I.EQ.3.AND.J.EQ.1.AND.K.EQ.2)EPS= 1.0D0
      IF (I.EQ.3.AND.J.EQ.2.AND.K.EQ.1)EPS=-1.0D0
      RETURN
      END
C     ==============================================================
      SUBROUTINE READS(N3,S)
      IMPLICIT REAL*8 (A-H,O-Z)
      implicit integer*4 (i-n)
      PARAMETER (nat0=190,N30=3*nat0,MENDELEV=89)
      DIMENSION S(N3,N3)
      COMMON//E(N30),N7
      CHARACTER*2 atsy(MENDELEV)
      data atsy/' H','He','Li','Be',' B',' C',' N',' O',' F','Ne',
     3'Na','Mg','Al','Si',' P',' S','Cl','Ar',
     4' K','Ca','Sc','Ti',' V','Cr','Mn','Fe','Co','Ni','Cu','Zn',
     4          'Ga','Ge','As','Se','Br','Kr',
     5'Rb','Sr',' Y','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd',
     5          'In','Sn','Sb','Te',' I','Xe',
     6'Cs','Ba','La',
     6               'Ce','Pr','Nd','Pm','Sm','Eu','Gd','Tb','Dy','Ho',
     6               'Er','Tm','Yb','Lu',
     6'Hf','Ta',' W','Re','Os','Ir','Pt','Au','Hg',
     6          'Tl','Pb','Bi','Po','At','Rn',
     7'Fr','Ra','Ac'/
C
      CM=219470.0
      SFAC=0.0234280
C     1 a.u.= 2.1947E5 cm^-1
      WRITE(3,*)' S matrix read from the file F.INP:'
      IS=0
      OPEN(4,FILE='F.INP',STATUS='OLD',IOSTAT=IS)
      IF(IS.NE.0)THEN
       IF(IS.EQ.6)WRITE(3,*)' FILE "F.INP" NOT FOUND'
       WRITE(3,*)' PROGRAM ERROR STOP'
       STOP
      ENDIF
      read(4,*)nint,nat3,nat
      N=NAT3
      N7=N-NINT+1
      WRITE(3,3002)
3002  FORMAT(1X,'THE GEOMETRY (CHECK IF THE SAME AS THE AB INITIO):',/,
     1       1X,'Nuclear charge atom coding is supposed')
      DO 1 I=1,NAT
      read(4,*)ki,xi1,xi2,xi3
1     WRITE(3,3001)I,KI,ATSY(KI),XI1,XI2,XI3
3001  FORMAT(2I3,A2,3F15.6)
      read(4,*)
      DO 2 I=1,NAT
      DO 2 J=1,NINT
2     read(4,*)idum,idum,s(3*(i-1)+1,j+N7-1),
     1s(3*(i-1)+2,j+N7-1),s(3*(i-1)+3,j+N7-1)
      read(4,*)nint
      READ(4,4000)(E(I),I=N7,N)
4000  FORMAT(6F11.6)
      DO 3 I=N7,N
3     E(I)=E(I)/CM
      DO 7 I=1,N7-1
      E(I)=0
      DO 7 J=1,N
7     S(J,I)=0.0
      DO 5 I=1,N
      DO 5 J=1,N
5     S(I,J)=S(I,J)*SFAC
      WRITE(3,6)SFAC
6     FORMAT(1X,'FACTOR FOR S-MATRIX: ',F20.10)
      NAT=N/3
      OPEN(5,FILE='S.MAT',FORM='UNFORMATTED')
      WRITE(5)NAT,(E(I),I=1,3*NAT),((S(I,J),J=1,3*NAT),I=1,3*NAT),SFAC
      CLOSE(5)
      WRITE(3,*)' S.MAT written on the disk'
      RETURN
      end
C
      SUBROUTINE READTEN(N30,NAT,ALPHA,G,A,alphav)
      IMPLICIT REAL*8 (A-H,O-Z)
      implicit integer*4 (i-n)
      DIMENSION ALPHA(N30,3,3),G(N30,3,3),A(N30,3,3,3),alphav(N30,3,3)
      OPEN(2,FILE='FILE.TTT',STATUS='OLD')
      READ(2,*)
      READ(2,*)NAT
      READ(2,*)
      READ(2,*)
      DO 1 I=1,3
      READ(2,*)
      DO 1 L=1,NAT
      DO 1 IX=1,3
      IND=3*(L-1)+IX
      READ(2,*)LDUM,IXDUM,(ALPHA(IND,I,J),J=1,3)
      DO 1 J=1,3
1     alphav(IND,I,J)=ALPHA(IND,I,J)
      READ(2,*)
      READ(2,*)
      DO 2 I=1,3
      READ(2,*)
      DO 2 L=1,NAT
      DO 2 IX=1,3
      IND=3*(L-1)+IX
2     READ(2,*)LDUM,IXDUM,(G(IND,I,J),J=1,3)
      READ(2,*)
      READ(2,*)
      DO 3 I=1,3
      DO 3 J=1,3
      READ(2,*)
      DO 3 L=1,NAT
      DO 3 IX=1,3
      IND=3*(L-1)+IX
3     READ(2,*)LDUM,IXDUM,(A(IND,I,J,K),K=1,3)
      CLOSE(2)
      WRITE(3,*)NAT,' atoms, tensors read in from FILE.TTT'
      RETURN
      END
C     ==============================================================
C
      SUBROUTINE READXYZ(R,NAT,N30)
      IMPLICIT REAL*8(A-H,O-Z)
      implicit integer*4 (i-n)
      DIMENSION R(3,N30/3)
      OPEN(2,FILE='FILE.XYZ',STATUS='OLD')
      READ(2,*)
      BOHR=0.529177
      I=0
1     I=I+1
      READ(2,*)ID,(R(J,I),J=1,3)
      IF(ID.NE.9999)GOTO 1
      NAT=I-1
      CLOSE(2)
      DO 2 I=1,NAT
      DO 2 J=1,3
2     R(J,I)=R(J,I)/BOHR
      WRITE(3,*)NAT,' atoms, geometry read in from FILE.XYZ'
      RETURN
      END
C
