      SUBROUTINE WRITETTT(M3,NAT,ALPHA,A,G)
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      DIMENSION ALPHA(M3,3,3),G(M3,3,3),A(M3,3,3,3)
      WRITE(2,2000)NAT
2000  FORMAT(' ROA tensors, cartesian derivatives',/,I4,' atoms',/,
     1' The electric-dipolar electric-dipolar polarizability:',/,
     2' Atom/x    jx           jy           jz')
      DO 1 I=1,3
      WRITE(2,2002)I
2002  FORMAT(' Alpha(',I1,',J):')
      DO 1 L=1,NAT
      DO 1 IX=1,3
      IIND=3*(L-1)+IX
1     WRITE(2,2001)L,IX,(ALPHA(IIND,I,J),J=1,3)
2001  FORMAT(I5,I2,3F16.7)
      WRITE(2,2004)
2004  FORMAT(' The electric dipole magnetic dipole polarizability:',/,
     1       ' Atom/x    jx(Bx)       jy(By)       jz(Bz)')
      DO 2 I=1,3
      WRITE(2,2003)I
2003  FORMAT(' G(',I1,',J):')
      DO 2 L=1,NAT
      DO 2 IX=1,3
      IIND=3*(L-1)+IX
2     WRITE(2,2001)L,IX,(G(IIND,I,J),J=1,3)
      WRITE(2,2005)
2005  FORMAT(' The electric dipole electric quadrupole polarizability:',
     2/,     ' Atom/x    kx           ky           kz')
      DO 3 I=1,3
      DO 3 J=1,3
      WRITE(2,2006)I,J
2006  FORMAT(' A(',I1,',',I1,',K):')
      DO 3 L=1,NAT
      DO 3 IX=1,3
      IIND=3*(L-1)+IX
3     WRITE(2,2001)L,IX,(A(IIND,I,J,K),K=1,3)
      WRITE(2,2007)
2007  FORMAT(' Velocity form of alpha (dummy):',/,
     1       ' Atom/x    jx           jy           jz')
      DO 4 I=1,3
      WRITE(2,2008)I
2008  FORMAT(' AlphaV(',I1,',J):')
      DO 4 L=1,NAT
      DO 4 IX=1,3
      IIND=3*(L-1)+IX
4     WRITE(2,2001)L,IX,(ALPHA(IIND,I,J),J=1,3)
      RETURN
      END
c     ============================================================
      subroutine writecon(ndiff)
c     writes control output
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      common/const/pi,clau,spt,bohr,debye
      character*2 at
      character*1 ok,ty
      parameter (nat0=190,nor=80,nort=700)
      common/work/escf,
     2cc(nat0,nor),alpha(nat0,nor),
     3rcp(nat0,nor),cij(nort,nort),bij(nort,nort),
     4e(nort),be(nort),nat,nao,nmo,
     5noe,ichm,mtp,ndo,nsa,nsb,noa,nori,
     6nop(nat0),ty(nat0,nor),ish(nat0,nor),
     7at(nat0),ok
      common/atoms/z(nat0),zsum,xv(3,nat0)
      logical lsprint,lpprint,lqprint,ld5,levprint,lvprint,llprint,lf7,
     1ld2,SCALED,TTT,RAMAN,XYZ,ABINI,CC5,LAN,LDO,lvv,lsp,lex,
     1lscf,lres,lcndo,fspec,lrec,lc5,lg94,
     9lopt,lturbo
      equivalence (lopt(68),lturbo)
      common/opts/lopt(300),icha,n1
      equivalence (lopt(1),lsprint),(lopt(2),lpprint),(lopt(3),lqprint),
     1(lopt(4 ),ld5    ),(lopt(5),levprint),(lopt(6),lvprint),
     1(lopt(7 ),llprint),(lopt(8),lf7     ),(lopt(9),ld2    ),
     1(lopt(10),SCALED ),(lopt(11),TTT    ),(lopt(12),RAMAN ),
     1(lopt(13),XYZ    ),(lopt(14),ABINI  ),(lopt(15),cc5   ),
     1(lopt(16),lan    ),(lopt(17),ldo    ),(lopt(18),lvv    ),
     1(lopt(19),lsp    ),(lopt(20),lex    ),(lopt(21),lscf   ),
     1(lopt(22),lres   ),(lopt(23),lcndo  ),(lopt(24),fspec  ),
     1(lopt(25),lrec   ),(lopt(26),lc5    ),(lopt(27),lg94   )
      common/iopts/iopt(300)
      equivalence (iopt(1),ncnmr),(iopt(2),inormo  ),(iopt(3),nek1   ),
     1            (iopt(4),nek2 ),(iopt(5),nej1    ),(iopt(6),nej2   ),
     1            (iopt(7),ioe  ),(iopt(8),nstart  ),(iopt(9),nend   ),
     1            (iopt(10),nprc),(iopt(11),multi  ),(iopt(12),ndog  ),
     1            (iopt(13),nsi ),(iopt(14),nconfig),(iopt(15),nproc ),
     1            (iopt(16),neci),(iopt(17),idiago ),(iopt(18),igradc),
     1            (iopt(19),nev ),(iopt(20),mmit   ),(iopt(21),iham  ),
     1            (iopt(22),ncut),(iopt(23),nk     ),(iopt(24),nj    )
      character*3 aot
      integer*4 iat,isha
      common/aotypes/aot(nort),iat(nort),isha(nort)
      parameter (nshtypes=49)
      character*3 shtypes(nshtypes)
      data shtypes/'s  ','px ','py ','pz ','d0 ','d1a','d1b',
     1             'd2a','d2b',
     1'f 0','f+1','f-1','f+2','f-2','f+3','f-3',
     2'g 0','g+1','g-1','g+2','g-2','g+3','g-3','g+4','g-4',
     2'h 0','h+1','h-1','h+2','h-2','h+3','h-3','h+4','h-4','h+5','h-5',
     2'i 0','i+1','i-1','i+2','i-2','i+3','i-3','i+4','i-4','i+5','i-5',
     2'i+6','i-6'/
      character*1 spd(7)
      data spd/'s','p','d','f','g','h','i'/
c
      mtp=multi
      if(ndiff.eq.0)then
      write(3,*)  'ROAAI control output'
      write(3,*)  'MOLECULAR PARAMETERS'
      write(3,*)  '------------------------------------------'
      write(3,*) 'Number of basis functions           :    ',nao
      write(6,*) 'Number of basis functions           :    ',nao
      write(3,*) 'Number of electrons                 :    ',noe
      write(3,*) 'Charge                              :    ',ichm
      write(3,*) 'Multiplicity                        :    ',mtp
      write(3,*) 'Number of doubly occupied orbitals  :    ',ndo
      write(3,*) 'Number of singly occupied a-orbitals:    ',nsa
      write(3,*) 'Number of singly occupied b-orbitals:    ',nsb
      write(3,*) 'Number of atoms                     :    ',noa
      write(3,*) 'Sum of atomic charges               :    ',int(zsum)
      write(3,*)
      write(3,*)
      iao=1
      do 1 i=1,noa
      write(3,4000) i,nop(i)
4000  format(I3,' atom, ',I4,' primitive functions:',/,
     1'  shell prim          alpha      expansion    P-expansion',
     2'   AO range')
      do 1 j=1,nop(i)
      if(ish(i,j+1).gt.ish(i,j))then
       idel=0
       if(ty(i,j).eq.'S')then
        idel=1
        aot(iao)='s  '
       endif
       if(ty(i,j).eq.'P')then
        idel=3
        aot(iao  )='px '
        aot(iao+1)='py '
        aot(iao+2)='pz '
       endif
       if(ty(i,j).eq.'L')then
        idel=4
        aot(iao  )='s  '
        aot(iao+1)='px '
        aot(iao+2)='py '
        aot(iao+3)='pz '
       endif
       if(ty(i,j).eq.'D'.and.ld5)then
        idel=5
        aot(iao  )='d0 '
        aot(iao+1)='d1a'
        aot(iao+2)='d1b'
        if(lturbo)then
         aot(iao+3)='d2a'
         aot(iao+4)='d2b'
        else
         aot(iao+3)='d2b'
         aot(iao+4)='d2a'
        endif
       endif
       if(ty(i,j).eq.'D'.and..not.ld5)then
        idel=6
        aot(iao  )='xx '
        aot(iao+1)='yy '
        aot(iao+2)='zz '
        aot(iao+3)='xy '
        aot(iao+4)='xz '
        aot(iao+5)='yz '
       endif
       if(ty(i,j).eq.'F'.and.lf7)then
        idel=7
        aot(iao   )='f 0'
        aot(iao+ 1)='f+1'
        aot(iao+ 2)='f-1'
        aot(iao+ 3)='f+2'
        aot(iao+ 4)='f-2'
        aot(iao+ 5)='f+3'
        aot(iao+ 6)='f-3'
       endif
       if(ty(i,j).eq.'F'.and..not.lf7)then
        L=3
        idel=10
        aot(iao   )='xxx'
        aot(iao+ 1)='yyy'
        aot(iao+ 2)='zzz'
        aot(iao+ 3)='xxy'
        aot(iao+ 4)='xxz'
        aot(iao+ 5)='yyx'
        aot(iao+ 6)='yyz'
        aot(iao+ 7)='zzx'
        aot(iao+ 8)='zzy'
        aot(iao+ 9)='xyz'
       endif

       if(ty(i,j).eq.'G'.or.ty(i,j).eq.'H'.or.ty(i,j).eq.'I')then
        if(ty(i,j).eq.'G')L=4
        if(ty(i,j).eq.'H')L=5
        if(ty(i,j).eq.'I')L=6
        idel=0
        if(lf7)then
         do 6 m=0,L
         ipend=2
         if(m.eq.0)ipend=1
         do 6 ip=1,ipend
         aot(iao+idel)(1:1)=spd(L+1)
         if(ip.eq.1)then
          aot(iao+idel)(2:2)='+'
         else
          aot(iao+idel)(2:2)='-'
         endif
         if(ipend.eq.1)aot(iao+idel)(2:2)=' '
         write(aot(iao+idel)(3:3),'(i1)')m
6        idel=idel+1
        else
         do 7 ix=0,L
         do 7 iy=0,L-ix
         iz=L-ix-iy
         write(aot(iao+idel)(1:1),'(i1)')ix
         write(aot(iao+idel)(2:2),'(i1)')iy
         write(aot(iao+idel)(3:3),'(i1)')iz
7        idel=idel+1
        endif
       endif

       do 200 k=0,idel-1
200    iat(iao+k)=i
       if(idel.eq.0)call report('uknown shell '//ty(i,j))

       if(ty(i,j).ne.'L')write(3,10001)ish(i,j),
     1 ty(i,j),j,alpha(i,j),cc(i,j),iao,iao+idel-1
       if(ty(i,j).eq.'L')write(3,10000)ish(i,j),
     1 ty(i,j),j,alpha(i,j),cc(i,j),rcp(i,j),iao,iao+idel-1
       iao=iao+idel
      else
       if(ty(i,j).ne.'L')write(3,10000)ish(i,j),
     1 ty(i,j),j,alpha(i,j),cc(i,j)
       if(ty(i,j).eq.'L')write(3,10000)ish(i,j),
     1 ty(i,j),j,alpha(i,j),cc(i,j),rcp(i,j)
      endif
10000 format(1x,i5,a1,I5,3f15.6,I4,' - ',I4)
10001 format(1x,i5,a1,I5,2f15.6,15x,I4,' - ',I4)
1     continue
      endif

c     Turbomole shell numbering - restarts each atom, separate for each shell
      do ii=1,nshtypes
       iaold=0
       isn=0
       do i=1,nao
        if(iat(i).ne.iaold)isn=0
        if(aot(i).eq.shtypes(ii))then
         isn=isn+1
         isha(i)=isn
        endif
        iaold=iat(i)
       enddo
      enddo

      if(nao.gt.nort)call report('Too many basis functions')
      write(3,*)' AO  type atom  shell'
      do 5 i=1,nao
5     write(3,300)i,aot(i),iat(i),isha(i)
300   format(i5,1x,a3,1x,2i4)
c
      if(levprint)then
       write(3,*)'Eigenvectors'
      else
       write(3,*)'Eigenvalues'
      endif
      write(3,*)'Alpha'
      i=1
      nori=ndo
      if(nmo.gt.0)nori=nmo
777   j=i+4
      if(j.gt.nori)j=nori
      write(3,1005)(e(i1),i1=i,j)
1005  format(12x,5f13.6)
      if(levprint)then
       write(3,10051)(i1,i1=i,j)
10051  format(12x,5i13)
       do 3 i2=1,nao
3      write(3,10052)i2,(cij(i1,i2),i1=i,j)
10052 format(i12,5f13.6)
       write(3,*)
      endif
      if(j.lt.nori)then
       i=i+5
       goto 777
      endif
c
      write(3,*)'Beta'
      i=1
7771  j=i+4
      if(j.gt.nori)j=nori
      write(3,1005)(be(i1),i1=i,j)
      if(levprint)then
       write(3,10051)(i1,i1=i,j)
       do 31 i2=1,nao
31     write(3,10052)i2,(bij(i1,i2),i1=i,j)
       write(3,*)
      endif
      if(j.lt.nori)then
       i=i+5
       goto 7771
      endif
c
      open(31,file='GEO.X')
      write(3,*)'Geometry (A): '
      write(31,*)'Geometry (A): '
      write(31,*)nat
      do 112 i=1,nat
      write(31,11021)int(z(i)),(bohr*xv(j,i),j=1,3)
11021 format(i3,3f16.6,' 0 0 0 0 0 0 0 0.0')
112   write(3,1102)at(i),i,(bohr*xv(j,i),j=1,3),z(i)
1102  format(1x,a2,i3,3f16.6,f10.5)
      close(31)
c
      return
      end

      subroutine vp(a,b,c)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      dimension a(3),b(3),c(3)
      c(1)=a(2)*b(3)-a(3)*b(2)
      c(2)=a(3)*b(1)-a(1)*b(3)
      c(3)=a(1)*b(2)-a(2)*b(1)
      return
      end

      function sp(a,b)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      dimension a(3),b(3)
      sp=a(1)*b(1)+a(2)*b(2)+a(3)*b(3)
      return
      end

      subroutine norm(a)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      dimension a(3)
      a2=sp(a,a)
      if(abs(a2).lt.1.0d-30)return
      anorm=1.0d0/sqrt(a2)
      do 1 i=1,3
1     a(i)=a(i)*anorm
      return
      end
c     =====================================
      SUBROUTINE WRITETTTV(M3,NAT,ALPHA,A,G,ALPHAV)
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      DIMENSION ALPHA(M3,3,3),G(M3,3,3),A(M3,3,3,3),
     1ALPHAV(M3,3,3)
      WRITE(2,2000)NAT
2000  FORMAT(' ROA tensors, cartesian derivatives',/,I4,' atoms',/,
     1' The electric-dipolar electric-dipolar polarizability:',/,
     2' Atom/x    jx           jy           jz')
      DO 1 I=1,3
      WRITE(2,2002)I
2002  FORMAT(' Alpha(',I1,',J):')
      DO 1 L=1,NAT
      DO 1 IX=1,3
      IIND=3*(L-1)+IX
1     WRITE(2,2001)L,IX,(ALPHA(IIND,I,J),J=1,3)
2001  FORMAT(I5,I2,3F16.7)
      WRITE(2,2004)
2004  FORMAT(' The electric dipole magnetic dipole polarizability:',/,
     1       ' Atom/x    jx(Bx)       jy(By)       jz(Bz)')
      DO 2 I=1,3
      WRITE(2,2003)I
2003  FORMAT(' G(',I1,',J):')
      DO 2 L=1,NAT
      DO 2 IX=1,3
      IIND=3*(L-1)+IX
2     WRITE(2,2001)L,IX,(G(IIND,I,J),J=1,3)
      WRITE(2,2005)
2005  FORMAT(' The electric dipole electric quadrupole polarizability:',
     2/,     ' Atom/x    kx           ky           kz')
      DO 3 I=1,3
      DO 3 J=1,3
      WRITE(2,2006)I,J
2006  FORMAT(' A(',I1,',',I1,',K):')
      DO 3 L=1,NAT
      DO 3 IX=1,3
      IIND=3*(L-1)+IX
3     WRITE(2,2001)L,IX,(A(IIND,I,J,K),K=1,3)
      WRITE(2,2007)
2007  FORMAT(' Velocity form of alpha:',/,
     1       ' Atom/x    jx           jy           jz')
      DO 4 I=1,3
      WRITE(2,2008)I
2008  FORMAT(' AlphaV(',I1,',J):')
      DO 4 L=1,NAT
      DO 4 IX=1,3
      IIND=3*(L-1)+IX
4     WRITE(2,2001)L,IX,(ALPHAV(IIND,I,J),J=1,3)
      RETURN
      END
